
(PRELOAD DIAINP DYTSYM)

(TITLE "
FRIEDC.TST
Robertson-Walker or Friedman solution for closed dustlike universe.
Landau-Lifshitz (112.4), (112.9), (112.10)
Hawking-Ellis ch. 5.3
Exact Solutions (12.3a)
Petrov type 0
Test of dyad transformations allowed under standard form for
perfect fluids")

(OFF ALL) (ON NOZERO SUBPOT COMPLX)

(NAMLC N A)
(DEFNAM TT (LC t))
(DEFNAM A0 (LC a DOWN 0 UP))

(REAL N X H P A0 A TT B D)

(VARS N X H P)  % (eta,xi,theta,phi)

(RPL A TT)
A0*(1-COS N) $
A0*(N-SIN N) $

(FUNS (A0) A TT)

(NEWSUL 3 RIESUL)
COS X ^2 $  1 -SIN X ^2 $
SIN N ^2 $  1 -COS N ^2 $
COS N $  1 -A/A0 $
(USESUL RIESUL RIEF D2PHI D2LAMBDA JC2)

(RPL GD)
A $  A $  A*SIN X $  A*SIN X*SIN H $

% Maximal dyad transformation as an extra dyad transformation used for
% PHITR, PSITR etc.
(FUNS (B) (D))

(NEWSUL COSH2SUL)
SINH B ^2 $  -1 +COSH B ^2 $
(USESUL COSH2SUL DYTRXDET DYTRXP2 DYTRXP3 DYTRXP4
 PHITR DLAMBDATR DPHITR D2LAMBDATR D2PHITR APHITR)

(RPL DYTRX1)
1/COSH(B)               $  -SINH(B)/COSH(B)*E^(-I*D) $
SINH(B)/COSH(B)*E^(I*D) $  1/COSH(B)                 $
