%### IRCREF.SL

(NOTLOADTIME
 (DS PUSH (X Y) (SETQ Y (CONS X Y)))
%(DEFLIST '((ANLFN PROCSTAT) (CRFLAPO PROCSTAT)) 'STAT)
 (FLAG '(ANLFN CRFLAPO) 'COMPILE) )

(GLOBAL
 '(UNDEFG!* GSEEN!* BTIME!* FLGLOB!* GLFLU!* FLSEEN!* EXPAND!*
   TAGSEEN!* !*NOEXTRA HAVEARGS!* !*NOTUSE NOLIST!* EXNOLIST!*
   REDEF!* KNLIST!* DCLFLU!* EXDCLFLU!* ENTPTS!* UNDEFNS!* SEEN!*
   TSEEN!* CRFNTYPES!* OP!*!*  BCRFFIL!* PFILES!* CURLIN!*
   PRETITL!* !*CREFTIME !*STRICTCOND FNARFIL!* TFSEEN!* NOTCAUGHT!*
   NOTHROWN!* !*USEFN NOTUSE!* RECFUNS!* CNSTBS!* CNSTSEEN!*
   !*FILEPROPS CURFIL!* !*INDEX !*RCALL !*FORCE !*LOSE !*NOVARFN
   USESTD!* PROPSEEN!* FLAGSEEN!* IDSEEN!* !*IDPROPS !*PROPS
   MPROPS!* !*APPLYLOCAL !*PREDECLS !*FNARGNOLIST !*SAVEPROPS
   MAXARG!* !*CREFSUMMARY !*RLISP USEKNW!* !*LISTALL LOCFN!*
   UNDCENT!* UNUSLOC!* LOCNONLOC!* POSLOC!* NOTUSESTD!*
   FILESORDR!* FUNSDEFS!* FUNSORDR!* DCENT!* !*EXPERT   %LH
   POSMRG!* PUTCL!* !*MODE !*GLOBALS !*ALGEBRAICS !*CHKONLY) )

%Switches: *NOEXTRA *CREFTIME *STRICTCOND *FILEPROPS *INDEX
%          *FNARGNOLIST *FORCE *LOSE *SAVEPROPS *CREFSUMMARY
%          *GLOBALS *IDPROPS *PROPS *RCALL *NOVARFN *APPLYLOCAL
%          *LISTALL *CHKONLY
(FLUID '(GLOBS!* CALLS!* LOCLS!* SLOCLS!*
         TOPLV!* CURFUN!* CURFILE!* TAGS!* PROPS!* FLAGS!*
         CLOC!* DFPRINT!* !*CREF !*DEFN DSARGS!* FIL!*
         !*GC !*MSG !*INPROG GOLIST!* NOGOLIST!* RCALLED!* RCALL!*))

(SETQ PUTCL!* '(!.))

(SETQ !*NOVARFN T)

(SETQ !*LOSE T)

(SETQ !*INDEX T)

(SETQ !*ALGEBRAICS T)

(SETQ !*PREDECLS T)

(SETQ !*GLOBALS T)

(SETQ !*PROPS T)

(SETQ !*RLISP NIL)

(SETQ !*SAVEPROPS NIL)

(SETQ MAXARG!* 15)

(SETQ EXPAND!* NIL)                     % Franz

%LH (Non)Expert? Verbose/Short
(DE CEXPERT (V S) (COND (!*EXPERT S) (T V) ))

(DE SETSTDFN (X) (SETQ NOLIST!* (UNION (DEFLIST X 'KNWTYP) NOLIST!*)))

(DE SETEXFN (X)
 (SETQ EXNOLIST!* (UNION (DEFLIST X 'KNWTYP) EXNOLIST!*)) )

(DFEXPR KNOWNFUNCTIONS (!&REST L) (SETQ KNLIST!* (FOREACH X IN L COLLECT
   (PUT (CAR X) 'ARGCOUNT (CADDR X))
   (LIST (CAR X) (CADR X)) )))

(DE PUTL (L Y Z) (FOREACH X IN L DO (PUT X Y Z)))

(DFEXPR KNOWNGLOBALS (!&REST L) (PUTL L 'GLBTYP 'GLOBAL))

(DFEXPR KNOWNCONSTANTS (!&REST L) (PUTL L 'GLBTYP 'CONSTANT))

(DFEXPR KNOWNFLUIDS (!&REST L) (PUTL L 'GLBTYP 'FLUID))

(DFEXPR KNOWNPROPS (!&REST L) (FLAG L 'KNWPROP))

(DFEXPR KNOWNFLAGS (!&REST L) (FLAG L 'KNWFLAG))

(DFEXPR KNOWNTAGS (!&REST L) (FLAG L 'KNWTAG))

(FLAG '(KNOWNFUNCTIONS KNOWNGLOBALS KNOWNCONSTANTS KNOWNFLUIDS
        KNOWNPROPS KNOWNFLAGS KNOWNTAGS)
      'NOANL)

(KNOWNFUNCTIONS
   (ABS EXPR 1) (ADD1 EXPR 1) (APPEND EXPR 2) (APPLY EXPR 2)
   (ASSOC EXPR 2) (ATOM EXPR 1)
   (CAR EXPR 1) (CDR EXPR 1)
   (CAAR EXPR 1) (CADR EXPR 1) (CDAR EXPR 1) (CDDR EXPR 1)
   (CAAAR EXPR 1) (CAADR EXPR 1) (CADAR EXPR 1) (CADDR EXPR 1)
   (CDAAR EXPR 1) (CDADR EXPR 1) (CDDAR EXPR 1) (CDDDR EXPR 1) 
   (CAAAAR EXPR 1) (CAAADR EXPR 1) (CAADAR EXPR 1) (CAADDR EXPR 1)
   (CADAAR EXPR 1) (CADADR EXPR 1) (CADDAR EXPR 1) (CADDDR EXPR 1)
   (CDAAAR EXPR 1) (CDAADR EXPR 1) (CDADAR EXPR 1) (CDADDR EXPR 1)
   (CDDAAR EXPR 1) (CDDADR EXPR 1) (CDDDAR EXPR 1) (CDDDDR EXPR 1)
   (CLOSE EXPR 1) (CODEP EXPR 1) (COMPRESS EXPR 1) (CONS EXPR 2)
   (CONSTANTP EXPR 1)
   (DEFLIST EXPR 2) (DELETE EXPR 2) (DIFFERENCE EXPR 2)
   (DIGIT EXPR 1) (DIVIDE EXPR 2)
   (EJECT EXPR 0) (EQ EXPR 2) (EQN EXPR 2)
   (EQUAL EXPR 2) (ERROR EXPR 2) (ERRORSET EXPR 3) (EVAL EXPR 1)
   (EVLIS EXPR 1) (EXPAND EXPR 2) (EXPLODE EXPR 1) (EXPT EXPR 2)
   (FIX EXPR 1) (FIXP EXPR 1) (FLAG EXPR 2) (FLAGP EXPR 2)
   (FLOAT EXPR 1) (FLOATP EXPR 1) (FLUID EXPR 1) (FLUIDP EXPR 1)
   (FUNCTION EXPR 1) (GENSYM EXPR 0)
   (GET EXPR 2) (GETD EXPR 1) (GETV EXPR 2) (GLOBAL EXPR 1)
   (GLOBALP EXPR 1) (GO EXPR 1) (GREATERP EXPR 2)
   (IDP EXPR 1) (INTERN EXPR 1)
   (LENGTH EXPR 1)
   (LESSP EXPR 2) (LINELENGTH EXPR 1) (LITER EXPR 1) (LPOSN EXPR 0)
   (MAP EXPR 2) (MAPC EXPR 2) (MAPCAN EXPR 2) (MAPCAR EXPR 2)
   (MAPCON EXPR 2) (MAPLIST EXPR 2) (MAX2 EXPR 2) (MEMBER EXPR 2)
   (MEMQ EXPR 2) (MINUS EXPR 1) (MINUSP EXPR 1) (MIN2 EXPR 2)
   (MKVECT EXPR 1) (NCONC EXPR 2) (NOT EXPR 1) (NULL EXPR 1)
   (NUMBERP EXPR 1)
   (ONEP EXPR 1) (OPEN EXPR 2)
   (PAGELENGTH EXPR 1) (PAIR EXPR 2) (PAIRP EXPR 1) (PLUS2 EXPR 2)
   (POSN EXPR 0) (PRINC EXPR 1) (PRINT EXPR 1) (PRIN1 EXPR 1)
   (PRIN1D EXPR 1) (PRIN2 EXPR 1) (PRIN2D EXPR 1) (PUT EXPR 3)
   (PUTD EXPR 3) (PUTV EXPR 3) (QUOTE EXPR 1) (QUOTIENT EXPR 2)
   (RDS EXPR 1) (READ EXPR 0) (READCH EXPR 0) (REMAINDER EXPR 2)
   (REMD EXPR 1) (REMFLAG EXPR 2) (REMOB EXPR 1) (REMPROP EXPR 2)
   (RETURN EXPR 1) (REVERSE EXPR 1) (RPLACA EXPR 2) (RPLACD EXPR 2)
   (SASSOC EXPR 3) (SET EXPR 2) (SETQ EXPR 2) (STRINGP EXPR 1)
   (SUBLIS EXPR 2) (SUBST EXPR 3) (SUB1 EXPR 1)
   (TERPRI EXPR 0) (TIMES2 EXPR 2)
   (UNFLUID EXPR 1) (UPBV EXPR 1)
   (VECTORP EXPR 1)
   (WRS EXPR 1)
   (ZEROP EXPR 1)
   (DE FEXPR (3)) (DF FEXPR (3)) (DM FEXPR (3)) (DMM FEXPR (3))
   (PLUS MACRO (2)) (TIMES MACRO (2)) (AND FEXPR (2)) (OR FEXPR (2))
   (PROGN FEXPR (2))
   (MAX MACRO (2)) (MIN MACRO (2)) (COND FEXPR (1))
   (PROG FEXPR (2)) (LIST FEXPR (1)) ) % Franz

(SETSTDFN KNLIST!*)

(KNOWNCONSTANTS !$EOL!$ !$EOF!$ T NIL)

(KNOWNGLOBALS EMSG!*)

(KNOWNFLUIDS !*COMP !*RAISE)

(DE CREFOUT (FL) (CREFOUTF (COND (FL (CAR FL)))))

(DE CREFOUTF (FIL!*)
 (PROG (A)
  (TERPRI)
  (COND
   ((GETD 'BEGIN)
    (PRIN2 "CREFOUT: IN files; or type in expressions")
    (TERPRI)
    (PRIN2 "When all done, execute CREFEND; ") )
   (T (PRIN2 "CREFOUT: (DSKIN files) or type in expressions")
      (TERPRI)
      (PRIN2 "When all done, execute (CREFEND) ") ) )
  (TERPRI)
  (COND (FIL!*
         (SETQ FIL!* (OPEN
           (SETCASE (COND
            ((NULL (CDDR (SETQ A (FILNAM FIL!*))))
             (CONCATID FIL!* '!.CRF) )
            (T FIL!*) ))
           'OUTPUT )) ))                        % Franz
  (COND (!*FNARGNOLIST (SETQ FNARFIL!*
          (COND
           (A (OPEN (SETCASE (CONCATID (CADR A) '!.FNS)) 'OUTPUT)) ) )))
  (SETQ !*CREF T)
  (SETQ BCRFFIL!* (LIST (WRS FIL!*)))
  (CREFON) ))

(PUT 'CREFOUT 'STAT 'IOSTAT)

(DFEXPR !%CREFOUT (!&REST FIL)
 (CREFOUTF
  (COND
    (FIL (CAR FIL)))))

(COND ((NOT (GETD 'BEGIN))
       (FLAG '(RDS DEFLIST FLAG FLUID GLOBAL REMPROP REMFLAG UNFLUID)
             'EVAL )
       (PROG (!*MSG) (MOVD 'CREFOUT '!%CREFOUT))
       (FLAG '(CREFOFF DSKIN READIN) 'IGNORE) ))

(FLAG '(CREFEND) 'IGNORE)

(PUT 'CREFEND 'STAT 'ENDSTAT)

(DE CREFON NIL
 (COND (!*CREFTIME (SETQ BTIME!* (CLOCK))))
 (SETQ DFPRINT!* 'REFPRINT)
 (SETQ !*DEFN T)
 (COND ((NOT !*ALGEBRAICS) (PUT 'ALGEBRAIC 'NEWNAM 'SYMBOLIC)))
 (COND ((NOT !*LISTALL)
        (FOREACH X IN
         (COND
          (!*NOEXTRA (APPEND NOLIST!* EXNOLIST!*))
          (T NOLIST!*))
         DO (COND ((NOT (FLAGP X 'DOLIST)) (FLAG1 X 'NOLIST))) ) ))
 (FLAG EXPAND!* 'ANLEXPAND)
 (COND
  (!*IFPEXPAND (FLAG '(IFP) 'DFEXPAND))
  (T (REMFLAG '(IFP) 'DFEXPAND)) )
 (COND (!*NOFPAG (SETQ !*FORMFEED NIL)))
 (COND (!*CHKONLY (SETQ !*CREFSUMMARY T)
        (SETQ !*IDPROPS (SETQ !*PROPS (SETQ !*RCALL
           (SETQ !*INDEX (SETQ !*FILEPROPS
             (SETQ !*FNARGNOLIST NIL) )) ))) ))
 (SETQ !*GC NIL)
 (SETQ REDEF!* NIL)
 (SETQ CNSTBS!* NIL)
 (SETQ CNSTSEEN!* NIL)
 (SETQ NOTUSE!* NIL)
 (SETQ NOTUSESTD!* NIL)
 (SETQ USESTD!* NIL)
 (SETQ USEKNW!* NIL)
 (SETQ ENTPTS!* NIL)
 (SETQ DCENT!* NIL)
 (SETQ UNDEFNS!* NIL)
 (SETQ SEEN!* NIL)
 (SETQ CRFNTYPES!* NIL)
 (SETQ LOCFN!* NIL)
 (SETQ UNDCENT!* NIL)
 (SETQ UNUSLOC!* NIL)
 (SETQ LOCNONLOC!* NIL)
 (SETQ POSLOC!* NIL)
 (SETQ POSMRG!* NIL)
 (SETQ TSEEN!* NIL)
 (SETQ TFSEEN!* NIL)
 (SETQ RECFUNS!* NIL)
 (SETQ IDSEEN!* NIL)
 (SETQ MPROPS!* NIL)
 (SETQ PROPSEEN!* NIL)
 (SETQ FLAGSEEN!* NIL)
 (SETQ TAGSEEN!* NIL)
 (SETQ GSEEN!* NIL)
 (SETQ FILESORDR!* NIL)
 (SETQ FUNSORDR!* NIL)
 (SETQ FUNSDEFS!* NIL)
 (SETQ PFILES!* NIL)
 (SETQ UNDEFG!* NIL)
 (SETQ FLSEEN!* NIL)
 (SETQ GLFLU!* NIL)
 (SETQ FLGLOB!* NIL)
 (SETQ CURLIN!* NIL)
 (SETQ PRETITL!* NIL)
 (SETQ GLOBS!* NIL)
 (SETQ CALLS!* NIL)
 (SETQ TAGS!* NIL)
 (SETQ LOCLS!* NIL)
 (SETQ SLOCLS!* NIL)
 (SETQ TOPLV!* T)
 (SETQ CURFUN!* NIL)
 (SETQ OP!*!* NIL)
 (SETPAGE "  Errors or questionables" NIL) )

(DE PRINCNG (U) (PRINCN (GETES U)))

(DE CREFEND NIL
 (CREFOFF)
 (SETQ !*CREF NIL)
 (COND (!*FNARGNOLIST (CLOSE FNARFIL!*)))
 (COND ((AND BCRFFIL!* (SETQ BCRFFIL!* (WRS (CAR BCRFFIL!*))))
        (CLOSE BCRFFIL!*) (SETQ BCRFFIL!* NIL) )) )     % Franz

(DE CREFOFF NIL
 (PROG (TIM)
  (SETQ DFPRINT!* NIL)
  (SETQ !*DEFN NIL)
  (COND ((NOT !*ALGEBRAICS) (REMPROP 'ALGEBRAIC 'NEWNAM)))
  (COND (!*CREFTIME (SETQ TIM (DIFFERENCE (CLOCK) BTIME!*))))
  (COND ((NOT !*CHKONLY) (SETUPLISTS) (PRINTSUMMARY)))
  (COND ((NOT !*CREFSUMMARY) (PRINTUSAGE)))
  (COND (!*INDEX (PRINCREFINDEX)))
  (COND (!*FILEPROPS (FOREACH Z IN PFILES!* DO (PRINFILEPROP Z))))
  (COND (!*FNARGNOLIST (PRINARGNOLIST)))
  (COND ((NOT !*SAVEPROPS) (REMCREFPROPS)))
  (COND (!*CREFTIME (PRINCREFTIME TIM))) ) )

(DE SETUPLISTS ()
 (PROG (X)
  (FOREACH FN IN (SETQ SEEN!* (SORT SEEN!*)) DO (LOOKATFN FN))
  (SETQ TSEEN!* (FOREACH Z IN (SORT TSEEN!*) COLLECT
    (REMPROP Z 'TSEEN)
    (FOREACH FN IN (SETQ X (SORT (GET Z 'FUNS))) DO
     (COND ((NOT (GET FN 'GALL)) (PUSH FN UNDEFNS!*)))
     (PUT FN 'ORCCNAM (REMPROP FN 'RCCNAM))
     (PUT FN 'RCCNAM (GET FN 'RELNAM)) )
    (CONS Z X) ))
  (SETQ USESTD!* (FOREACH FN IN (SETQ NOLIST!* (SORT NOLIST!*)) CONC
   (COND
    ((FLAGP FN 'USED) (LIST FN))
    (!*USEFN (PUSH FN NOTUSESTD!*) NIL) )))
  (SETQ USEKNW!* (FOREACH FN IN (SETQ EXNOLIST!* (SORT EXNOLIST!*)) CONC
   (COND
    ((FLAGP FN 'USED) (LIST FN))
    (!*USEFN (PUSH FN NOTUSE!*) NIL) )))
  (FOREACH Z IN (SETQ TAGSEEN!* (SORT TAGSEEN!*)) DO
   (COND
    ((NOT (GET Z 'THROWNTO)) (PUSH Z NOTHROWN!*))
    ((NOT (GET Z 'CAUGHTBY)) (PUSH Z NOTCAUGHT!*)) ))
  (SETQ GSEEN!* (FOREACH Z IN (SORT GSEEN!*) CONC (LOOKATGLOB Z)))
  (SETQ PFILES!* (FOREACH Z IN PFILES!* COLLECT (CDR Z)))
  (SETQ FILESORDR!* (REVERSE PFILES!*))
  (SETQ FUNSORDR!* (FOREACH Z IN FILESORDR!* COLLECT 
    (COND ((SETQ Z (GET (GET Z 'FILEPROPS) 'FUNCTIONS))
           (RPLACD Z (REVERSIP (CDR Z))) )) ))
  (SETQ FUNSDEFS!*
   (FOREACH Z IN FUNSORDR!* CONC (COND (Z (APPEND Z NIL)))) )
  (SETQ MPROPS!*
   (FOREACH Z IN IDSEEN!* CONC (COND ((CHKMPROP Z) (LIST Z)))) )
  (COND (!*RCALL (SETUPALLCALL))) ))

(DE SETUPALLCALL () (PROG (X A)
  (FOREACH W IN (SETQ A (CONS (CONS NIL SEEN!*) TSEEN!*)) DO
   (FOREACH FN IN (CDR W) DO (FOREACH Z IN (GETRCALL FN) DO
     (COND ((EQ FN Z) (PUSH FN RECFUNS!*)))
     (TRAPUT Z 'RCALLEDBY FN) )) )
  (FOREACH Z IN A DO (FOREACH FN IN (CDR Z) DO
    (COND
     ((SETQ X (GET FN 'RCALLEDBY))
      (PUT FN 'RCALLEDBY (SORT X)) ) ) )) ))

(DE LOOKATGLOB (Z) (PROG (X)
  (COND ((GET Z 'USEDUNBY) (PUSH Z UNDEFG!*)))
  (RETURN
   (COND
    ((EQ (SETQ X (GET Z 'GLBTYP)) 'GLOBAL)
     (COND ((GET Z 'BOUNDBY) (PUSH Z FLGLOB!*))) (LIST Z) )
    ((EQ X 'CONSTANT)
     (COND ((OR (GET Z 'BOUNDBY) (GET Z 'SETBY)) (PUSH Z CNSTBS!*)))
     (PUSH Z CNSTSEEN!*)
     NIL )
    (T (COND ((NOT (GET Z 'BOUNDBY)) (PUSH Z GLFLU!*)))
       (PUSH Z FLSEEN!*)
       NIL ) )) ))

(DE CHKMPROP (Z) (PROG (SW)
  (COND ((FLAGP Z 'NOTWO) (RETURN NIL)))
  (SETQ SW (OR (FLAGP Z 'SEEN) (GET Z 'KNWTYP)))
  (COND ((OR (FLAGP Z 'GSEEN) (GET Z 'GLBTYP))
         (COND (SW (RETURN T))) (SETQ SW T)) )
  (COND ((AND Z (OR (FLAGP Z 'TAGSEEN) (FLAGP Z 'KNWTAG)))
         (COND (SW (RETURN T))) (SETQ SW T)) )
  (COND ((OR (FLAGP Z 'PROPSEEN) (FLAGP Z 'KNWPROP))
         (COND (SW (RETURN T))) (SETQ SW T)) )
  (RETURN (AND SW (OR (FLAGP Z 'FLAGSEEN) (FLAGP Z 'KNWFLAG)))) ))

(DE LOOKATFN (FN) (PROG (X A B C D)
  (COND
   ((SETQ B (GET FN 'GALL))
    (COND
     ((NOT (MEMQ (SETQ X (CDR B)) CRFNTYPES!*)) (PUSH X CRFNTYPES!*)) )
    (PUT X 'CRFNTYP (CONS FN (GET X 'CRFNTYP))) NIL)
   ((NOT (GET FN 'KNWTYP)) (PUSH FN UNDEFNS!*)) )
  (COND ((SETQ A (GET FN 'ENTLOC))
         (COND
          ((EQ A 'LOCALFUNCTION) (PUSH FN LOCFN!*))
          (T (PUSH FN DCENT!*)) )))
  (COND
   ((OR (NULL (SETQ D (SETQ X (GET FN 'CALLEDBY))))
     (AND (EQ FN (CAR X)) (NULL (CDR X))) )
    (PUSH FN ENTPTS!*)
    (COND
     ((EQ A 'LOCALFUNCTION) (PUSH FN UNUSLOC!*))
     ((NOT (EQ A 'ENTRYPOINT)) (PUSH FN UNDCENT!*)) ) )
   ((AND B (CAR B) (SETQ B (COND ((EQ (CDR B) 'EXPR) (CAAR B)))))
    (WHILE X (COND
      ((AND (SETQ C (GET (CAR X) 'GALL)) (CAR C) (EQ B (CAAR C)))
       (SETQ X (CDR X)) )
      (T (SETQ X (SETQ B NIL))) ))
    (COND
     (B (PUSH FN POSLOC!*)
        (COND ((OR (NULL (CDR D)) (AND (NULL (CDDR D)) (MEMQ FN D)))
               (PUSH FN POSMRG!*) )) )
     ((EQ A 'LOCALFUNCTION) (PUSH FN LOCNONLOC!*)) ) ) ) ))

(DE PRINTSUMMARY () (PROG (X)
  (SETPAGE "  Summary" NIL) (NEWPAGE)
  (PUNUSED "Cross reference listing for files:" PFILES!*)
  (PUNUSED "Files in order of loading:" FILESORDR!*)
  (SETQ DCENT!* (PUNUSEDR "Declared entry points:" DCENT!*))
  (SETQ USESTD!* (PUNUSED "Used standard functions:" USESTD!*))
  (SETQ USEKNW!* (PUNUSED "Other known functions:" USEKNW!*))
  (SETQ UNDEFNS!* (PUNUSEDR "Unknown undefined functions:" UNDEFNS!*))
  (SETQ ENTPTS!*
   (PUNUSEDR "Entry points (not called functions):" ENTPTS!*) )
  (SETQ UNDCENT!* (PUNUSEDR "Undeclared entry points:" UNDCENT!*))
  (SETQ LOCFN!* (PUNUSEDR "Declared local functions:" LOCFN!*))
  (SETQ LOCNONLOC!*
   (PUNUSEDR "Declared local functions used non-locally:" LOCNONLOC!*) )
  (SETQ UNUSLOC!*
   (PUNUSEDR "Not used declared local functions:" UNUSLOC!*) )
  (SETQ POSLOC!*
   (PUNUSEDR "Local or possibly local functions:" POSLOC!*) )
  (SETQ POSMRG!*
   (PUNUSEDR "Possibly local functions only called once:" POSMRG!*) )
  (FOREACH Z IN (SETQ CRFNTYPES!* (SORT CRFNTYPES!*)) DO
   (PUT Z 'CRFNTYP (SETQ X (REVERSIP (GET Z 'CRFNTYP))))
   (COND
    ((NOT (EQ Z 'EXPR))
     (PUNUSED (LIST "Called " Z "s:")
      (FOREACH FN IN X CONC (COND ((GET FN 'CALLEDBY) (LIST FN)))) ))) )
  (SETQ RECFUNS!* (PUNUSEDR "Recursive functions:" RECFUNS!*))
  (SETQ REDEF!* (PUNUSEDS "Redefined functions:" REDEF!*))
  (SETQ NOTCAUGHT!* (PUNUSEDR "Tags with no CATCH:" NOTCAUGHT!*))
  (SETQ NOTHROWN!* (PUNUSEDR "Tags with no THROW:" NOTHROWN!*))
  (SETQ MPROPS!* (PUNUSEDS
"More than one of: Function, Non-local variable, Tag, Property, Flag:"
    MPROPS!*))
  (SETQ UNDEFG!* (PUNUSEDR "Undeclared Non-local Variables:" UNDEFG!*))
  (SETQ CNSTBS!* (PUNUSEDR "Bound or Set Constants:" CNSTBS!*))
  (SETQ FLGLOB!* (PUNUSEDR "Bound GLOBAL Variables:" FLGLOB!*))
  (SETQ GLFLU!* (PUNUSEDR "Not Bound FLUID Variables:" GLFLU!*))
  (SETQ NOTUSESTD!*
   (PUNUSEDR "Not Used Standard Functions:" NOTUSESTD!*) )
  (SETQ NOTUSE!* (PUNUSEDR "Not Used Other Known Functions:" NOTUSE!*))
  (SETQ TAGSEEN!* (PUNUSEDS "Catch and Throw Tags:" TAGSEEN!*))
  (SETQ PROPSEEN!* (PUNUSEDS "Properties:" PROPSEEN!*))
  (SETQ FLAGSEEN!* (PUNUSEDS "Flags:" FLAGSEEN!*))
  (SETQ CNSTSEEN!* (PUNUSEDR "Constants:" CNSTSEEN!*))
  (PUNUSED "GLOBAL variables:" GSEEN!*)
  (SETQ FLSEEN!* (PUNUSEDR "FLUID variables:" FLSEEN!*))
  (FOREACH Z IN CRFNTYPES!* DO
   (PUT Z 'CRFNTYP (PUNUSED (LIST Z " functions:") (GET Z 'CRFNTYP))) )
  (NEWLINE 2) (PRTLST "Functions in order of definition:")
  (NEWLINE 0) (FOREACH Z IN FUNSORDR!* DO (COND (Z (LSPRINT Z 8))))
  (NEWLINE 0)
  (PUNUSEDS "Defined functions:" FUNSDEFS!*)
  (PUNUSED "Functions:" SEEN!*)
  (FOREACH Z IN TSEEN!* DO
   (RPLACD Z (PUNUSEDS (LIST (CAR Z) " procedures:") (CDR Z)))
   (FOREACH FN IN (CDR Z) DO (PUT FN 'RCCNAM (GET FN 'ORCCNAM))) ) ))

(DE PRINFILEPROP (Z) (PROG (X A B C)
  (SETPAGE (GET Z 'FLNAM) NIL) (NEWPAGE)
  (SETQ A (GET Z 'FILEPROPS))
  (SETQ B (SORT (GET A 'CALLS)))
  (FOREACH TYP IN CRFNTYPES!* DO
   (SETQ C (GET TYP 'CRFNTYP))
   (PUNUSED (LIST TYP " Call:")
    (FOREACH FN IN B CONC (COND ((MEMQ FN C) (LIST FN)))) ) )
  (PUNUSED "All Calls:" B)
  (SETQ B (PUNUSED "External Calls:" (FOREACH FN IN B CONC
     (COND ((NOT (AND (SETQ X (GET FN 'GALL)) (EQCAR (CAR X) Z)))
            (LIST FN) )) )))
  (SETQ C NIL)
  (FOREACH FN IN B DO
   (COND ((AND (SETQ X (GET FN 'GALL)) (NOT (MEMQ (SETQ X (CAAR X)) C)))
          (PUSH X C) )) )
  (PUNUSEDS "External calls to files:" C)
  (SETQ C
   (PUNUSED "Functions in order of definition:" (GET A 'FUNCTIONS)) )
  (SETQ C (PUNUSEDS "Functions:" C))
  (PUNUSED "Local functions:" (FOREACH FN IN C CONC
    (COND ((MEMQ FN POSLOC!*) (LIST FN))) ))
  (PUNUSED "Entry points:" (FOREACH FN IN C CONC
    (SETQ X (GET FN 'CALLEDBY))
    (WHILE
     (AND X (OR (EQ (CAR X) FN) (NOT (MEMQ (CAR X) C))))
     (UNPUSH X) )
    (COND ((NULL X) (LIST FN))) ))
  (PUNUSEDS "Non-Locals:" (GET A 'GLOBS))
  (PUNUSEDS "Tags:" (GET A 'TAGS))
  (PUNUSEDS "Properties:" (GET A 'PROPS))
  (PUNUSEDS "Flags:" (GET A 'FLAGS)) ))

(DE PRINTUSAGE () (PROG (X)
  (CREFG1 CNSTSEEN!* "  CONSTANT Value Usage")
  (CREFG1 GSEEN!* "  GLOBAL Variable Usage")
  (CREFG1 FLSEEN!* "  FLUID Variable Usage")
  (CREFPR TAGSEEN!* "  CATCH and THROW Tag Usage:"
   '((THROWNTO "Thrown in:") (CAUGHTBY "Caught by:")) )
  (CREFPR FLAGSEEN!* "  Flags:"
   '((HASFLAG "Flag on:") (FLAGPBY "FLAGP in:")
     (FLAGBY "FLAGged in:") (REMFLAGBY "REMFLAG in:") ) )
  (CREFPR PROPSEEN!* "  Properties:"
   '((HASPROP "Prop. on:") (GOTBY "GET in:")
     (PUTBY "PUT in:") (REMPROPBY "REMPROP in:") ) )
  (FOREACH Z IN TSEEN!* DO
   (CREF52 (LIST "  " (CAR Z) " procedures") (CDR Z)) )
  (COND (SEEN!* (CREF52 "  Function Usage" SEEN!*)))
  (SETPAGE "  Top level calls:" NIL)
  (FOREACH Z IN PFILES!* DO
   (COND ((OR (GET Z 'CALLS) (GET Z 'GLOBS) (GET Z 'TAGS)
              (GET Z 'PROPS) (GET Z 'FLAGS) )
          (COND ((NULL X) (NEWPAGE) (SETQ X T)))
          (NEWLINE 0) (NEWLINE 0) (PRINCNG Z) (SPACES2 15)
          (UNDERLINE2 (DIFFERENCE (LINELENGTH NIL) 10))
          (CREF51 Z 'CALLS "Calls:")
          (CREF51 Z 'GLOBS "Non-locals:")
          (CREF51 Z 'TAGS "Tags:")
          (CREF51 Z 'PROPS "Properties:")
          (CREF51 Z 'FLAGS "Flags:") )) )
  (COND (!*IDPROPS (PRINIDPROPS))) ))

(DE PRINIDPROPS () (PROG (A)
  (SETPAGE "  IDs:" 1) (NEWPAGE)
  (FOREACH Z IN (SETQ IDSEEN!* (SORT IDSEEN!*)) DO
   (NEWLINE 0) (PRIN1 Z) (SPACES2 15)
   (COND ((FLAGP Z 'SEEN) (COND
           ((SETQ A (GET Z 'GALL))
            (PRIN1 (CDR A)) (PRIN2 " Function  ") )
           ((FLAGP Z 'ISAFEXPR) (PRIN2 "Declared FEXPR  "))
           ((SETQ A (GET Z 'KNWTYP))
            (PRIN2 "Known ") (PRIN1 A) (PRIN2 "  ") )
           (T (PRIN2 "Undefined Function  ")) )))     
   (COND ((FLAGP Z 'GSEEN)
          (COND
           ((EQ (SETQ A (GET Z 'GLBTYP)) 'CONSTANT)
            (PRIN2 "Constant  ") )
           (T (PRIN2 (COND (A A) (T 'Undeclared)))
              (PRIN2 " Variable  ") ) ) ))
   (COND ((FLAGP Z 'PROPSEEN) (PRIN2 "Property indicator  ")))
   (COND ((FLAGP Z 'FLAGSEEN) (PRIN2 "Flag  ")))
   (COND ((FLAGP Z 'TAGSEEN) (PRIN2 "Tag")))
   (CREF51 Z 'IDPROPS "Properties:")
   (CREF51 Z 'IDFLAGS "Flags:") ) ))

(DE PRINARGNOLIST () (PROG (X B)
  (SETQ X (WRS FNARFIL!*))
  (PRIN2 '!() (PRIN2 'KNOWNFUNCTIONS )
  (FOREACH Z IN SEEN!* DO
   (COND ((AND (SETQ B (GET Z 'GALL))
               (NOT (EQ (GET Z 'ENTLOC) 'LOCALFUNCTION)) )
     (COND ((GREATERP (POSN) 50) (TERPRI)))
     (PRIN2 '! )
     (PRIN2 '!() (PRIN1 Z) (PRIN2 '! ) (PRIN1 (CDR B)) (PRIN2 '! )
     (PRIN1 (GET Z 'ARGCOUNT)) (PRIN2 '!)) )))
  (PRIN2 " )") (TERPRI) (TERPRI)
  (PRINARGHLP CNSTSEEN!* 'KNOWNCONSTANTS)
  (PRINARGHLP GSEEN!* 'KNOWNGLOBALS)
  (PRINARGHLP FLSEEN!* 'KNOWNFLUIDS)
  (PRINARGHLP PROPSEEN!* 'KNOWNPROPS)
  (PRINARGHLP FLAGSEEN!* 'KNOWNFLAGS)
  (PRINARGHLP TAGSEEN!* 'KNOWNTAGS)
  (WRS X) ))

(DE PRINARGHLP (L NM)
 (COND (L (PRIN2 "(") (PRINT NM)
          (WHILE L (COND ((GREATERP (POSN) 50) (TERPRI)))
           (COND
            ((NOT (FLAGP (CAR L) 'NOTTWO))
             (PRIN2 " ")
             (PRIN1 (CAR L)) ) )
           (UNPUSH L) )
          (PRIN2 " )") (TERPRI) (TERPRI) )) )

(DE PRINCREFINDEX () (PROG (L SW)
  (SETPAGE
   (COND
    ((CDR PFILES!*) "  Index:")
    (T (LIST "  Index for " (GET (CAR PFILES!*) 'FLNAM) '!:)) )
   1)
  (NEWPAGE)
  (SETQ L SEEN!*)
  (FOREACH Z IN TFSEEN!* DO (COND ((NOT (FLAGP Z 'SEEN)) (PUSH Z L))))
  (FOREACH Z IN (SORT L) DO
   (SETQ SW (PRININDEXLINE Z NIL))
   (COND ((SETQ Z (GET Z 'TYPES)) (SETQ Z (SORT Z))
          (PRININDEXLINE (CAR Z) SW)
          (FOREACH FN IN (CDR Z) DO (PRININDEXLINE FN T)) )) ) ))

(DE PRININDEXLINE (Z SW) (PROG (X)
  (COND ((SETQ X (GET Z 'GALL))
         (NEWLINE 0) (COND ((NOT SW) (PRINCNF Z)))
         (SPACES3 15) (PRIN1 (CDR X))
         (SPACES3 29) (PRARGCNT (GET Z 'ARGCOUNT))
         (COND ((SETQ X (CAR X))
                (COND ((CDR X)
                       (SETQ Z (CDDR X))
                       (SPACES3 (DIFFERENCE 50 (LENGTH (EXPLODE Z))))
                       (PRTNUM Z) (PRTATM '!/ ) (PRTNUM (CADR X)) ))
                (COND ((AND (CDR PFILES!*) (SETQ X (CAR X)))
                       (SPACES3 54) (PRIN2 "in")
                       (SPACES3 (DIFFERENCE 72 (CAR (GET X 'RCCNAM))))
                       (PRINCNG X) )) ))
         T)) ))

(DE PRINCREFTIME (TIM)
  (SETQ BTIME!* (DIFFERENCE (CLOCK) BTIME!*))
  (SETPAGE " Timing Information" NIL) (NEWPAGE)
  (NEWLINE 0) (PRTATM " Total Time=") (PRTNUM BTIME!*) (PRTATM " (ms)")
  (NEWLINE 0) (PRTATM " Analysis Time=") (PRTNUM TIM)
  (NEWLINE 0) (PRTATM " Sorting Time=")
  (PRTNUM (DIFFERENCE BTIME!* TIM))
  (NEWLINE 0) (NEWLINE 0) )


(DE REMCREFPROPS ()
  (REMFLAG NOLIST!* 'USED)
  (REMFLAG EXNOLIST!* 'USED)
  (REMPROPSS SEEN!*
   '(ENTLOC GALL CALLS TAGS GLOBS CALLEDBY ALSOIS SAMEAS PROPS FLAGS) )
  (REMFLAGSS SEEN!* '(USED SEEN CINTHIS ISAFEXPR))
  (REMPROPSS PFILES!* '(FILEPROPS FLNAM))
  (REMPROPSS TAGSEEN!* '(CAUGHTBY THROWNTO))
  (REMFLAGSS TAGSEEN!* '(TAGSEEN TAG TAGC TAGT))
  (REMPROPSS IDSEEN!* '(IDPROPS IDFLAGS))
  (REMFLAG IDSEEN!* 'IDSEEN)
  (REMPROPSS PROPSEEN!* '(GOTBY PUTBY REMPROPBY HASPROP))
  (REMFLAGSS PROPSEEN!* '(PROPSEEN PROP PROPG PROPP PROPR))
  (REMPROPSS FLAGSEEN!* '(FLAGPBY FLAGBY REMFLAGBY HASFLAG))
  (REMFLAGSS FLAGSEEN!* '(FLAGSEEN ISFLAG FLAGG FLAGP FLAGR))
  (REMPROPSS GSEEN!* '(USEDBY USEDUNBY BOUNDBY SETBY SETLIN CRVAL))
  (REMFLAGSS GSEEN!* '(DCLGLB GSEEN GLB2RF GLB2BD GLB2ST))
  (REMPROPSS FLSEEN!* '(USEDBY USEDUNBY BOUNDBY SETBY SETLIN))
  (REMFLAGSS FLSEEN!* '(DCLGLB GSEEN GLB2RF GLB2BD GLB2ST))
  (FOREACH Z IN CRFNTYPES!* DO (REMPROP Z 'CRFNTYP))    % JEA
% (FOREACH Z IN CRFNTYPES!* DO (REMPROP (CAR Z) 'CRFNTYP))
  (FOREACH Z IN TSEEN!* DO (REMPROP (CAR Z) 'FUNS))
  (REMPROPSS TFSEEN!* '(TYPES))
  (REMFLAG TFSEEN!* 'TFSEEN)
  (REMPROPSS HAVEARGS!* '(ARGCOUNT))
  (SETQ HAVEARGS!* NIL) )

(DE PUNUSEDR (X Y) (COND (Y (PUNUSED X (REVERSIP Y)))))

(DE PUNUSEDS (X Y) (COND (Y (PUNUSED X (SORT Y)))))

(DE PUNUSED (X Y) (COND (Y
   (NEWLINE 2) (PRTLST X)
   (NEWLINE 0) (LSPRINT Y 8)
   (NEWLINE 0)
   Y )))

(DE CREFPR (U TITL L) (COND (U
  (SETPAGE TITL 1)
  (NEWPAGE)
  (FOREACH Z IN U DO
   (NEWLINE 0)
   (PRIN1 Z)
   (FOREACH X IN L DO (CREF51 Z (CAR X) (CADR X))) )
  U)))

(DE CREF52 (X Y) (SETPAGE X 1) (NEWPAGE) (FOREACH Z IN Y DO (CREF5 Z)))

(DE PRINCNF (FN)
 (PROG (Y)
  (COND
   ((SETQ Y (GET FN 'RELNAM)) (PRINCN Y))
   (T (PRIN1 FN)) )
  (RETURN FN) ) )

(DE CREF5 (FN) (PROG (X Y)
  (NEWLINE 0)
  (NEWLINE 0)
  (PRINCNF FN)
  (SPACES2 15)
  (SETQ Y (GET FN 'GALL))
  (COND
   (Y (PRIN1 (CDR Y)) (SETQ X (CAR Y)))
   ((FLAGP FN 'ISAFEXPR) (PRIN2 "Declared FEXPR"))
   ((SETQ Y (GET FN 'KNWTYP)) (PRIN2 "Known ") (PRIN1 Y))
   (T (PRIN2 "Undefined")) )
  (SPACES3 27)
  (COND ((SETQ Y (GET FN 'ARGCOUNT)) (PRARGCNT Y) (PRIN2 "  ")))
  (UNDERLINE2 (DIFFERENCE (LINELENGTH NIL) 10))
  (COND (X (NEWLINE 15) (PRTATM 'Line!:) (PRTADR X)))
  (COND
   ((SETQ Y (GET FN 'CALLEDBY))
    (PUT FN 'CALLEDBY (SETQ Y (SORT Y)))
    (COND ((SETQ Y (DELETE FN Y)) (CREF51P Y "Called by:"))) ))
  (CREF51 FN 'CALLS "Calls:")
  (COND ((SETQ Y (COND
           (!*RCALL (GET FN 'RCALLEDBY))
           ((FLAGP FN 'RCLD) (GETRCALLED FN)) ))
         (COND ((SETQ Y (DELETE FN Y)) (CREF51P Y "RCalled by:"))) ))
  (COND ((SETQ Y (COND
           (!*RCALL (GET FN 'RCALL))
           ((FLAGP FN 'RCAL) (GETRCALL FN)) ))
         (CREF51P Y "R Calls:") ))
  (CREF51 FN 'ALSOIS "Is also:")
  (CREF51 FN 'SAMEAS "Same as:")
  (CREF51 FN 'GLOBS "Non-locals:")
  (CREF51 FN 'TAGS "Tags:")
  (CREF51 FN 'PROPS "Properties:")
  (CREF51 FN 'FLAGS "Flags:")
  ))

(DE PRTADR (X)
 (SPACES2 27) (PRTNUM (CDDR X)) (PRTATM '!/ ) (PRTNUM (CADR X))
 (PRTATM " in ") (PRINCNG (CAR X)) )

(DE GETRCALLED (FN) (PROG (RCALLED!*)
  (IGTRCLD FN)
  (REMFLAG SEEN!* 'RCDSEEN)
  (RETURN (COND (RCALLED!* (PUT FN 'RCALLEDBY (SORT RCALLED!*))))) ))

(DE IGTRCLD (FN) (PROG (X) (COND
   ((SETQ X (GET FN 'RCALLEDBY)) (FOREACH Y IN X DO
     (COND
      ((NOT (FLAGP Y 'RCDSEEN))
       (PUSH Y RCALLED!*)
       (FLAG1 Y 'RCDSEEN) ) ) ))
   (T (FOREACH Y IN (GET FN 'CALLEDBY) DO
       (COND
        ((NOT (FLAGP Y 'RCDSEEN))
         (PUSH Y RCALLED!*)
         (FLAG1 Y 'RCDSEEN)
         (IGTRCLD Y) )) )) )))

(DE GETRCALL (FN) (PROG (RCALL!*)
  (IGTRCL FN)
  (REMFLAG SEEN!* 'RCSEEN)
  (RETURN (COND (RCALL!* (PUT FN 'RCALL (SORT RCALL!*))))) ))

(DE IGTRCL (FN) (PROG (X) (COND
   ((SETQ X (GET FN 'RCALL)) (FOREACH Y IN X DO
     (COND
      ((NOT (FLAGP Y 'RCSEEN))
       (PUSH Y RCALL!*)
       (FLAG1 Y 'RCSEEN) )) ))
   (T (FOREACH Y IN (GET FN 'CALLS) DO
       (COND ((NOT (FLAGP Y 'RCSEEN))
              (PUSH Y RCALL!*) (FLAG1 Y 'RCSEEN) (IGTRCL Y) )) )) )))

(DE SPACES4 (N) (PROG (X)
  (SETQ X (DIFFERENCE N (POSN)))
  (COND
   ((MINUSP X) (NEWLINE N))
   ((NOT (ZEROP X)) (SPACES X)) ) ))

(DE SPACES3 (N) (SPACES (MAX 1 (DIFFERENCE N (POSN)))))

(DE PRARGCNT (Y) (COND
  ((NOT (PAIRP Y)) (PRIN2 Y) (PRIN2 " args"))
  ((ZEROP (CAR Y)) (COND
    ((CDR Y) (PRIN2 (CDR Y)) (PRIN2 " args or less"))
    (T (PRIN2 "Nary args")) ))
  ((CDR Y)
   (PRIN2 (CAR Y))
   (PRIN2 " to ")
   (PRIN2 (CDR Y))
   (PRIN2 " args") )
  (T (PRIN2 (CAR Y)) (PRIN2 " args or more")) ))

(DE CREF51 (X Y Z) (PROG (A)
  (COND
   ((SETQ A (GET X Y))
    (PUT X Y (SETQ A (SORT A)))
    (CREF51P A Z) )) ))

(DE CREF51P (X Z) (COND (X (SPACES4 15) (PRTATM Z) (LSPRINT X 27))))

(DE CREFG1 (X Y) (SLET (A) (COND (X
    (SETPAGE Y 1) (NEWPAGE)
    (FOREACH GLB IN X DO
     (NEWLINE 0) (PRIN1 GLB)
     (SPACES2 15) (SETQ !*NOTUSE T)
     (COND ((SETQ Y (GET GLB 'SETLIN))
            (PRIN2 "Value at:") (PRTADR Y) (NEWLINE 15) ))
     (CREF61 GLB 'USEDBY "Non-local:" NIL)
     (CREF61 GLB 'USEDUNBY "Undeclared:" NIL)
     (CREF61 GLB 'BOUNDBY "Bound in:" NIL)
     (COND ((SETQ A (GET GLB 'SETBY)) (PUT GLB 'SETBY (SETQ A (SORT A)))
            (COND ((OR (NULL Y) (SETQ A (DELETE (CAR Y) A)))
                   (CREF61A "Set by:" A) )) ))
     (COND (!*NOTUSE (PRTATM "*** Not Used ***"))) ) ))))

(DE CREF61 (X Y Z A)
 (COND ((SETQ A (GET X Y)) (PUT X Y (SETQ A (SORT A))) (CREF61A Z A))) )

(DE CREF61A (Z A)
 (COND ((NOT !*NOTUSE) (NEWLINE 15)) (T (SETQ !*NOTUSE NIL)))
 (PRTATM Z)
 (LSPRINT A 27) )

(DS ISGLOB (U) (GET U 'GLBTYP))

(DE GLOBDECL (U)
 (OR (FLAGP U 'DCLGLB) (AND !*PREDECLS (GET U 'GLBTYP))) )

(DS CHKID (S)
 (COND ((AND !*IDPROPS (NOT (FLAGP S 'IDSEEN)))
        (FLAG1 S 'IDSEEN) (PUSH S IDSEEN!*) )) )

(DE CHKSEEN (S)
 (COND ((NOT (FLAGP S 'SEEN))
        (CHKID S) (FLAG1 S 'SEEN) (PUSH S SEEN!*) )) )

(DS GLOBREF (U)
 (COND ((NOT (FLAGP U 'GLB2RF))
        (COND
         ((NOT (GLOBDECL U))
          (DOERRMSG T (LIST (CEXPERT "Nonlocal variable " "Nonl v ") U
                            (CEXPERT " is not declared" " undcl") )) ))
        (CHKGSEEN U) (FLAG1 U 'GLB2RF) (PUSH U GLOBS!*) )) )

(DS ANATOM (U)
 (COND ((AND !*GLOBALS U (NOT (EQ U 'T)) (IDP U))
        (COND
         ((NOT (ASSOC U LOCLS!*)) (GLOBREF U))
         (T (FLAG1 U 'USEDVAR)) ))) )

(DE CHKGSEEN (G)
 (COND ((NOT (FLAGP G 'GSEEN))
        (CHKID G) (PUSH G GSEEN!*) (FLAG1 G 'GSEEN) )) )

(DE CHKTAG (X Y)
 (COND ((NOT (FLAGP X 'TAG))
        (COND ((NOT (FLAGP X 'TAGSEEN))
               (CHKID X) (FLAG1 X 'TAGSEEN) (PUSH X TAGSEEN!*) ))
        (FLAG1 X 'TAG) (PUSH X TAGS!*)))
 (FLAG1 X (COND (Y 'TAGC) (T 'TAGT))) )

(DE DO!-GLOBAL (L TYP)
 (COND ((AND (PAIRP (SETQ L (QCRFA L 1))) !*GLOBALS TOPLV!*)
        (FOREACH V IN L DO (IDOGLOB V TYP)) )) )

(DE IDOGLOB (V TYP)
 (PROG (X)
  (CHKGSEEN V)
  (COND
   ((AND (SETQ X (GET V 'GLBTYP)) (NOT (EQ X TYP)))
    (DOERRMSG NIL
     (LIST "Declaration of " V " is changed from " X " to " TYP) ) ) )
  (PUT V 'GLBTYP TYP)
  (FLAG1 V 'DCLGLB) ) )

(DC GLOBAL ANLFN (L) (DO!-GLOBAL L 'GLOBAL))

(DC FLUID ANLFN (L) (DO!-GLOBAL L 'FLUID))

(DC UNFLUID ANLFN (L)
 (PROG (X)
  (COND
   ((AND (PAIRP (SETQ L (QCRFA L 1))) !*GLOBALS TOPLV!*)
    (FOREACH V IN L DO
     (COND
      ((NOT (GLOBDECL V))
       (DOERRMSG NIL
        (LIST V " was not declared non local before UNFLUID") ) )
      ((NOT (EQ (SETQ X (GET V 'GLBTYP)) 'FLUID))
       (DOERRMSG NIL (LIST V " was declared " X " before UNFLUID")) )
      (T (CHKGSEEN V)) )
     (REMPROP V 'GLBTYP) )
    (REMFLAG L 'DCLGLB) ) ) ) )

(DE X!-GLOBAL (L)
 (COND ((NOT !*CREF) (PROGN (FLAG L 'DCLGLB) (FLAG L 'NOFLUID))))
 (I!-GLOBAL L) )

(DE X!-FLUID (L) (COND ((NOT !*CREF) (FLAG L 'DCLGLB))) (I!-FLUID L))

(DE X!-UNFLUID (L)
 (COND ((NOT !*CREF) (REMFLAG L 'DCLGLB)))
 (I!-UNFLUID L) )

(MOVD 'I!-GLOBAL 'GLOBAL)

(MOVD 'I!-FLUID 'FLUID)

(MOVD 'I!-UNFLUID 'UNFLUID)

(PROG (!*MSG)
 (MOVD 'GLOBAL 'X!-GLOBAL)
 (MOVD 'FLUID 'X!-FLUID)
 (MOVD 'UNFLUID 'X!-UNFLUID) )

(DE ADD2LOCS (LL)
 (PROG (OLDLOC S SS)
  (COND
   (!*GLOBALS
    (FOREACH GG IN LL DO
     (SETQ OLDLOC (ASSOC GG LOCLS!*))
     (SETQ S (FLAGP GG 'USEDVAR))
     (COND
      ((NULL OLDLOC) (PUSH (CONS GG (LIST S)) LOCLS!*))
      (T (COND
          ((AND (OR (CDDR OLDLOC) (NOT (SETQ SS (MEMQ GG DSARGS!*))))
                (NOT (FLAGP GG 'NESTEDOK)) )
           (DOERRMSG T (LIST "Variable " GG " nested declaration")) ) )
         (RPLACD OLDLOC (CONS (OR S SS) (CDR OLDLOC))) ) )
     (PUSH GG SLOCLS!*)
     (COND (S (REMFLAG1 GG 'USEDVAR)))
     (COND ((OR (FLAGP GG 'GLB2RF) (COND ((ISGLOB GG) (GLOBREF GG) T)))
            (FLAG1 GG 'GLB2BD) ))
     (COND ((FLAGP GG 'SEEN) (DOERRMSG T
             (LIST "Function " (LIST GG) " used as variable") ))) ) ))))

(DE REMLOCS (LLN) (PROG (OLDLOC) (COND (!*GLOBALS
    (FOREACH LL IN LLN DO
     (SETQ SLOCLS!* (EFFACE1 LL SLOCLS!*))
     (SETQ OLDLOC (ASSOC LL LOCLS!*))
     (COND ((NULL OLDLOC) (COND
             ((GETD 'BEGIN) (REDERR (LIST " Lvar confused" LL)))
             (T (ERROR 0 (LIST " Lvar confused" LL))) )))
     (COND ((NOT (OR (FLAGP LL 'USEDVAR) (FLAGP LL 'GSEEN)
                     (AND (CDDR OLDLOC) (MEMQ LL DSARGS!*))
                     (GLOBDECL LL) (FLAGP LL 'DUMMY) ))
            (DOERRMSG T (LIST "Variable " LL " is not used")) ))
     (COND
      ((CADR OLDLOC) (FLAG1 LL 'USEDVAR))
      (T (REMFLAG1 LL 'USEDVAR)))
     (COND
      ((CDDR OLDLOC) (RPLACD OLDLOC (CDDR OLDLOC)))
      (T (SETQ LOCLS!* (EFFACE1 OLDLOC LOCLS!*))) ) ) ))))

(FLAG '(DUMMY DUMMY1 DUMMY2 DUMMY3 DUMMY4 DUMMY5) 'DUMMY)

(DE ADD2CALLS (FN)
 (FLAG1 FN 'USED)
 (COND ((NOT (OR (FLAGP FN 'NOLIST) (FLAGP FN 'CINTHIS)))
        (CHKSEEN FN) (PUSH FN CALLS!*) (FLAG1 FN 'CINTHIS) )) )

(DE ANFORM (U) (COND ((ATOM U) (ANATOM U)) (T (ANFORM1 U))))

(DE ANFORML (L)
 (WHILE (NOT (ATOM L)) (ANFORM (CAR L)) (SETQ L (CDR L)))
 (COND (L (ANATOM L))) )

(DE ANFORM1 (U) (PROG (FN) (COND
   ((EQCAR (SETQ FN (CAR U)) 'LAMBDA)
    (ANFORML (CDR U)) (ANLAMBDA (CDR FN) (CDR U) !*APPLYLOCAL) )
   ((PAIRP FN) (ANFORML U))
   ((NOT (IDP FN)) (DOERRMSG T (LIST FN " is not a function")))
   ((MEMQ FN DSARGS!*) (ANFORML U))
   ((OR (ISGLOB FN) (ASSOC FN LOCLS!*))
    (AND !*NOVARFN                      %LH
         (DOERRMSG T
          (LIST "Variable " FN (CEXPERT " in function position"
                                        " in ftn pos" )) ) )
    (ANFORML U) )
   (T (ANFORM2 FN U)) )))

(DE ANFORM2 (FN U)
 (PROG (X Y)
  (ADD2CALLS FN)
  (CHECKARGCOUNT FN (SETQ Y (CDR U)))
  (COND
   ((SETQ X (GET FN 'ANLFN)) (APPLY X (LIST Y)))
   ((FLAGP FN 'NOANL) NIL)
   ((AND
     (OR (AND !*FORCE (NOT (FLAGP FN 'NOEXPD))) (FLAGP FN 'ANLEXPAND))
     (NOT (EQUAL (SETQ X (MACEXPD1 U)) U)) )
    (ANFORM X) )
   (T (ANFORML Y)) ) ))

(COMMENT
(DE ANEXPD (FN U) (PROG (X) (RETURN (COND
    ((EQCAR (SETQ X (GETD FN)) 'MACRO) (APPLY (CDR X) (LIST U)))
    (T U) ))))
)

(DE ANLAMBDA (U AR SW) (COND
  (SW (PROG (LOCLS!* SLOCLS!*) (IANLAMBDA U AR)))
  (T (IANLAMBDA U AR)) ))

(DE IANLAMBDA (U AR)
 (COND ((NOT (FIXP AR)) (SETQ AR (TLENGTH AR))))
 (COND ((NOT (OR (MINUSP AR) (EQN AR (LENGTH (CAR U)))))
        (DOERRMSG T (CEXPERT "LAMBDA with wrong number of args"
                             "LAMBDA wrong no args")) ))
 (ADD2LOCS (CAR U))
 (ANFORML (CDR U))
 (REMLOCS (CAR U)) )

(DC LAMBDA ANLFN (U) (ANLAMBDA U -1 T) (DOERRMSG T "Strange LAMBDA"))

(DE ANLSETQ (U) (ANLST (CAR U)) (ANFORML (CDR U)))

(DE ANLST (U)
 (COND ((AND !*GLOBALS (NOT (MEMQ U SLOCLS!*)))
        (GLOBREF U) (FLAG1 U 'GLB2ST) )) )

(DEFLIST '((SETQ ANLSETQ)) 'ANLFN)

(DC COND ANLFN (U) (FOREACH X IN U DO (ANFORMCOND1 X)))

% Complaint if COND is used with singe bucket added by JEA.
(DE ANFORMCOND1 (X)
 (PROGN
  (ANFORMNPRG (CAR X))
  (COND
   ((CDR X) (ANFORMPROGN (CDR X)))
   (!*STRICTCOND
    (COND ((NOT !*EXPERT) (QERLINE 0)))
    (PRIN2 "**** ")
    (PRIN2 "COND used with singe bucket '") (PRIN1 X) (PRIN2 "'")
    (PRIN2 " in ") (PRINCNG CURFUN!*)
    (NEWLINE 0) ) ) ) )


(DE ANFORMNPRG (X) (PROG (!*INPROG) (ANFORM X)))

(DE ANFORMPROGN (U) (COND
  (!*INPROG (FOREACH X IN U DO (ANFORMPRG X)))
  (T (ANFORML U)) ))

(PUT 'PROGN 'ANLFN 'ANFORMPROGN)

(DC PROG ANLFN (U)
 (PROG (GOLIST!* NOGOLIST!* !*INPROG)
  (SETQ !*INPROG T)
  (ADD2LOCS (CAR U))
  (FOREACH X IN (CDR U) DO (COND ((ATOM X) (COND
      ((MEMQ X GOLIST!*)
       (DOERRMSG T (LIST "PROG label " X " multiply defined")) )
      (T (PUSH X GOLIST!*)) ))))
  (FOREACH X IN (CDR U) DO (COND ((NOT (ATOM X)) (ANFORMPRG X))))
  (FOREACH X IN NOGOLIST!* DO
   (DOERRMSG T (LIST "PROG label " X "is not used")) )
  (REMLOCS (CAR U)) ))

(DE ANFORMPRG (X)
 ((LAMBDA (!*INPROG) (ANFORM X))
  (AND !*INPROG (OR (NOT (PAIRP X)) (FLAGP (CAR X) 'INPROG))) ) )

(DC GO ANLFN (U)
 (COND
  ((NOT !*INPROG) (DOERRMSG T (LIST "GO not inside PROG")))
  ((NOT (MEMQ (SETQ U (CAR U)) GOLIST!*))
   (DOERRMSG T (LIST "Missing GO label" U)) )
  (T (SETQ NOGOLIST!* (EFFACE1 U NOGOLIST!*))) ))

(DC RETURN ANLFN (U)
 (COND ((NOT !*INPROG) (DOERRMSG T (LIST "RETURN not inside PROG"))))
 (ANFORMNPRG (CAR U)) )

(FLAG '(COND PROGN GO RETURN) 'INPROG)

(DC FOREACH ANLFN (U)
 (ANFORM (CADDR U))
 (ADD2LOCS (LIST (CAR U)))
 (ANFORML (CDDDDR U))
 (REMLOCS (LIST (CAR U))) )

(DC FOR ANLFN (U)
 (ANFORML (CADR U))
 (ADD2LOCS (LIST (CAR U)))
 (ANLST (CAR U))
 (COND (!*GLOBALS (FLAG1 (CAR U) 'USEDVAR)))
 (ANFORM (CADDDR U))
 (REMLOCS (LIST (CAR U))) )

(DC FUNCTION ANLFN (U) (ANLAPLCH (CONS 'FUNCTION U) -1 T))

(COMMENT
(DC FUNCTION ANLFN (U) (COND
  ((PAIRP (SETQ U (CAR U))) (ANFORM1 U))
  ((ISGLOB U) (GLOBREF U))
  ((NULL (ASSOC U LOCLS!*)) (ADD2CALLS U)) )) )

(DC QUOTE ANLFN (U)
 (COND ((AND DSARGS!* (MEMQ (CAR U) DSARGS!*)) (ANFORM (CAR U)))) )

%(FLAG '(QUOTE) 'NOANL)

(DE ANLEVAL (U) (PROG (X)
  (ANFORML (CDR U))
  (COND
   ((EQCAR (SETQ U (CAR U)) 'QUOTE) (ERRSANFORM (CADR U)))
   ((COND
     ((EQCAR U 'CONS) (SETQ X -1))
     ((EQCAR U 'LIST) (SETQ X (CDDR U)) T) )
    (ADD2CALLS (CAR U))
    (ANFORML (CDDR U))
    (ANLAPLCH (CADR U) X T) )
   (T (ANFORM U)) ) ))

(DEFLIST '((EVAL ANLEVAL) (ERRORSET ANLEVAL)) 'ANLFN)

(DE ERRSANFORM (U) (PROG (LOCLS!* SLOCLS!*) (RETURN (ANFORM U))))

(DE ANLMAP (U) (ANFORM (CAR U)) (ANLAPLCH (CADR U) 1 NIL))

(DEFLIST '((MAP ANLMAP) (MAPC ANLMAP) (MAPLIST ANLMAP) (MAPCAR ANLMAP)
           (MAPCON ANLMAP) (MAPCAN ANLMAP) )
         'ANLFN)

(DE ANLAPPLY (U) (PROG (X)
 (ANFORM (SETQ X (CADR U)))
 (ANLAPLCH (CAR U)
  (COND
   ((AND (PAIRP X) (MEMQ (CAR X) '(LIST NCONS))) (CDR X))
   (X -1) )
   !*APPLYLOCAL) ))

(DE ANLAPLCH (FN AR SW)
 (COND
  ((OR (NOT (QUOTP FN)) (MEMQ (SETQ FN (CADR FN)) DSARGS!*))
   (ANFORM FN) )
  ((IDP FN) (ADD2CALLS FN) (CHECKARGCOUNT FN AR))
  ((NOT (EQCAR FN 'LAMBDA))
   (DOERRMSG T (LIST FN " illegal function")) )
  (T (ANLAMBDA (CDR FN) AR SW)) ))

(PUT 'APPLY 'ANLFN 'ANLAPPLY)

(DE QUOTP (U) (OR (EQCAR U 'QUOTE) (EQCAR U 'FUNCTION)))

(PUT 'CREF 'SIMPFG '((T (CREFON)) (NIL (CREFOFF))))

(DE DOERRMSG (SW L)
 (COND ((NOT !*EXPERT) (QERLINE 0)))                    %LH
 (PRIN2 "**** ")
 (COND
  ((PAIRP L)
   (FOREACH X IN L DO
    (COND
     ((STRINGP X) (PRIN2 X))
     ((ATOM X) (PRIN1 X))
     ((PAIRP (CAR X)) (PRARGCNT (CAAR X)))
     ((CDR X) (PRIN2 " in") (LSPRINT (SORT (CDR X)) (ADD1 (POSN))))
     (T (PRINCNG (CAR X))) )) )
  ((STRINGP L) (PRIN2 L))
  (T (PRIN1 L)) )
 (COND (SW (PRIN2 " in ") (PRINCNG CURFUN!*)))
 (NEWLINE 0) )
 
(DE IOUTREF (S VARLIS BODY TYPE N L)
 (PROG (CURFUN!* CALLS!* GLOBS!* LOCLS!* SLOCLS!*
        TOPLV!* TAGS!* PROPS!* FLAGS!*)
  (COND ((OR (FLAGP S 'NOTTWO) (LOSEPP S "Procedure")) (RETURN NIL)))
  (COND
   (N N)
   ((PAIRP VARLIS)
    (SETQ N
     (COND
      ((EQ TYPE 'MMACRO) (SUB1 (LENGTH VARLIS)))
      (T (LENGTH VARLIS)) ) ) )
   ((NULL VARLIS) (SETQ N 0))
   ((NOT (MEMQ VARLIS '(ANP!!ATOM ANP!!IDB ANP!!EQ ANP!!UNKNOWN)))
    (SETQ VARLIS (NCONS VARLIS)) (SETQ N (LIST 0)) ) )
  (SETQ S (OUTRDEFUN S TYPE (COND (N N) (T (GET BODY 'ARGCOUNT)))))
  (COND
   ((NULL VARLIS) (ANFORML BODY))
   ((PAIRP VARLIS)
    (ADD2LOCS VARLIS)
    (ANFORML BODY)
    (COND ((EQ TYPE 'SMACRO) (FOREACH X IN DSARGS!* DO
            (COND ((AND (NOT (FLAGP X 'USEDVAR)) (XMEMQ X BODY))
                   (FLAG1 X 'USEDVAR) )) )))
    (REMLOCS VARLIS))
   ((OR (NULL BODY) (NOT (IDP BODY))) NIL)
   ((EQ VARLIS 'ANP!!EQ)
    (PUT S 'SAMEAS (LIST BODY))
    (TRAPUT BODY 'ALSOIS S) )
   (T (ADD2CALLS BODY)) )
  (FOREACH X IN L DO (ADD2CALLS X))
  (OUTREFEND S) ) )

(DE LOSEP (X) (AND !*LOSE (FLAGP X 'LOSE)))

(DE LOSEPP (X Y)
 (COND ((LOSEP X) (DOERRMSG NIL (LIST Y " " X " lost (LOSE)")))) )

(DE TRAPUT (U V W)
 (PROG (A)
  (COND
   ((SETQ A (GET U V))
    (COND ((NOT (MEMQ W A)) (RPLACD A (CONS W (CDR A))) )) )
%   (COND ((NOT (OR TOPLV!* (MEMQ W A))) (RPLACD A (CONS W (CDR A))) ))
   (T (PUT U V (LIST W))) )))

(DE FILPUT (V W) (COND (!*FILEPROPS (TRAPUT CURFIL!* V W))))

(DE TOPUT (U V W)
 (COND
  (W
   (COND (U (PUT U V (COND (TOPLV!* (UNION W (GET U V))) (T W)))))
   (COND (!*FILEPROPS (PUT CURFIL!* V (UNION W (GET CURFIL!* V))))) )))

(DE OUTRF (NM L PRP FLG U)
 (TOPUT NM PRP L)
 (REMFLAG L FLG)
 (FOREACH X IN L DO
  (FOREACH Y IN U DO
   (COND
    ((FLAGP X (CAR Y))
     (REMFLAG1 X (CAR Y))
     (TRAPUT X (CADR Y) NM) ) ) ) ) )

(DE OUTREFEND (S)
 (TOPUT S 'CALLS CALLS!*)
 (REMFLAG CALLS!* 'CINTHIS)
 (FOREACH X IN CALLS!* DO (TRAPUT X 'CALLEDBY S))
 (OUTRF S TAGS!* 'TAGS 'TAG '((TAGC CAUGHTBY) (TAGT THROWNTO)))
 (OUTRF S PROPS!* 'PROPS 'PROP
  '((PROPG GOTBY) (PROPP PUTBY) (PROPR REMPROPBY)) )
 (OUTRF S FLAGS!* 'FLAGS 'FLAG
  '((FLAGP FLAGPBY) (FLAGG FLAGBY) (FLAGR REMFLAGBY)) )
 (TOPUT S 'GLOBS GLOBS!*)
 (REMFLAG GLOBS!* 'GLB2RF)
 (FOREACH X IN GLOBS!* DO
  (TRAPUT X (COND ((GLOBDECL X) 'USEDBY) (T 'USEDUNBY)) S)
  (COND ((FLAGP X 'GLB2BD) (REMFLAG1 X 'GLB2BD) (TRAPUT X 'BOUNDBY S)))
  (COND ((FLAGP X 'GLB2ST) (REMFLAG1 X 'GLB2ST) (TRAPUT X 'SETBY S)
         (COND ((AND TOPLV!* CURLIN!*) (PUT X 'SETLIN CURLIN!*))) )) ) )

(DE RECREF (S TYPE)
 (QERLINE 2)
 (PRTATM "*** Redefinition to ")
 (PRIN1 TYPE)
 (PRTATM " procedure, of:")
 (CREF5 S)
 (REMPROPSS (LIST S) '(CALLS GLOBS TAGS PROPS FLAGS SAMEAS))
 (NEWLINE 2) )

(DE OUTRDEFUN (S TYPE V) (PROG (X)
  (SETQ S (QTYPNM S TYPE))
  (COND ((SETQ X (GET S 'GALL)) (RECREF S TYPE)))
  (COND ((FLAGP TYPE 'FUNCTION)
         (COND ((AND (OR X (GET S 'KNWTYP)) (NOT (MEMQ S REDEF!*)))
                (PUSH S REDEF!*) ))
         (CHKSETYPE S TYPE) ))
  (PUT S 'GALL (CONS CURLIN!* TYPE))
  (COND ((FLAGP TYPE 'FUNCTION)
         (COND ((OR (ISGLOB S) (ASSOC S LOCLS!*))
                (DOERRMSG NIL
                 (LIST "Variable " (LIST S) " defined as function") )))
         (FILPUT 'FUNCTIONS S) ))
  (COND (V (DEFINEARGS S V)
           (FOREACH Y IN (GET S 'ALSOIS) DO (DEFINEARGS Y V)) ))
  (SETQ PROPS!*
   (SETQ FLAGS!* (SETQ TAGS!* (SETQ GLOBS!* (SETQ CALLS!* NIL)))) )
  (SETQ CURFUN!* S)
  (RETURN S) ))

(DE CHKSETYPE (FN TYPE)
 (PROG (X Y)
  (COND
   ((NOT (EQ TYPE (SETQ X (GETYPE FN))))
    (COND
     ((SETQ Y (GET FN 'CALLEDBY))
      (DOERRMSG NIL
       (LIST TYPE " " (LIST FN) " called as " X (CONS NIL Y)) ) )
     ((FLAGP FN 'ISAFEXPR)
      (REMFLAG1 FN 'ISAFEXPR)
      (DOERRMSG NIL
       (LIST TYPE " " (LIST FN) " declared FEXPR earlier") ) ) ) ) ) ) )

(DE GETYPE (X) (SLET ((Y (GET X 'GALL)))
 (COND
   (Y (CDR Y))
   ((FLAGP X 'ISAFEXPR) 'FEXPR)
   (T (OR (GET X 'KNWTYP) 'EXPR)) )))

%(FLAG '(MACRO FEXPR) 'NARYARG)

(DE QTYPNM (S TYPE)
 (COND
  ((FLAGP TYPE 'FUNCTION) (CHKSEEN S) S)
  (T (PROG (X Y Z)
      (COND ((AND (SETQ Y (GET TYPE 'TSEEN)) (SETQ X (ATSOC S (CDR Y))))
             (RETURN (CDR X)) ))
      (COND ((NULL Y)
        (SETQ Y (LIST (APPEND PUTCL!* (EXPLODE TYPE))))
        (PUT TYPE 'TSEEN Y)
        (PUSH TYPE TSEEN!*) ))
      (SETQ Z (EXPLODE S))
      (SETQ X (GENSYM))
      (RPLACD Y (CONS (CONS S X) (CDR Y)))
      (SETQ Y (APPEND Z (CAR Y)))
      (PUT X 'RELNAM (CONS (LENGTH Z) Z))
      (PUT X 'RCCNAM (CONS (LENGTH Y) Y))
      (COND
       ((NOT (FLAGP S 'TFSEEN)) (FLAG1 S 'TFSEEN) (PUSH S TFSEEN!*)) )
      (TRAPUT S 'TYPES X)
      (TRAPUT TYPE 'FUNS X)
      (RETURN X) )) ))

(DE DEFINEARGS (NAME N) (PROG (CALLEDWITH X)
  (SETQ CALLEDWITH (GET NAME 'ARGCOUNT))
  (COND
   ((EQUAL N CALLEDWITH) (RETURN NIL))
   ((AND CALLEDWITH (NOT (PAIRP CALLEDWITH))
         (OR (NOT (PAIRP N)) (LESSP CALLEDWITH (CAR N))
             (AND (CDR N) (LESSP (CDR N) CALLEDWITH)) )
         (SETQ X (GET NAME 'CALLEDBY)) )
    (DOERRMSG NIL
     (LIST NAME (CEXPERT " called with " " given ") CALLEDWITH
                (CEXPERT " instead of " " want ")
           (LIST (LIST N)) (CONS NIL X) ) ) ) )
  (RETURN (HASARG NAME N)) ))

(DE HASARG (NAME N)
 (PUSH NAME HAVEARGS!*)
 (COND ((COND
         ((PAIRP N) (AND (CDR N) (GREATERP (CDR N) MAXARG!*)))
         (T (GREATERP N MAXARG!*)) )
        (DOERRMSG NIL (LIST NAME " has " (LIST (LIST N)))) ))
 (PUT NAME 'ARGCOUNT N) )

(DE CHECKARGCOUNT (NAME N) (PROG (CORRECTN)
  (COND ((NOT (FIXP N)) (SETQ N (TLENGTH N))))
  (COND ((OR (MINUSP N) (FLAGP NAME 'NARYARGS)) (RETURN NIL)))
  (SETQ CORRECTN (GET NAME 'ARGCOUNT))
  (COND ((NULL CORRECTN) (RETURN (HASARG NAME N))))
  (COND ((AND (NOT (EQUAL CORRECTN N))
              (OR (NOT (PAIRP CORRECTN))
                  (LESSP N (CAR CORRECTN))
                  (AND (CDR CORRECTN) (LESSP (CDR CORRECTN) N)) ) )
         (DOERRMSG T
          (LIST NAME " called with " N " instead of "
           (LIST (LIST CORRECTN)) ) ) )) ))

(DE TLENGTH (U)
 (PROG (N)
  (SETQ N 0)
 LOOP
  (COND (U (SETQ N (ADD1 N))))
  (COND ((NOT (PAIRP U)) (RETURN N)))
  (SETQ U (CDR U))
  (GO LOOP) ) )

(DE REFPRINT (U) (PROG (X)
  (SETQ X (COND (CLOC!* (FILEMK (CAR CLOC!*))) (T "*TTYINPUT*")))
  (COND
   ((SETQ CURFUN!* (ASSOC X PFILES!*)) (SETQ CURFUN!* (CDR CURFUN!*)))
   (T (PUSH (CONS X (SETQ CURFUN!* (GENSYM))) PFILES!*)
      (PUT CURFUN!* 'FLNAM X)
      (SETQ X (EXPLODEC X))             % Franz
      (PUT CURFUN!* 'RCCNAM (CONS (LENGTH X) X)) ) )
  (SETQ CURLIN!* (COND (CLOC!* (CONS CURFUN!* (CDR CLOC!*)))))
  (COND
   ((AND !*FILEPROPS (NOT (SETQ CURFIL!* (GET CURFUN!* 'FILEPROPS))))
    (PUT CURFUN!* 'FILEPROPS (SETQ CURFIL!* (GENSYM))) ) )
  (SETQ PROPS!* (SETQ FLAGS!* (SETQ TAGS!* (SETQ CALLS!* (SETQ GLOBS!*
       (SETQ SLOCLS!* (SETQ LOCLS!* NIL)) )))))
  (ANFORM U)
  (OUTREFEND CURFUN!*) ))

(DE CHKFLG (NM X)
 (COND ((NOT (FLAGP X 'ISFLAG))
        (COND ((NOT (FLAGP X 'FLAGSEEN))
               (FLAG1 X 'FLAGSEEN) (PUSH X FLAGSEEN!*) ))
        (FLAG1 X 'ISFLAG) (PUSH X FLAGS!*) ))
 (TRAPUT X 'HASFLAG NM)
 (COND (!*IDPROPS (CHKID NM) (TRAPUT NM 'IDFLAGS X))) )

(DE ANFLAG1 (NM FLG)
 (COND (!*PROPS (CHKFLG NM FLG) (FLAG1 FLG 'FLAGG))) )

(DE ANFLAGP (NM FLG)
 (COND (!*PROPS (CHKFLG NM FLG) (FLAG1 FLG 'FLAGP))) )

(DE ANREMFLAG1 (NM FLG)
 (COND (!*PROPS (CHKFLG NM FLG) (FLAG1 FLG 'FLAGR))) )

(DE ANFLAG (L FLG)
 (COND
  ((NOT (PAIRP L)) (ANFLAG1 L FLG))
  (T (FOREACH X IN L DO (ANFLAG1 X FLG))) ) )

(DE ANREMFLAG (L FLG)
 (COND
  ((NOT (PAIRP L)) (ANREMFLAG1 L FLG))
  (T (FOREACH X IN L DO (ANREMFLAG1 X FLG))) ) )

(DC FLAGP ANLFN (U) (ANFLAGP (QCRFA U 1) (QCRFA U 2)))

(DC FLAG1 ANLFN (U) (ANFLAG1 (QCRFA U 1) (QCRFA U 2)))

(DC FLAG ANLFN (U) (ANFLAG (QCRFA U 1) (QCRFA U 2)))

(DC REMFLAG1 ANLFN (U) (ANREMFLAG1 (QCRFA U 1) (QCRFA U 2)))

(DC REMFLAG ANLFN (U) (ANREMFLAG (QCRFA U 1) (QCRFA U 2)))

(DE CHKPROP (NM X)
 (COND ((NOT (FLAGP X 'PROP))
        (COND ((NOT (FLAGP X 'PROPSEEN))
               (FLAG1 X 'PROPSEEN) (PUSH X PROPSEEN!*) ))
        (FLAG1 X 'PROP) (PUSH X PROPS!*) ))
 (TRAPUT X 'HASPROP NM)
 (COND (!*IDPROPS (CHKID NM) (TRAPUT NM 'IDPROPS X))) )

(DE ANPUT (NM PROP)
 (COND (!*PROPS (CHKPROP NM PROP) (FLAG1 PROP 'PROPP))) )

(DE ANGET (NM PROP)
 (COND (!*PROPS (CHKPROP NM PROP) (FLAG1 PROP 'PROPG))) )

(DE ANREMP (NM PROP)
 (COND (!*PROPS (CHKPROP NM PROP) (FLAG1 PROP 'PROPR))) )

(DC REMPROP ANLFN (U) (ANREMP (QCRFA U 1) (QCRFA U 2)))

(DE ANFORMGET (U) (ANGET (QCRFA U 1) (QCRFA U 2)))

(DEFLIST '((DEFLIST ANDEFLIST) (GET ANFORMGET)) 'ANLFN)

(DE ANDEFLIST (U)
 (PROG (PROP L)
  (SETQ PROP (QCRFA U 2))
  (COND
   ((NOT (PAIRP (SETQ L (QCRFA U 1)))) (ANFORMPUT L PROP (MKQUOTE L)))
   (T (FOREACH X IN L DO
       (ANFORMPUT (CAR X) PROP (MKQUOTE (CADR X))) )) ) ) )

(FLAG '(SMACRO NMACRO) 'CREF)

(DE ANFORMPUT (X Y Z)
 (COND
  ((OR (LOSEP X) (LOSEP Y))
   (DOERRMSG NIL (LIST X " property of " Y " lost (LOSE)")) )
  (T (ANPUT X Y)
     (COND
      ((AND TOPLV!* (QCPUTX Y)) (ANPUTX X Y Z NIL))
      (T (ANFORM Z)) ) ) ))

(DC PUTD ANLFN (U)
 (COND
  (TOPLV!* (ANPUTX (QCRFA U 1) (CADR U) (CADDR U) T))
  (T (ANFORML U)) ) )

(DE ANLPUT (U) (ANFORMPUT (QCRFA U 1) (QCRFA U 2) (CADDR U)))

(PUT 'PUT 'ANLFN 'ANLPUT)

(PUT 'PUTC 'ANLFN 'ANLPUT)

(DE QCPUTX (U) (OR (FLAGP U 'CREF) (FLAGP U 'COMPILE)))

(DE ANPUTX (NAM TYP U SW) (PROG (X BODY)
  (COND
   (SW
    (SETQ TYP
     (COND
      ((NOT (EQ (SETQ X (IQCRF TYP NIL)) '!!ArgValue!!)) X)
      ((AND (EQCAR TYP 'CAR) (EQCAR (SETQ TYP (CADR TYP)) 'GETD)
        (QUOTEP (SETQ TYP (CADR TYP))) )
       (GETYPE (CADR TYP)) )
      (T 'EXPR) ) ) ) )
  (COND
   ((IDP U) (PROGN (SETQ BODY (QCRF U)) (SETQ U 'ANP!!ATOM)))
   ((COND
     ((ATOM U) (SETQ BODY U) T)
     ((MEMQ (CAR U) '(QUOTE FUNCTION)) (SETQ BODY (CADR U)) T) )
    (COND
     ((EQCAR BODY 'LAMBDA)
      (SETQ U (CADR BODY)) (SETQ BODY (CDDR BODY)) )
     ((IDP BODY)
      (SETQ U
       (COND
        (SW 'ANP!!IDB)
        (T (ISETENTLOC BODY 'ENTRYPOINT) 'ANP!!EQ) ) ) )
     (SW (DOERRMSG T (LIST "Illegal function " BODY)) (RETURN NIL))
     (T (RETURN (ANFORM U))) ) )
   ((AND (EQ (CAR U) 'CDR) (EQCAR (CADR U) 'GETD))
    (SETQ BODY (QCRFA (CADR U) 2)) (SETQ U 'ANP!!EQ) )
   ((EQ (CAR U) 'GETFN) (SETQ BODY (QCRFA U 1)) (SETQ U 'ANP!!EQ))
   ((AND (EQ (CAR U) 'GET) (EQCAR (SETQ BODY (CADDR U)) 'QUOTE)
         (QCPUTX (SETQ BODY (CADR BODY))) )
    (SETQ BODY (QTYPNM (QCRFA U 2) BODY)) (SETQ U 'ANP!!EQ) )
   ((EQ (CAR U) 'MKCODE)
    (ANFORM (CADR U)) (SETQ U (QCRFA U 3)) (SETQ BODY NIL) )
   (SW (SETQ BODY (QCRF U)) (SETQ U 'ANP!!UNKNOWN))
   (T (RETURN (ANFORM U))) )
  (IOUTREF NAM U BODY TYP NIL NIL) ))

(DC DE ANLFN (U) (IOUTREF (CAR U) (CADR U) (CDDR U) 'EXPR NIL NIL))

(DC DF ANLFN (U) (OUTDEFR U 'FEXPR))

(DC DM ANLFN (U) (OUTDEFR U 'MACRO))

(DC DMM ANLFN (U) (OUTDEFR U 'MMACRO))

(DE OUTDEFR (U TYPE) (IOUTREF (CAR U) (CADR U) (CDDR U) TYPE NIL NIL))

(FLAG '(!!NoArg!! !!ArgValue!!) 'NOTWO)

(DE QCRFA (U N)
 (WHILE (AND U (GREATERP N 1)) (SETQ N (SUB1 N)) (SETQ U (CDR U)))
 (COND
  ((PAIRP U) (QCRF (CAR U)))
  (T '!!NoArg!!) ) )

(DE QCRF (U) (IQCRF U T))

(DE IQCRF (U SW)
 (COND
  ((OR (NULL U) (EQ U T)) U)
  ((AND (EQCAR U 'QUOTE) (NOT (MEMQ (SETQ U (CADR U)) DSARGS!*))) U)
  ((PROGN (ANFORM U) (NOT (AND SW (IDP U) (FLAGP U 'GSEEN))))
   '!!ArgValue!!)
  ((SETQ SW (GET U 'CRVAL)) SW)
  (T (PUT U 'CRVAL (SETQ SW (GENSYM)))
     (SETQ U (CONS '!( (NCONC (EXPLODE U) '(!)))))
     (PUT SW 'RCCNAM (CONS (LENGTH U) U))
     SW) ))

(FLAG '(EXPR FEXPR MACRO SMACRO NMACRO) 'FUNCTION)

(COMMENT                                % Franz
(DC LAP ANLFN (U)
 (COND
   ((PAIRP (SETQ U (QCRFA U 1)))
    (PROG (TAGS!* GLOBS!* LOCLS!* SLOCLS!* CALLS!* CURFUN!* TOPLV!* X)
       (WHILE U
         (PROGN
          (COND
            ((PAIRP (CAR U))
             (COND
               ((SETQ X (GET (SETQ OP!*!* (CAAR U)) 'CRFLAPO))
                (APPLY X (LIST U)))
               (!*GLOBALS (FOREACH Y IN (CDAR U) DO (ANLAPEV Y))))))
          (SETQ U (CDR U))))
       (QOUTREFE) ) ) ) )

(DC !*ENTRY CRFLAPO (U)
 (PROGN
  (QOUTREFE)
  (SETQ U (CDAR U))
  (OUTRDEFUN (CAR U) (CADR U) (CADDR U))))

(DE QOUTREFE NIL
 (PROG NIL
    (COND
      ((NULL CURFUN!*)
       (COND
         ((OR TAGS!* GLOBS!* CALLS!*)
          (PROGN
           (SETQ CURFUN!* (COMPRESS (EXPLODE '!?LAP!?!?)))
           (CHKSEEN CURFUN!*)))
         (T (RETURN NIL)))))
    (OUTREFEND CURFUN!*) ) )

(DC !*LAMBIND CRFLAPO (U)
 (FOREACH X IN (CADDAR U) DO (GLOBIND (CAR X))) )

(DC !*PROGBIND CRFLAPO (U)
 (FOREACH X IN (CADAR U) DO (GLOBIND (CAR X))) )

(DE LINCALL (U)
 (PROGN
  (ADD2CALLS (CAR (SETQ U (CDAR U))))
  (CHECKARGCOUNT (CAR U) (CADDR U)) ) )

(PUT '!*LINK 'CRFLAPO 'LINCALL)

(PUT '!*LINKE 'CRFLAPO 'LINCALL)

(DE ANLAPEV (U)
 (COND
   ((PAIRP U)
    (COND
      ((MEMQ (CAR U) '(GLOBAL FLUID))
       (PROGN
        (SETQ U (CADR U))
        (GLOBREF U)
        (COND ((EQ (CAR U) 'GLOBAL) (FLAG1 U 'NOFLUID)))
        (COND ((FLAGP OP!*!* 'STORE) (PUT U 'GLB2ST 'T)))))
      (T (PROGN (ANLAPEV (CAR U)) (ANLAPEV (CDR U)))) ) ) ) )

(FLAG '(!*STORE) 'STORE)
)

(DE QERLINE (U)
 (COND
   (PRETITL!* (NEWLINE U))
   (T (PROGN (SETQ PRETITL!* T) (NEWPAGE)))))

(COMMENT                                % Franz
(DE EQCAR (U V) (AND (PAIRP U) (EQ (CAR U) V)))


(DE MKQUOTE (U) (LIST 'QUOTE U))
)

(DE EFFACE1 (U V)
 (COND
   ((NULL V) NIL)
   ((EQ U (CAR V)) (CDR V))
   (T (RPLACD V (EFFACE1 U (CDR V)))) ) )

(COMMENT                                % Franz
(SETQ MAXARG!* 14)

(FLAG '(POP MOVEM SETZM HRRZM) 'STORE)

(DE LAPCALLF (U)
 (PROG (FN)
    (RETURN
     (COND
       ((EQCAR (CADR (SETQ U (CDAR U))) 'FUNC)
        (PROGN
         (ADD2CALLS (SETQ FN (CADADR U)))
         (CHECKARGCOUNT FN (COND ((EQ (CAR U) 15) 1) (T (CAR U))))))
       (!*GLOBALS (ANLAPEV (CADR U))) ) ) ) )

(PUT 'JCALL 'CRFLAPO 'LAPCALLF)

(PUT 'CALLF 'CRFLAPO 'LAPCALLF)

(PUT 'JCALLF 'CRFLAPO 'LAPCALLF)

(DC CALL CRFLAPO (U)
 (COND
   ((NOT (EQUAL (CADDAR U) '(FUNC !*LAMBIND!*))) (LAPCALLF U))
   (T
    (WHILE (AND (SETQ U (CDR U)) (EQCAR (CAR U) 0))
      (GLOBIND (CADR (CADDAR U))) ) ) ) )

(FLAG '(XLOAD FLOAD) 'NOANL)

(FLAG '(XLOAD FLOAD) 'NARYARGS)

(DEFLIST
 '((FISLM 1) (XLOADX 3) (!*BOX 1) (ASCII 1) (ATSOC 2) (BOOLE 3)
   (DEPOSIT 2) (EXAMINE 1) (EXCISE 0) (EXPLODEC 1) (FILEP 1)
   (FREEZE 1) (GCD 2) (GCTIME 0) (INTERNP 1) (INUMP 1) (LSH 2)
   (MKCODE 2) (BIGP 1) (NUMVAL 1) (PGLINE 0) (QUIT 0) (RDSLSH 1)
   (SCAN 0) (SCANSET 1) (SCANINIT 5) (SETPCHAR 1) (SETSYS 1)
   (SKIPTO 1) (SPEAK 0) (TIME 0) (TYI 0) (TYO 1) (UNREADCH 1)
   (WARNING 1)) 'ARGCOUNT)

)

%### IRCREF.SL end
