%### VALU.SL

(SETFLUIDS !$NAMCA)

(DE VALUC (SXP) (VALU (COPYL SXP)))

(DE VALU (SXP)
 (SLET (A)
  (SETQ PARSW!* 0)
  (COND
   ((SNUMP SXP) (VNUM SXP))
   ((NOT (PAIRP SXP)) (VATM SXP))
   ((SETQ A (IGET (CAR SXP) 'PRT)) (FUNCALL A SXP))
   (T (FOREACH X IN SXP REPLACE (VALU X)) (VTRIG SXP)) ) ) )

(NEWSWITCHES
 (NOAUTONAM "PRT does not print names with no NAM as OUTLOWER case")
 (AUTONAMF  "FPRT prints names with no NAMF as OUTLOWER case")
 (OUTLOWER  "Lower case is default for output") )

% Indirect reference to stop compilers from producing recursive calls.
(SETFLUIDS (NEWTEXSWFN TEXMODE!.SWITCHFN))      % JEA

(DC TEXMODE SWITCHFN (SW)
 (REMD 'TEXMODE!.SWITCHFN)
 (LOADX 'PRTEX MSEARCHLIS!* MEXTLIS!* T NIL)  % c.f. MRELOAD in Classi.
 (APPLY NEWTEXSWFN (LIST SW)))  %:LH, JEA

(DE VATM (ATM) (COND
  ((OR NONAM (NOT (IDP ATM))) ATM)
  (T (SLET ((TYP (COND (!*FPRT 'NAMF) (T 'NAM))) (A (GET ATM TYP)))
      (COND
      %((PAIRP A) (SETQ PARSW!* (COND ((CDR A)) (T 0))) (CAR A))
       ((PAIRP A) (SETQ PARSW!* (OR (CDR A) 0)) (CAR A)) %LH
       (A A)    % JEA.
       ((COND (!*FPRT (NOT AUTONAMF)) (T NOAUTONAM)) ATM)
       (T
        (ISETNAM ATM TYP (SETQ A (ULCASE ATM (NOT OUTLOWER))) NIL)
        A ) ) )) ))

% Give NIL a NAM NIL to prevent giving it any other NAM
% ISETNAM is not used here as this NAM is purely internal and should
% not appear on any list of NAMs.
(DPUT NIL NAM (NIL . 0))
(DPUT NIL NAMF (NIL . 0))

(DE VTRIG (VXP) (PROGN
  (SETPARSW DIFPAR TRIGPAR)
  (COND ((CDR VXP) (FOREACH X IN (CDDR VXP) REPLACE (CONS '!, X))))
  (RPLACD VXP (ATPAR (CDR VXP))) ))

(DE ATPAR (VXP) (CONS (CONS '!( VXP) '!)))

(DS DASHP (VXP) (EQCAR VXP '!-))

(DE SUMVALU (SXP) (PROGN
  (SETQ SXP (VALU SXP))
  (COND ((TSTPARSW SUMPAR) (ATPAR SXP)) (T SXP)) ))

(DC PLUS PRT (SXP)
 (COND
  ((NULL (UNPUSH SXP)) (SETQ SXP 0))
  ((NULL (CDR SXP)) (SETQ SXP (SUMVALU (CAR SXP))))
  (T (RPLACA SXP (SUMVALU (CAR SXP)))
     (FOREACH X IN (CDR SXP) REPLACE
      (COND
       ((EQCAR (SETQ X (VALU X)) '!-) X)
       (T (CONS '!+ (COND ((TSTPARSW SUMPAR) (ATPAR X)) (T X)))) ) ) ) )
 (SETPARSW SUMPAR DIFPAR BASPAR TIMPAR)
 SXP)

(DC UNSMP PRT (SXP) (VALU (CADR SXP)))

(DC TXT PRT (SXP)
 (COND
  ((NULL (UNPUSH SXP)) NIL)
  ((NULL (CDR SXP)) (VALU (CAR SXP)))
  (T (FOREACH X IN (CDR SXP) REPLACE (CONS '!  (VALU X)))
     (RPLACA SXP (VALU (CAR SXP)))
     (SETPARSW SUMPAR DIFPAR BASPAR TIMPAR)
     SXP) ) )

(DC VARNR PRT (X)
 (PRTVARNR (CADR X) (COND ((CDDR X) (CADDR X)) (T CRDIF!*))) )

(DE PRTVARNR (X Y)
 (COND
  ((NOT (NUMBERP (SETQ X (GTVRNAM X Y NIL)))) X)
  (!*FPRT (CONS 'X X))
  (T (SETPARSW BASPAR) (LIST 'X UP X DOWN)) ) )

(DC FORM PRT (X)
 (FOREACH Y IN (CDDDR (UNPUSH X)) REPLACE (CONS '!^ (DXPRT Y (CADR X))))
 (PRTPRO T (CAR X) (RPLACA (CDDR X) (DXPRT (CADDR X) (CADR X)))) )

(DC DX PRT (X)
 (SETPARSW DIFPAR)
 (DXPRT (CADR X) (COND ((CDDR X) (CADDR X)) (T CRDIF!*))) )

(DE DXPRT (X Y) (CONS "d" (PRTVARNR X Y)))

(DC QFORM PRT (SXP)
 (UNPUSH SXP)
 (PRTPRO NIL (CAR SXP) (COND
   ((EQUAL (CADDR SXP) (CADDDR SXP))
    (VEXP (LIST (LIST 'DX (CADDR SXP) (CADR SXP)) 2)) )
   (T (CONS (DXPRT (CADDR SXP) (CADR SXP))
       (DXPRT (CADDDR SXP) (CADR SXP)) )) )) )

(DE PRTPRO (SW X Y)
 (SLET ((A (EQCAR X 'TIMES)) SGN ISW)
  (COND ((EQCAR (SETQ X (VALU X)) '!-) (UNPUSH X) (SETQ SGN T)))
  (SETQ X (COND
    ((AND (NOT A) (TSTPARSW TIMPAR)) (CONS (ATPAR X) Y))
    ((AONEP X) (COND ((NOT (OR SGN (CDR Y))) (SETQ ISW SW))) Y)
    (T (CONS X Y)) ))
  (COND
   ((NULL ISW) (SETPARSW TIMPAR DIFPAR BASPAR))
   (T (SETPARSW DIFPAR)) )
  (COND (SGN (CONS '!- X)) (T X)) ) )

(DC QUOTE PRT (X)
 (FOREACH Y IN (CDDR X) DO (SET Y T)) % ????
 (CADR X) )

(DC FACTOR PRT (SXP) (VALU (COND
  ((EQCAR (CADR SXP) 'TIMES) (NCONC (CADR SXP) (CDDR SXP)))
  (T (RPLACA SXP 'TIMES)) )))

(DC TIMES PRT (SXP)
 (COND
  ((NULL (UNPUSH SXP)) (SETQ SXP 1))
  (T (SLET ((A (VALU (CAR SXP))) SGN SW)
      (COND ((EQCAR A '!-) (SETQ SGN T) (UNPUSH A)))
%     (COND ((TSTPARSW CPLXPAR) (RPLACA (CDR A) (COND
%              ((EQ (CADR A) '!-) '!+)
%              (T '!-) ))))
      (COND ((TSTPARSW TIMPAR) (SETQ A (ATPAR A))))
      (SETQ A (COND
        ((NULL (CDR SXP)) (SETQ SXP A) NIL)
        ((AONEP A) (SETQ SW T) (UNPUSH SXP))
        (T (RPLACA SXP A) (CDR SXP)) ))
      (FOREACH X IN A REPLACE
       (SETQ X (VALU X))
       (COND ((OR (TSTPARSW TIMPAR) (EQCAR X '!-)) (SETQ X (ATPAR X))))
       (COND
        (SW (SETQ SW NIL) X)
        (!*FPRT (CONS '!* X))
        (CHINPRO (CONS CHINPRO X))
        (T X) ) )
      (COND (SGN (XPUSH SXP '!-))) )) )
 (SETPARSW TIMPAR DIFPAR BASPAR)
 SXP)

(DE VQDIF (DXP X VT)
 (SLET ((A (VALU (CADR DXP))) (B (CDDR DXP)) C D N)
  (RPLACA (CDR DXP)
   (COND
    (!*FPRT A)
    (T (CONSA (COND ((TSTPARSW DIFPAR) (ATPAR A)) (T A)) DOWN X)) ) )
  (WHILE B
   (SETQ D (GTVRNAM (SETQ C (CAR B)) VT !*FPRT))
   (RPLACA B D)
   (SETQ A (CDR B))
   (SETQ N 1)
   (WHILE (AND (UNPUSH B) (EQUAL C (CAR B))) (RPLACA B D) (IINCR N))
   (COND ((NOT (COND (!*FPRT (IONEP N)) (T (ILESSP N 4))))
          (RPLAD A (COND (!*FPRT N) (T (ATPAR N))) B) )) )
  (COND
   (!*FPRT (VTRIG DXP))
   (T (SETPARSW DIFPAR BASPAR) (CONS (CDR DXP) UP)) ) ) )

(DE GTVRNAM (C VT SW)
 (SLET (D)
  (COND
   ((NOT (NUMBERP C)) (VALU C))
   ((AND (NOT SW) PVARNUM) C)
   ((SETQ D (XGTVRNM C VT)) (VALU D))
   ((NOT SW) C)
   (T (VALU (EASK (LIST (XTWOVARQ VT) C)
                  "Use VARS command to give%l variable %p a name"
                  (LIST 'XGTVRNM C (MKQUOTE VT)) C NIL))) ) ) )

(DE XGTVRNM (X VT)
 (COND ((NOT (NUMBERP (SETQ X (KAR1 (GTVRLS VT) X)))) X)) )

(XPUSH DEFDIFLIS!*!* '(PRT . VDIFF))

(DE VDIFF (DXP)
 (SLET ((A (CAR DXP)))
  (COND (!*FPRT (RPLACA DXP 'DF)))
  (VQDIF DXP '!, A) ) )

(DE VEXP (SXP)
 (COND
  (!*FPRT (CONSA (IFPAVL (CAR SXP)) '!*!* (IFPAVL (CADR SXP))))
  (T (SLET (X)
     (RPLAD (CDR SXP) (CONS UP (VALU (CADR SXP))) DOWN) %LH
     (SETQ X (VALU (CAR SXP)))
     (COND
      ((TSTPARSW TRIGPAR)
       (RPLACA SXP (CAR X)) (RPLACD (CDR SXP) (RPLACA X (CDDR SXP))) )
      (T (RPLACA SXP (COND ((TSTPARSW BASPAR) (ATPAR X)) (T X)))) )
     (SETPARSW BASPAR DIFPAR)
     SXP)) ) )

(DE IFPAVL (SXP)
 (COND ((PAIRP (SETQ SXP (VALU SXP))) (ATPAR SXP)) (T SXP)) )

(DE VEXPT (SXP) (VEXP (CDR SXP)))

(DEFLIST '((EXPT VEXPT)) 'PRT)

(DC EXP PRT (SXP)
 (COND
  ((AONEP (CADR SXP)) (VATM 'E))
  (T (VEXP (RPLACA SXP 'E))) ) )

(DEFLIST '((LET PRTLIST)) 'PRT)

(DE PRTLIST (X)
 (FOREACH Y IN (CDR X) REPLACE (CONS " ," (VALU Y)))
 (RPLACA (CADR X) '! )
 (SETPARSW BASPAR SUMPAR DIFPAR TIMPAR)
 X)

(DC EQUAL PRT (X) (PRTEQL X '!=))

(DE PRTEQL (X L)
 (RPLACA X (VALU (CADR X)))
 (RPLACA (CDR X) L)
 (RPLACA (CDDR X) (VALU (CADDR X)))
 (SETPARSW BASPAR SUMPAR DIFPAR TIMPAR)
 X)

(DC DEPEND PRT (X) (SLET ((VT (CADR X)))
 (RPLACD X (CDDR X))
 (RPLACD X (CONS '!  (CONS (VALU (CADR X))
    (FOREACH Y IN (CDDR X) REPLACE (CONS '!, (GTVRNAM Y VT !*FPRT))) )))
 (SETPARSW BASPAR SUMPAR DIFPAR TIMPAR)
 X))

(DE VEQL NIL (COND (!*FPRT " := ") (T " = ")))

(DC ARRAY PRT (X)
 (RPLACD X (CONS '!  (CONS (VALU (CADR X))
    (FOREACH Y IN (CDDR X) REPLACE (CONS '!, (VALU Y))) )))
 (SETPARSW BASPAR SUMPAR DIFPAR TIMPAR)
 X)

(DC SETEN PRT (SXP) (PRTEQL SXP (VEQL)))
(DE PRTEN (SXP)
 (COND
  ((NULL (CDR SXP)) (VALU (CAR SXP)))
  ((NOT !*FPRT)
   (SLET ((B (CAR SXP)) (VTL (GTVRLS CRDIF!*)) UPL INX)
    (SLET ((UPIN (GET B 'UPINDX)) (TNSP (GET B 'TNSPCH)))
     (RPLACA SXP (VALU B))
     (FOREACH X IN (CDR SXP) REPLACE
      (COND
       ((NOT (NUMBERP X)) (SETQ X (VALU X)))
       (PTEVAR (SETQ X (VALU (KAR1 VTL X)))) )
      (COND
       ((NULL INX)
        (COND ((SETQ B (AATSOC 0 TNSP)) (SETQ X (CONS (CDR B) X))))
        (SETQ UPL (AMEMQ (SETQ INX 1) UPIN))
        (SETQ X (CONS (COND (UPL UP) (T DOWN)) X)) )
       ((AMEMQ (IINCR INX) UPIN)
        (COND ((NOT UPL) (SETQ UPL T) (SETQ X (CONSA UP UP X)))) )
       (UPL (SETQ UPL NIL) (SETQ X (CONSA DOWN DOWN X))) )
      (COND ((SETQ B (AATSOC INX TNSP)) (SETQ X (CONS X (CDR B)))))
      X)
     (SETPARSW BASPAR)
     (CONS SXP (COND (UPL DOWN) (T UP))) ) ) )
  ((OR NOREDARY TPSSW) SXP)
  (T (VTRIG (FOREACH X IN SXP REPLACE (VALU X)))) ) )

(DE DONAM (L TYP) (SLET ((NONAM T)) (FOLDCASE NIL
   (FOREACH X IN L DO
    (COND ((AND (GET X TYP) (TTYINP)) (WARNINGFT 182 "%r new nam" X)))
    (SETNAM X TYP (FOINPC X)) ) )))

(DE SETNAM (X TYP NM) (SLET ((NONAM T))
  (SETQ !*FPRT (EQ TYP 'NAMF))
  (SETQ NM (VALUC NM))
  (ISETNAM X TYP NM PARSW!*) ))

(DE ISETNAM (ID TYP NM SW) (SLET ((NL (GET ID TYP)))
  (COND (NM (SETQ NM (CONS
                      (COND
                       ((OR (NOT (PAIRP NM)) (CDR NM)) NM)
                       (T (CAR NM)) )
                   %LH(COND (SW) (T 0))
                      (OR SW 0) ))))
  (COND (NL (COND
          ((NULL NM) (WARNINGFT 184 "%p for %p deleted" TYP ID))
          ((NOT (EQUAL NM NL))
           (WARNINGFT 186 "Old %p for %p replaced" TYP ID) ) )))
  (COND
   (NM (PUT ID TYP NM) (PUTXL TYP 'NAMLIS ID))
   (T (REMPROP ID TYP) (REMPROPXL TYP 'NAMLIS ID)) )
  ID))

(DE DONAMC (SW TYP L)
 (FOREACH X IN L DO (ISETNAM X TYP (ULCASE X SW) NIL)) )

(NEWSWITCHES (NONAMFOLD "Do not fold case in NAM definitions"))

(DE DOINAM (L) (IDOINAM L (NOT OUTLOWER)))

(DE IDOINAM (L !$NAMCA)
 (SLET ((A (IGET (CAR L) 'NAMFN)))
  (COND
   (A (FUNCALL A L))
   (T (FOREACH X IN L CONC
       (COND
        ((PAIRP X) (IDOINAM X !$NAMCA))
        ((EQ X 'UC) (SETQ !$NAMCA T) NIL)
        ((EQ X 'LC) (SETQ !$NAMCA NIL))
        (T (NCONS (COND
                   ((SETQ A (GET X 'PRTLCTRL)) A)
                   (NONAMFOLD X)
                   (T (ULCASE X !$NAMCA)) ))) ))) )))

(DC QUOTE NAMFN (X) (NCONS (COND
   ((OR NONAMFOLD (PAIRP (CADR X))) (CADR X))   % JEA
   (T (ULCASE (CADR X) !$NAMCA)) )))

%### VALU.SL end
