%### MKPSHP.SL

% This file is used to generate compiled Sheep with profiling on
% Cambridge Lisp.

(SETQ !*INT NIL)                % Batch
(SETQ !*COMP NIL)
(LOAD "../SEARSH")              % Set search list for making Sheep.
(PROFILE 1)
(IFP !*RSHEEP (LOAD SHBOOT))    % For Rsheep only.
(MODULOAD SHIMP1)               % Implementation specific code, part 1.
(LOAD SHPMAC)                   % Macros. For compilation only.
(PROFILE 1)
(LOAD SHEEPI)                   % Sheep, implementation independent.
(MODULOAD SHIMP2)               % Implementation specific code, part 2.
(LOAD SHLOD)                    % Some initialisation.
(IFP !*RSHEEP (LOAD SHPFIN))    % For Rsheep only.
(MKSIDEFAP CORD)                % Make Cord side module.
(FOREACH FN IN LOCALFUNCTIONS!* DO (REMOB FN))  % Remove from oblist.
(SETQ LOCALFUNCTIONS!* NIL)     % Release list storage.
(SAVERUN NIL)                   % Save the image.

%### MKPSHP.SL end
