%### SHIMP2.SL

% Implementation specific code for Sheep, part 2, functions that have
% better be defined after loading the implementation independent code.
% Codemist Standard Lisp (CSL) version.

% This file was created by dividing shcmbl into two parts shimp1 and
% shimp2 to be loaded before and after the bulk of the Sheep code. JEA.

%(SETGLOBALS RESIDEFUNCTIONS!*)

% Remove flagging made in shimp1.sl
(NOTLOADTIME
  (REMFLAG 
    '(
      SETQENQQ XMEXPT XMMULTC XMDOMULC
      XMDFMQ XMDFMQL XMDFMQ2L XMPLUS XMRTIMES
      BIGGID2 TSTPARSW TSTBIT IDVALUE)
    'LOSE) )

% Not needed for CSL.
(REMFLAG '(RPLANUM RPLADEN CHKGCD NORM1 SPL2 ARITHP1 STI2 ARITHT1)
      'LOSE)

%(SETQ RESIDEFUNCTIONS!* '(RESIDETENSORS))       % For MKSIDEFAP.

%(DE RESIDETENSORS (TL) (SLET (X) (COND % Remove compile time tensor def
%   ((NULL TL) (CONS TENALIAS!* (COPYT TENSORS)))    % for side module.
%   (T (SETQ TENALIAS!* (CAAR TL))
%      (SETQ X (SETDIFFQ TENSORS (SETQ TL (CDAR TL))))
%      (FOREACH TN IN X DO (UNSET TN)
%       (FOREACH Z IN '(HELP TNDEFIL LOSE) DO (REMPROP TN Z)) )
%      (SETQ TENSORS TL)
%      X) )))

%### SHIMP2.SL end
