%### ON.SL

(SETGLOBALS PSWITCHES)

(DC SWITCHES HELP () (LLHELP "Switches:" SWITCHES))

(DS ON (!&REST L) (XONOFF 'L T T NIL))

(DS OFF (!&REST L) (XONOFF 'L NIL T NIL))

(DMACRO SWISTAT (!&REST L)  % Rewritten to test L at expand time. JEA.
 (LIST 'XONOFF (COND (L (MKQUOTE L)) (T 'SWITCHES)) NIL NIL NIL) )
%(DS SWISTAT (!&REST L) (XONOFF (COND ('L) (T SWITCHES)) NIL NIL NIL))

(DS PON (!&REST L) (XONOFF 'L T T T))

(DS POFF (!&REST L) (XONOFF 'L NIL T T))

(NEWSWITCHES
 (NOREDSWITCHES "Do not prefix unknown switch with * as in REDUCE")
 (REDSWIQUIET "Do not warn about unknown switch taken as REDUCE style")
  )

(DE XONOFF (L SW CSW PSW)
 (SLET (A B C SWR)
  (COND
   ((EQCAR L 'SWITCHES) (SETQ L SWITCHES))
   ((EQCAR L 'ALL) (SETQ L (SETDIFFQ SWITCHES PSWITCHES)))
   ((EQCAR L 'PALL) (SETQ L PSWITCHES))
   ((AND (PAIRP L) (EQCAR (CAR L) 'LIST))       % Reduce compatibility
    (SETQ L (EVAL (CAR L))) ) )                 % hack. JEA.
  (FOREACH X IN L CONC
   (SETQ SWR
    (COND
     ((MEMQ X SWITCHES) X)
     ((SETQ C (GET X 'ISWITCHALIAS)) C)
     ((OR NOREDSWITCHES (NOT (BOUNDP (SETQ A (CONCATID '!* X)))))
      (ERRORFT 483 "%r is not a switch" X) )
     (T (COND ((NOT REDSWIQUIET)
               (WARNINGFT 142 "%r is a REDUCE style switch" X) ))
      (PUT X 'ISWITCHALIAS A) ) ))
   (COND (PSW (COND
               (SW (PUSHQ PSWITCHES X))
               (T (REMPOP PSWITCHES X)) )))
   (SETQ A (EVAL SWR))
   (COND (CSW
          (COND
           ((SETQ B (GET X 'SWITCHFN))
            (COND                       % Check first if switch change.
             ((NOT (EQ SW (EVAL X))) (FUNCALL B SW)) ) )    % JEA
           ((SETQ B (ATSOC SW (GET X 'SIMPFG))) (EVLIS (CDR B))) )
          (SET SWR SW) ))
   (COND (A (LIST X))) ) ) )

%### ON.SL end
