%### MKSHP.SL

% This file is used to generate compiled Sheep on Portable Standard
% Lisp (PSL) or Rsheep on PSL based Reduce.

(SETQ !*INT NIL)                % Batch
(LOAD "../SEARSH")              % Set search list for making Sheep.
(IFP !*RSHEEP (LOAD SHBOOT))    % For Rsheep only.
(SETQ !*COMP T)                 % For compilation only.
(LOAD SHIMP1)                   % Implementation specific code, part 1.
(LOAD SHPMAC)                   % Macros. For compilation only.
(LOAD SHEEPI)                   % Sheep, implementation independent.
(LOAD SHIMP2)                   % Implementation specific code, part 2.
(SETQ !*COMP NIL)               % Stop compiling.
(LOAD SHLOD)                    % Some initialisation.
(IFP !*RSHEEP (MODULOAD SHPFIN)) % For Rsheep only.
(IFP !*RSHEEP                   % Save the image.
 (SAVERUN PRSHEEP)
 (SAVERUN PSHEEP) )

%### MKSHP.SL end
