%### SIMPBL.SL

(DE MKPLUS (X Y) (COND
  ((AZEROP X) Y)
  ((AZEROP Y) X)
  (T (LIST 'PLUS X Y)) ))

(DE MKTIMS (X Y) (COND 
  ((OR (AZEROP X) (AZEROP Y)) 0)
  ((AONEP X) Y)
  ((AONEP Y) X)
  (T (LIST 'TIMES X Y)) ))

(DE MKMIN (X) (COND
  ((AZEROP X) 0)
  (T (LIST 'TIMES -1 X)) ))

(DE NSMMINUS (X) (COND
  ((SNUMP X) (SMINUS X))
  ((ATOM X) (MKMIN X))
  (T (LIST 'MINUS X)) ))

(DE DOCOPY (SSXP) (DOCOPYS SSXP NIL NIL))

(DE DOCOPYS (SSXP MSW CSW) (PROGN
  (COND ((EQCAR SSXP 'MINUS) (SETQ MSW T) (SETQ SSXP (CADR SSXP))))
  (COND ((EQCAR SSXP 'CONJOF) (SETQ CSW T) (SETQ SSXP (CADR SSXP))))
  (SETQ SSXP (TPCOPY SSXP))
  (COND (CSW (SETQ SSXP (CPLXCONJ SSXP))))
  (COND
   (MSW (SMMINUS SSXP))
   (T SSXP) ) ))

(DE DOMULC (X Y) (DOMULCW X Y NIL))

(DE DOMULCW (X Y MSW) (COND 
  ((OR (AZEROP X) (AZEROP Y)) 0)
  ((AONEP X) (DOCOPYS Y MSW NIL))
  ((AONEP Y) (DOCOPYS X MSW NIL))
  (T (COND ((EQCAR X 'MINUS) (SETQ MSW (NOT MSW)) (SETQ X (CADR X))))
     (COND ((EQCAR Y 'MINUS) (SETQ MSW (NOT MSW)) (SETQ Y (CADR Y))))
     (COND
      (TPSSW (TPSMUL X Y TPSSW MSW))
      (T (SLET (CJSW)
          (COND ((EQCAR X 'CONJOF) (SETQ CJSW T) (SETQ X (CADR X))))
          (SETQ X (COPYL X))
          (COND (CJSW (SETQ X (CPLXCONJ X))))
          (SETQ CJSW (COND ((EQCAR Y 'CONJOF) (SETQ Y (CADR Y)))))
          (SETQ Y (COPYL Y))
          (COND (CJSW (SETQ Y (CPLXCONJ Y))))
          (SMTIMES2 (COND (MSW (SMMINUS X)) (T X)) Y) )) ) ) ))

% SHL is list of Sheep-expressions to multiply,
% NMS is a Sheep-number or NIL,
% SGN is the sign switch and SW is the copy switch.
(DE SMMULTC (SHL NMS SGN SW) (SLET (CSW)
  (COND ((NULL NMS) (SETQ NMS 1)))
  (SETQ SHL (FOREACH X IN SHL CONC
    (COND 
     ((SNUMP X) (COND 
       ((AEQN X -1) (SETQ SGN (NOT SGN)))
       ((NOT (AONEP X)) (SETQ NMS (STIMES NMS X))) )
      NIL)
     ((NOT (PAIRP X)) (LIST X))
     (T (SETQ CSW (COND
          (SW T)
          ((EQCAR X 'XCOPY) (UNPUSH X) T) ))
        (COND ((EQCAR X 'MINUS) (SETQ X (CADR X)) (SETQ SGN (NOT SGN))))
        (LIST (COND
          ((EQCAR X 'CONJOF)
           (CPLXCONJ (COND (CSW (COPYL (CADR X))) (T (CADR X)))))
          (CSW (COPYL X))
          (T X) )) ) ) ))
  (COND (SGN (SETQ NMS (SMINUS NMS))))
  (COND 
   ((NULL SHL) NMS)
   ((NULL (CDR SHL)) (SNUTIM NMS (CAR SHL)))
   (T (SMTIMESL (CONS 'TIMES (COND
          ((AONEP NMS) SHL)
          (T (CONS NMS SHL)) )))) ) ))

(DE IDFMQ (X Y VR VT MSW) (COND
  ((OR (AZEROP X) (SNUMP Y)) 0)
  ((AONEP X) (SETQ X (SMDIFFC Y VR VT)) (COND (MSW (SMMINUS X)) (T X)))
  (T (COND ((EQCAR X 'MINUS) (SETQ MSW (NOT MSW)) (SETQ X (CADR X))))
     (COND ((EQCAR Y 'MINUS) (SETQ MSW (NOT MSW)) (SETQ Y (CADR Y))))
     (COND
      (TPSSW (TPDFMQ X Y VR VT TPSSW MSW))
      ((AZEROP (SETQ Y (SMDIFFC Y VR VT))) 0)
      (T (SETQ VR (COND ((EQCAR X 'CONJOF) (SETQ X (CADR X)))))
         (SETQ X (COPYL X))
         (COND (VR (SETQ X (CPLXCONJ X))))
         (SMTIMES2 (COND (MSW (SMMINUS X)) (T X)) Y) ) ) ) ))

% IDFMQL added by JEA.
(DE IDFMQL (X Y VRL VT MSW) (COND
  ((OR (AZEROP X) (SNUMP Y)) 0)
  ((AONEP X)
   (SETQ X (SMDIFFCL Y VRL VT)) (COND (MSW (SMMINUS X)) (T X)) )
  (T (COND ((EQCAR X 'MINUS) (SETQ MSW (NOT MSW)) (SETQ X (CADR X))))
     (COND ((EQCAR Y 'MINUS) (SETQ MSW (NOT MSW)) (SETQ Y (CADR Y))))
     (COND
      (TPSSW (TPDFMQL X Y VRL VT TPSSW MSW))
      ((AZEROP (SETQ Y (SMDIFFCL Y VRL VT))) 0)
      (T (SETQ VRL (COND ((EQCAR X 'CONJOF) (SETQ X (CADR X)))))
         (SETQ X (COPYL X))
         (COND (VRL (SETQ X (CPLXCONJ X))))
         (SMTIMES2 (COND (MSW (SMMINUS X)) (T X)) Y) ) ) ) ))

% IDFMQ2L added by JEA.
(DE IDFMQ2L (X Y VR1L VT1 VR2L VT2 MSW) (COND
  ((OR (SNUMP X) (SNUMP Y)) 0)
  (T (COND ((EQCAR X 'MINUS) (SETQ MSW (NOT MSW)) (SETQ X (CADR X))))
     (COND ((EQCAR Y 'MINUS) (SETQ MSW (NOT MSW)) (SETQ Y (CADR Y))))
     (COND
      (TPSSW (TPDFMQ2L X Y VR1L VT1 VR2L VT2 TPSSW MSW))
      ((AZEROP (SETQ X (SMDIFFCL X VR1L VT1))) 0)
      ((AZEROP (SETQ Y (SMDIFFCL Y VR2L VT2))) 0)
      (T (SMTIMES2 (COND (MSW (SMMINUS X)) (T X)) Y) ) ) ) ))

(DE SMDIFFC (SXP VR VT) (COND
  (TPSSW (TPDIFF SXP VR VT TPSSW))
  (T (SMDIFF (DOCOPY SXP) VR VT)) ))

(DE SMDIFFCL (SXP VRL VT) (COND
  (TPSSW (TPDIFFL SXP VRL VT TPSSW))
  (T (SMDIFFL (DOCOPY SXP) VRL VT)) )) 

(DE SMDIFF (SXP VR VT) (SIMP1 (SDIF SXP VR VT)))

(DE SMDIFFL (SXP VRL VT) (PROGN
  (FOREACH VR IN VRL DO (SETQ SXP (SMDIFF SXP VR VT)))
  SXP))

(DE SNUTIM (NUM SXP) (COND
  ((AZEROP NUM) 0)
  ((AONEP NUM) SXP)
  ((AEQN NUM -1) (SMMINUS SXP))
  (T (ISNUTIM NUM SXP)) ))

(DE ISNUTIM (NUM SXP) (COND
  ((SNUMP SXP) (STIMES NUM SXP))
  ((EQCAR SXP 'PLUS)
   (FOREACH X IN (CDR SXP) REPLACE (ISNUTIM NUM X))
   SXP )
  ((NOT (EQCAR SXP 'TIMES)) (LIST 'TIMES NUM SXP))
  ((NOT (SNUMP (CADR SXP))) (RPLACD SXP (CONS NUM (CDR SXP))))
  ((NOT (AONEP (SETQ NUM (STIMES NUM (CADR SXP)))))
   (RPLACA (CDR SXP) NUM) SXP)
  ((CDDDR SXP) (RPLACD SXP (CDDR SXP)))
  (T (CADDR SXP)) ))

(DE SMMINUS (SXP) (SLET (A) (COND
   ((SNUMP SXP) (SMINUS SXP))
   ((ATOM SXP) (MKMIN SXP))
   ((EQ (CAR SXP) 'PLUS)
    (FOREACH Y IN (CDR SXP) REPLACE (SMMINUS Y))
    SXP )
   ((NOT (EQ (CAR SXP) 'TIMES)) (MKMIN SXP))
   ((NOT (SNUMP (SETQ A (CADR SXP)))) (RPLACD SXP (CONS -1 (CDR SXP))))
   ((NOT (AEQN A -1)) (RPLACA (CDR SXP) (SMINUS A)) SXP)
   ((CDDDR SXP) (RPLACD SXP (CDDR SXP)))
   (T (CADDR SXP)) )))

%### SIMPBL.SL end
