%### SIMPEX.SL

(SETFLUIDS COLLEX!$ PLEXPT!$)

(COMMENT
(DE SMEXPT (BAS EX) (COND
  ((AZEROP EX) 1)
  ((AONEP EX) BAS)
  ((EQCAR (SETQ BAS (COLLEX BAS EX NIL)) 'TIMES) (SMTIMESL BAS))
  (T BAS) )) )

(DE SMEXPT (BAS EX) (XSMEXPT BAS EX NIL))

(DE XSMEXPT (BAS EX X) (COND
  ((AZEROP EX) 1)
  ((AONEP EX) BAS)
  (T (COLLEX BAS EX X)) ))

(DE SIMP2 (X) (SLET (A) (COND 
   ((SATOM X) X)
   ((NOT NOALLSIMP) (COND
     ((SETQ A (IGET (CAR X) 'SIMP2FN)) (FUNCALL A X))
     ((PROGN (SIMP2L X) (SETQ A (IGET (CAR X) 'SIMPXFN)))
      (FUNCALL A (CADR X) X))
     ((SETQ A (IGET (CAR X) 'SHSMPFN)) (FUNCALL A X))
     (T X) ))
   ((EQ (CAR X) 'PLUS) (SIMP2L X) (SMPLUSL X))
   ((EQ (CAR X) 'TIMES) (TIMESS2 X))
   ((EQ (CAR X) 'EXPT) (EXPTS2 X))
   ((EQ (CAR X) 'EXP) (XSMEXP (SIMP2 (CADR X)) X))
   ((SETQ A (IGET (CAR X) 'SHSMPFN)) (FUNCALL A X))
   (T X) )))

(DE SIMP2L (SXP) (FOREACH X IN (CDR SXP) REPLACE (SIMP2 X)))

% PLUS has SIMPXFN property

(DE TIMESS2 (X)
 (SLET ((L (CDR X)))
  (WHILE
   (AND L (NOT (AZEROP (CAR (RPLACA L (SIMP2 (CAR L)))))))
   (UNPUSH L) )
  (COND
   (L 0)
   (T (SMTIMESL X)) ) ))

(DE EXPTS2 (X) (SLET ((EX (SIMP2 (CADDR X)))) (COND
   ((AZEROP EX) 1)
   ((AONEP EX) (SIMP2 (CADR X)))
   (T (COLLEX (SIMP2 (CADR X)) EX X)) )))

(DEFLIST '((TIMES TIMESS2) (EXPT EXPTS2) (UNSMP RETARG)) 'SIMP2FN)

%(DEFLIST '((PWS CSIPWS)) 'SIMP2FN)

(COMMENT
(DE SIMPEX (SXP) (COND 
  ((ATOM SXP) SXP)
  ((MEMQ (CAR SXP) '(TIMES PLUS))
   (FOREACH X IN (CDR SXP) REPLACE (SIMPEX X))
   SXP)
  ((EQ (CAR SXP) 'EXP)
   (COND
    ((AZEROP (CAR (RPLACA (CDR SXP) (SIMP2 (CADR SXP))))) 1)
    (T SXP) ) )
  ((NOT (EQ (CAR SXP) 'EXPT)) SXP)
  (T (SLET ((EX (SIMP2 (CADDR SXP)))) (COND 
       ((AZEROP EX) 1)
       ((AONEP EX) (SIMPEX (CADR SXP)))
       (T (COLLEX (SIMP2 (CADR SXP)) EX SXP)) ))) )) )

(NEWSWITCHES (EXPTEXP "Convert X^Y to exp(Y*Log(X))"))

(DE COLLEX (BAS EX COLLEX!$) (SLET (A) (COND 
   ((AONEP BAS) BAS)
   ((EQCAR BAS 'EXP)
    (XSMEXP (SMTIMES2 (CADR BAS) EX) BAS) )
   ((AND EXPTEXP (NOT (SNUMP EX)))
    (XSMEXP (SMTIMES2 (XSMLOG BAS COLLEX!$) EX) NIL) )
   ((EQ BAS IMNT!*) (IMBAS EX))
   ((SNUMP BAS) (SIEDN BAS EX))
   ((NOT (PAIRP BAS)) (XMKEXPT BAS EX))
   ((SETQ A (GET (CAR BAS) 'EXPTFN)) (FUNCALL A BAS EX))
   (T (XMKEXPT BAS EX)) )))

(DC EXPT EXPTFN (BAS EX)
 (COLLEX (CADR BAS) (SMTIMES2 EX (CADDR BAS)) BAS) )

(DC TIMES EXPTFN (BAS EX)
 (FOREACH X IN (CDR BAS) REPLACE (COLLEX X (COPYL EX) NIL))
 (SMTIMESL BAS) )

% This version of PLUSBAS uses a multinomial expansion.
% Originally by JEA.
(DC PLUS EXPTFN (BAS EX) (SLET (PLEXPT!$ B) (COND
   ((AND (SNUMP EX) (GREATERP (SETQ PLEXPT!$ (SFIX EX)) 0)
     (NOT (GREATERP PLEXPT!$ EXPANDLIM!*)) )
    (COND ((NOT (AZEROP (SETQ EX (SFRACTION EX))))
           (SETQ B (XMKEXPT (COPYL BAS) EX)) ))
    (SETQ PLEXPT!$
     (SHCOLLECT (PLEXPT PLEXPT!$ NIL 1 (REVERSIP (CDR BAS)))) )
    (COND (B (SMTIMES2 B PLEXPT!$)) (T PLEXPT!$)) )
   (T (XMKEXPT BAS EX)) )))

(DE PLEXPT (EX RES N L)
 (SLET ((A (CAR L)) (B (SMEXPT (COPYL A) EX)) (RN 0) (CN PLEXPT!$))
  (SMADDTERM (IDOCOLLTIMES (STIMES N (SXIOVERW CN EX NIL)) B RES))
  (COND ((UNPUSH L)
         (WHILE (NOT (AZEROP (XIDECR EX)))
          (PLEXPT (XIINCR RN) (CONS (CONS A EX) RES)
                  (STIMES N (SXIOVERW (XIDECR CN) EX NIL)) L ) )
         (PLEXPT (XIADD1 RN) RES N L) )) ))
 
(DE IDOCOLLTIMES (NN B RES) (COND
  ((NULL RES) (SNUTIM NN B))
  ((SNUMP B) (IDOCOLLTIMES (STIMES NN B) (CAR RES) (CDR RES)))
  (T (ICOLLTIMES
      NN
      (COND ((EQCAR B 'TIMES) B) (T (LIST 'TIMES B)))
      (FOREACH X IN RES COLLECT (SMEXPT (COPYL (CAR X)) (CDR X)))
      NIL NIL )) ))

%(DE COLIS (X N) 
% (SLET ((A (LIST X))) (REPEATS (XSUB1 N) (XPUSH A (COPYL X))) A) )

(DE SIEDN (BAS EX) (SLET (A B) (COND 
   ((AONEP BAS) BAS)
   ((AZEROP BAS) (COND 
     ((AZEROP EX) (XMKEXPT 0 EX))
     ((SMINUSP EX) (SRECIP 0))     % Give error
     (T 0) ))
   ((NOT (SNUMP EX)) (XMKEXPT BAS EX))
   ((SMINUSP BAS)
    (SMTIMES2 (MIN1BAS EX) (SIEDN (SMINUS BAS) EX)) )
   ((OR (SFLOATP BAS) (SFLOATP EX)) (SFEXPT BAS EX))
   ((GREATERP (ABS (SETQ A (SFIX EX))) POWER!*) (XMKEXPT BAS EX))
   ((AZEROP (SETQ EX (SFRACTION EX))) (SEXPT BAS A))
   (T (SETQ B (COND
        ((SETQ B (SDENP BAS))
         (SMTIMES2 (SHREXPT (SNUMQ BAS) EX) (SHREXPT B (SMINUS EX))) )
        (T (SHREXPT BAS EX)) ))
      (COND
       ((AZEROP A) B)
       (T (SNUTIM (SEXPT BAS A) B)) ) ) )))

% BAS^EX
% EX is a rational number. BAS is an integer.
(DE SHREXPT (BAS EX) (COND
  ((AONEP BAS) 1)
  ((AEQN BAS -1) (MIN1BAS EX))
  ((MINUSP BAS) (SMTIMES2 (MIN1BAS EX) (SHREXPT (MINUS BAS) EX))) 
  ((SMINUSP EX) (SMTIMES2 (SEXPT BAS -1) (SMROOT BAS (SADD1 EX))))
  (T (SMROOT BAS EX)) ))

% BAS is a positive integer, EX is a positive rational number.
(DE SMROOT (BAS EX) (COND
  ((PAIRP (SETQ BAS (PRIMEFACTORS BAS)))
   (SLET ((N 1) A B)
    (FOREACH Y IN BAS REPLACE (COND
      ((PAIRP Y)
       (SETQ A (STIMES EX (CDR Y)))
       (COND ((NOT (AZEROP (SETQ B (SFIX A))))
              (SETQ N (TIMES N (EXPT (CAR Y) B))) ))
       (COND
        ((AZEROP (SETQ B (SFRACTION A))) 1)
        (T (XMKEXPT (CAR Y) B)) ) )
      (T (XMKEXPT Y EX)) ))
    (COND
     ((NULL (SETQ BAS (DELQIP 1 BAS))) N)
     ((CDR BAS)
      (SMTIMESL (CONS 'TIMES (COND ((AONEP N) BAS) (T (CONS N BAS))))) )
     ((AONEP N) (CAR BAS))
     (T (SNUTIM N (CAR BAS))) ) ) )
  (T (XMKEXPT BAS EX)) ))

% Make Sheep exponent expression. Formerly called MKEXPT.
(DE MKSEXPT (BAS EX) (LIST 'EXPT BAS EX))

(DE XMKEXPT (BAS EX) (COND
  ((AONEP EX) BAS)
  (COLLEX!$ (PROG1 COLLEX!$
    (RPLACA (CDR COLLEX!$) BAS) (RPLACA (CDDR COLLEX!$) EX)
    (RPLACD (CDDR COLLEX!$) NIL) (SETQ COLLEX!$ NIL) ))
  (T (LIST 'EXPT BAS EX)) ))

(DE EXPANDLIM (X) (PROG1 EXPANDLIM!* (SUB1 X) (SETQ EXPANDLIM!* X)))

(DE POWER (X) (PROG1 POWER!* (SUB1 X) (SETQ POWER!* X)))

(DE SIMPI (X) (COND 
  ((SATOM X) X)
  (T (SLET ((A (IGET (CAR X) 'SIMP3FN))) (COND
       (A (FUNCALL A X))
       ((PROGN (SIMPIL X) (SETQ A (IGET (CAR X) 'SIMPXFN)))
        (FUNCALL A (CADR X) X) )
       ((SETQ A (IGET (CAR X) 'SHSMPFN)) (FUNCALL A X))
       (T X) ))) ))

(DE SIMPIL (SXP) (FOREACH X IN (CDR SXP) REPLACE (SIMPI X)))
 
(DC PLUS SIMPXFN (DUMMY X) (SMPLUSL X))

%(DEFLIST '((PLUS SMPLUSL)) 'SHSMPFN)

(DC TIMES SIMP3FN (X)
 (SLET ((L (CDR X)))
  (WHILE
   (AND L (NOT (AZEROP (CAR (RPLACA L (SIMPI (CAR L)))))))
   (UNPUSH L) )
  (COND
   (L 0)
   (T (SMTIMESL X)) ) ))

(DC SETEN SIMP3FN (X) (SETEN (SIMPI (CADR X)) (SIMPI (CADDR X))))

(DC EXPT SIMP3FN (X) (SLET ((EX (SIMPI (CADDR X)))) (COND
   ((AZEROP EX) 1)
   ((AONEP EX) (SIMPI (CADR X)))
   (T (COLLEX (SIMPI (CADR X)) EX X)) )))

(DEFLIST '((PWS CSIPWS) (UNSMP RETARG)) 'SIMP3FN)

(DEFLIST '((EXP XSMEXP) (LOG XSMLOG)) 'SIMPXFN)

(DC EVAL SHSMPFN (X!&) (EVAL (CADR X!&)))

(DC EVAL SIMPXFN (X!& DUMMY) (EVAL X!&))

(DC EXP SHSMPFN (SXP) (XSMEXP (CADR SXP) SXP))

%(DC LOG SHSMPFN (SXP) (XSMLOG (CADR SXP) SXP))

(DE SMEXP (X) (XSMEXP X NIL))
                   
(DE XSMEXP (X SX)
 (SLET (G)
  (COND
   ((AZEROP X) 1)                   
   ((SETQ G (IIXSMEXP X)) G)
   ((NOT (EQCAR X 'PLUS)) (XMKEXP X SX))
   (T (SLET ((A X) B C D)
       (WHILE (SETQ B (CDR A))
        (COND
         ((SETQ C (IIXSMEXP (CAR B)))
          (RPLACD A (CDR B))
          (SETQ D (RPLAD B C D)) )
         (T (SETQ A B)) ) )
       (COND
        (D (COND
            ((NOT (AZEROP (SETQ X (PLUSEND X))))
             (XPUSH D (XMKEXP X SX)) ) )
           (COND
            ((CDR D) (SMTIMESL (CONS 'TIMES D)))
            (T (CAR D)) ) )
        (T (XMKEXP X SX)) ) )) ) ) )

(DE XMKEXP (X SX) (COND
  (SX (RPLACA (CDR SX) X) SX)
  (T (LIST 'EXP X)) ))

(DE IIXSMEXP (X) (COND
  ((EQCAR X 'LOG) (CADR X))
  ((AND (EQCAR X 'TIMES) (SNUMP (CADR X))
    (EQCAR (CADDR X) 'LOG) (NULL (CDDDR X)) )
   (COLLEX (CADR (CADDR X)) (CADR X) (RPLACA X 'EXPT)) ) ))

(NEWSWITCHES (EXPNDLOG "Expand LOG of product to a sum of LOGs"))

(DE SMLOG (X) (XSMLOG X NIL))

(DE XSMLOG (X SX) (COND
  ((AONEP X) 0)
  ((EQCAR X 'EXP) (CADR X))
  ((NOT EXPNDLOG) (XMKLOG X SX))
  ((SNUMP X) (COND
    ((SRATIONALP X)
     (SMPLUS2 (XSMLOG (SNUMQ X) NIL) (SMMINUS (XSMLOG (SDENQ X) SX))) )
    ((FIXP X) (LOGNUM X SX))
    (T (XMKLOG X SX)) ))
  ((EQCAR X 'EXPT)
   (SMTIMES2 (CADDR X) (XSMLOG (CADR X) (RPLACA X 'LOG))) )
  ((NOT (EQCAR X 'TIMES)) (XMKLOG X SX))
  (T (FOREACH Y IN (CDR X) REPLACE (XSMLOG Y NIL))
     (SMPLUSL (RPLACA X 'PLUS)) ) ))

(DE XMKLOG (X SX)
 (COND
  (SX (RPLAD (CDR SX) X NIL) (RPLACA SX 'LOG)) %LH
  (T (LIST 'LOG X)) ))

(DE LOGNUM (X SX) (COND
  ((NOT (PAIRP (SETQ X (PRIMEFACTORS X)))) (XMKLOG X SX))
  ((CDR X)
   (FOREACH Y IN X REPLACE (COND
     ((PAIRP Y) (LIST 'TIMES (CDR Y) (XMKLOG (CAR Y) NIL)))
     (T (XMKLOG Y NIL)) ))
   (CONS 'PLUS X) )
  (T (RPLACD X (NCONS (XMKLOG (CAAR X) SX)))
     (CONS 'TIMES (RPLACA X (CDAR X))) ) ))

(DEFLIST '((SIN ODDXX) (COS EVENXX) (TAN ODDXX) (COT ODDXX)     % JEA
           (SINH ODDXX) (COSH EVENXX) (TANH ODDXX) (COTH ODDXX))% JEA
         'SIMPXFN)

(DE ODDXX (X SX) (ODDXSM X SX (CAR SX)))

(DE ODDXSM (X SX NM) (COND
  ((AZEROP X) 0)
  ((SMMINUSP X) (SMMINUS (ODDXSM (SMMINUS X) SX NM)))
  (SX (RPLACA (CDR SX) X) SX)
  (T (LIST NM X)) ))

(DE EVENXX (X SX) (EVENXSM X SX (CAR SX)))

(DE EVENXSM (X SX NM) (COND
  ((AZEROP X) 1)
  (T (COND ((SMMINUSP X) (SETQ X (SMMINUS X))))
     (COND
      (SX (RPLACA (CDR SX) X) SX)
      (T (LIST NM X)) ) ) ))

%### SIMPEX.SL end
