%### TENBAS.SL

% Most basic routines collected, subset central for STENSOR.

(FUNCTIONS MGETEN TENP SXIOVERW XPREQ)

% Moved from deften:
% Tensors are macros with this definition.
(DMACRO MGETEN (!&MACRO TN !&REST L)
 (LIST 'GETEN (MKQUOTE TN) (COND (L (CONS 'LIST L)))) )

(DE TENP (TN) (AND (IDP TN) (OR (GET TN 'TTYPE) (GET TN 'TNDEFIL))))

% Moved from karlim:
(DE SXIOVERW (N K SW)
% N and K: Inum, SW: boolean Result: XInum
% SW false: N*(N-1)*(N-2)*...*(N-K+1)/1*2*...(K-1)*K
%   i.e. binomial N over K.
% SW true: (N+K-1)*(N+K-2)*...*N/1*2*...(K-1)*K
%   i.e. binomial N+K-1 over K.
 (COND (SW (SETQ N (ISUB1 (IPLUS N K))))) 
 (COND ((ILESSP (SETQ SW (IDIFFERENCE N K)) K) (SETQ K SW)))
 (COND 
  ((IMINUSP K) 0)
  ((IZEROP K) 1)
  ((IONEP K) N)
  (T (SLET ((M N) (L 1))
      (UNTIL
       (IEQN L K)
       (SETQ M (XIQUOTIENT (XITIMES M (IDECR N)) (IINCR L))) )
      M )) ) )

% Moved from tenval:
(DE XPREQ (TN L) (SLET ((A (GET TN 'PREQ)))
  (FOREACH X IN (SETDIFFQ A L) DO (REMPROPXL X 'DEP TN))
  (FOREACH X IN (SETDIFFQ L A) DO (PUTXL X 'DEP TN))
  (PUT TN 'PREQ L) ))

%### TENBAS.SL end
