(in-package 'sl)
%	CHANGES:

% 1991-05-31: Changed SubtractcPol in 'noncomm' (and auxiliaries
% in 'reductions'), so that contents are factored out more often.
% Compiled version 0.521. Former version saved as old--2. /JoeB

% 1991-05-13: Modified SPolInputs in 'noncomm'. Compiled version
% 0.52. Former version saved as old--. /JoeB

% 1991-05-13: Load better module "nbig30" instead of "big". Thus,
% the EXPT to avoid ridiculous message no longer necessary. /JoeB

%(OFF RAISE)
(GLOBAL '(SPairs cSPairs GBasis cGBasis InPols cInPols))

%(COND ((NOT (MEMBER "/usr/local/matte/bergman/" LOADDIRECTORIES!*))
%       (SETQ LOADDIRECTORIES!* (CONS "/usr/local/matte/bergman/" LOADDIRECTORIES!*))))

(COND ((FILEP "/usr/local/matte/bergman/groebncner.sbin") (LOAD groebncner))
      (T (DSKIN "/usr/local/matte/bergman/groebncner.sl")))
(COND ((FILEP "/usr/local/matte/bergman/groebinout.sbin") (LOAD groebinout))
      (T (DSKIN "/usr/local/matte/bergman/groebinout.sl")))
(COND ((FILEP "/usr/local/matte/bergman/groebncmonomials.sbin") (LOAD groebncmonomials))
      (T (DSKIN "/usr/local/matte/bergman/groebncmonomials.sl")))
(COND ((FILEP "/usr/local/matte/bergman/groebreclaim.sbin") (LOAD groebreclaim))
      (T (DSKIN "/usr/local/matte/bergman/groebreclaim.sl")))
(COND ((FILEP "/usr/local/matte/bergman/groebreductions.sbin") (LOAD groebreductions))
      (T (DSKIN "/usr/local/matte/bergman/groebreductions.sl")))
(COND ((FILEP "/usr/local/matte/bergman/groebnoncomm.sbin") (LOAD groebnoncomm))
      (T (DSKIN "/usr/local/matte/bergman/groebnoncomm.sl")))
%(COND ((FILEP "PBseries.sbin") (LOAD "PBseries"))
%      (T (DSKIN "PBseries.sl")))
(DSKIN "PBseries.sl")

%((EQ (CAR str) 'DEB) (DSKIN "/usr/local/matte/bergman/groebdebug.sl"))
%(OFF RAISE)	% since reading in may have put it ON.

(DE CLEARALL () (PROGN (SETQ SPairs NIL) (SETQ cSPairs NIL) (RPLACD GBasis ())
 (RPLACD cGBasis ()) (SETQ InPols ()) (SETQ cInPols ()) (RPLACD MONLIST ())
 (CLEARPBSERIES)
 (COND ((PAIRP HISTORYLIST!*) (RPLACD HISTORYLIST!* NIL))) (RECLAIM) ))

%(DE TI () (DSKIN TESTFOO))
%(SETQ TESTFOO NIL)

(ON SAVEREKVALUES)
%(OFF GC)

(DE GI () (GROEBNERINIT)) (DE GK () (GROEBNERKERNEL)) (DE BO () (BIGOUTPUT))
(DE GF () (GROEBNERFINISH)) (DE CL () (CLEARALL))
(DE DOP (fil) (EVAL (LIST 'DEGREEOUTPREPARE fil)))
(DE ES () (PROGN (DEGREEOUTPUT) (ENDDEGREEOUTPUT)))
(DE STF (fil) (SETQ TESTFOO fil))
(DF SMI (lrg) (PRINTX (SET (CAR lrg) (MONINTERN (CDR lrg)))))

(DE SIMPLE (files)
    (PROG (outfi)
	  (COND ((AND (PAIRP files) (FILEP (CAR files)))
		 (DSKIN (CAR files))
		 (COND ((AND (PAIRP (CDR files)) (STRINGP (CADR files)))
			(SETQ outfi (CADR files))))
		 (GO skip)))
	  (PRIN2 "Now input in-variables and ideal generators in mapleform, thus:")
	  (TERPRI) (PRIN2 "	setinvars v1, ..., vn;") (TERPRI)
	  (PRIN2 "	r1, ..., rm;") (TERPRI)
	  (PRIN2 "where v1, ..., vn are the variables, and r1, ..., rm the generators.")
	  (TERPRI) (MAPLEINPUT)
     skip (SETQ ALGOUTMODE 'MAPLE)
	  (COND (outfi (DOP outfi)) (T (DEGREEOUTPREPARE)))
	  (GROEBNERINIT)
	  (GROEBNERKERNEL)
	  (GROEBNERFINISH)
	  (PRIN2 " - All is OK (I hope). Now you may (e. g.):") (TERPRI)
	  (PRIN2 "   - kill bergman with ^D; or") (TERPRI)
	  (PRIN2 "   - interrupt bergman with ^Z; or") (TERPRI)
	  (PRIN2 "   - clear the memory with (CLEARALL), and run a new (SIMPLE).")
	  (TERPRI) ))

(FLAG '(DEGREEENDDISPLAY) 'USER)

(DE ALLROOS (infile gbfile PBfile Hfile)
   (PROG (oldoutfi PBoutfi Houtfi !*CUSTSHOW oldded)
	 (DSKIN infile)
	 (DOP gbfile)
	 (SETQ PBoutfi (OPEN PBfile 'OUTPUT))
	 (SETQ Houtfi (OPEN Hfile 'OUTPUT))
	 (SETQ ALGOUTMODE 'MAPLE)
	 (ON CUSTSHOW)
	 (COPYD 'DEGREEENDDISPLAY 'ROOSDED)
	 (GROEBNERINIT)
	 (GROEBNERKERNEL)
	 (GROEBNERFINISH)
	 (CLOSE PBoutfi)
	 (CLOSE Houtfi)
	 (COPYD 'DEGREEENDDISPLAY 'oldded) ))

(DE DEGREEENDDISPLAY () (PROGN (DEGREEOUTPUT) (TERPRI)
 (PRIN2 "% No. of Spolynomials calculated until degree ")
 (PRIN2 cDeg) (PRIN2 ": ")  (PRINT NOOFSPOLCALCS)
 (PRIN2 "% Time: ") (PRINT (TIME)) ))

(COPYD 'oldded 'DEGREEENDDISPLAY)

(DE ROOSDED ()
  (PROGN (DEGREEOUTPUT)
	 (SETQ oldoutfi (WRS PBoutfi))
	 (TDEGREECALCULATEPBSERIES cDeg)
	 (WRS Houtfi)
	 (TDEGREEHSERIESOUT cDeg)
	 (WRS oldoutfi)
	 (TERPRI)
	 (PRIN2 "% No. of Spolynomials calculated until degree ")
	 (PRIN2 cDeg) (PRIN2 ": ")  (PRINT NOOFSPOLCALCS)
	 (PRIN2 "% Time: ") (PRINT (TIME)) ))

(ON IMMEDIATEFULLREDUCTION)
(ON RAISE)
% (LOAD NBIG30)
% (EXPT 2 16)	 Just to avoid the message
		% "Unexpected tag 24 found at 0 during gc"
		% seemingly due to a minor bug in big.b

% (SETQ TOPLOOPNAME!* "bergman")

#+ignore
(SAVESYSTEM "test variant 0.521 of non-commutative Bergman with PBseries"
	    "/usr/local/matte/bergman/PBHncbergman"
	    '((SETQ TOPLOOPNAME!* "bergman")
	      (READ-INIT-FILE "ncbergman.init")))

