%### MKSL.SL ========================================================
%
%       MKSL.SL
%       -------
%
%       Copyright (c) 1992 by Jan E. Aman, Institute of Theoretical
%       Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file contains the commands executed in Codemist
%       Standard Lisp (CSL) to build a compiled Sheep Lisp.
%
%====================================================================

(SETQ !*RAISE NIL)

(SETQ !*COMP NIL)

(COND ((NOT (GETD 'INCLUDE)) (RDF "ldint.sl")))

(SETQ !*COMP T)

(INCLUDE "exfn1.sl")
(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "printf.sl")
(INCLUDE "load.sl")

(IFP            %:Atari skip luxury
 (NOT (AND (EQ 'ATARI (SYSTYPE 'MACHINE)) (LESSP (SYSTYPE 'MEMORY) 2)))
 (INCLUDE "../newnam.sl") )

(SETQ !*COMP NIL)

(FOREACH FN IN LOCALFUNCTIONS!* DO
 (COND ((CODEP (GETFN FN)) (REMOB FN))) )       % Remove from oblist.
(SETQ LOCALFUNCTIONS!* NIL)             % Release list storage.

(SETQ DATE!* (DATETIME))

(SAVERUN NIL)

%### MKSL.SL end
