%### SYSTYP.SL ======================================================
%
%       SYSTYP.SL
%       --------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%
%       This file contains the SYSTYPE commands that tells which system,
%       site etc. that you have. Edit it appropriately for your site.
%
%====================================================================

(CPROGN
 (SETSYSTYPE 'SITE 'STOCKHOLM!-PHYSICS) % This is for a typical
 (SETSYSTYPE 'NODE 'STOCKHOLM!-PHYS!-ORION)     % Orion installation
 (SETSYSTYPE 'MACHINE 'ORION)           % (Dept. of Physics,
 (SETSYSTYPE 'MACHINEVERS 1)            % Univ. of Stockholm).
 (SETSYSTYPE 'MVERS 18.2)               % Micro code version.
 (SETSYSTYPE 'OS 'UNIX)
 (SETSYSTYPE 'OSTYPE 'BSD)
 (SETSYSTYPE 'OSVERS 4.2)
 (SETSYSTYPE 'LISPSYSTEM 'CULISP)       % Cambridge University Lisp.
 (SETSYSTYPE 'LISPVERS 1.08) )

%### SYSTYP.SL end
