%### SFAP.SL

% This file is no longer in use. It was used to adapt the Culisp
% file fap.k that converts source code into so called fast loading
% binary files (*.k-files) for Sheep Lisp, cf sidmod.sl. JEA.

(IFP (BOUNDP '!*!l!o!w!e!r)
 (COND ((NOT (FNP '!&FSLOUT1)) (MLOAD 'FAP)))
 (COND ((NOT (FNP '!&FSLOUT1)) (MLOAD 'FAPUC))) )

(GLOBAL '(!*ATOMINDX!* !*FILOC!* !*COMP PUTCHR!* !*MSGCHN!*))

(GLOBAL '(CALLINITSW!* FAPOUTNM!* ARGV!*))

% Command line switches:

% o <file>  Use filename <file> as name of fap output file
(DE !o!_RCINIT () (SETQ FAPOUTNM!* (CHKERARGV)) NIL)

(DE DOFAP () (PROG (X AL)
  (PUT '!o 'INITLINEFN '!o!_RCINIT)
  (SETQ CALLINITSW!* NIL)
  (SETQ FAPOUTNM!* NIL)
  (WHILE ARGV!* (COND ((NOT (TRYINICHSWITCH (SETQ X (CHKERARGV))))
                       (XPUSH AL X) )))
  (COND (CALLINITSW!*
         (EVAL (CONS 'PROGN CALLINITSW!*)) (SETQ CALLINITSW!* NIL) ))
  (COND (AL (SETQ AL (REVERSIP AL))
            (IFAPOUT (OR FAPOUTNM!* (CADR (FILNAM (CAR AL)))) AL) )) ))

(SETQ GOFN!* 'DOFAP)

%(DMM FAPOUT U (LIST 'IFAPOUT (MKQUOTE (CADR U)) (MKQUOTE (CDDR U))))
(DCM FAPOUT U (LIST 'IFAPOUT (MKQUOTE (CAR U)) (MKQUOTE (CDR U))))

(SETFLUIDS MAKEBPS !&MAKEFSL OLDMAKEBPS OLDMLIST!* MLIST!* DFPRINT!*
           !*OLDCOMP !*DEFN MSEARCHLIS!* MEXTLIS!* !*MSGTOFILE)

(DE IFAPOUT (X Y) (PROGN
  (SETQ !*MSGTOFILE NIL)
  (!&FASL!-START (SETQ X (OUTFILENAME NIL X 'K)))
  (WRS !*MSGCHN!*)
  (PRINTF "Creating FAP file: %w" X)
  (SETQ OLDMLIST!* (COPYT MLIST!*))     % Bugfix. JEA.
  (SETQ !*OLDCOMP !*COMP)
  (DECLARE)
%  (COMPILE)
  (SETQ OLDMAKEBPS MAKEBPS)
  (SETQ MAKEBPS !&MAKEFSL)
  (SETQ !*COMP NIL)
  (SETQ DFPRINT!* 'MY!&FSLOUT1)
  (SETQ !*DEFN T)
  (COND
   (Y (FOREACH Z IN Y DO
       (LOADX Z MSEARCHLIS!* (DELETE 'K MEXTLIS!*) T NIL) )
      (FAPEND) )
   (T (PRINTF "Type in expressions or DSKIN files. End with (FAPEND)"
       NIL )) ) ))

(DE FAPEND () (PROGN
  (SETQ MAKEBPS OLDMAKEBPS)
  (SETQ !*COMP !*OLDCOMP)
  (SETQ MLIST!* OLDMLIST!*)
  (SETQ DFPRINT!* NIL)
  (SETQ !*DEFN NIL)
  (!&FASL!-CLOSE T)
  (PRINTF2 "%nAtomindex: %p  Block length: %p%n"
   (LIST !*ATOMINDX!* !*FILOC!*) ) ))

(UNFLUID '(MAKEBPS))

(DE MY!&FSLOUT1 (X) (PROG (A B C D) (RETURN (COND
   ((NOT (PAIRP X)) (!&FSLOUTS X))
   ((EQ (CAR X) 'CPROGN) (FOREACH Y IN (CDR X) DO (MY!&FSLOUT1 Y)))
   ((AND (EQ (CAR X) 'PUTD)
         (EQCAR (SETQ A (CADR X)) 'QUOTE)
         (EQCAR (SETQ B (CADDR X)) 'QUOTE)
         (FLAGP (SETQ B (CADR B)) 'COMPILE)
         (EQCAR (SETQ C (CADDDR X)) 'QUOTE)
         (EQCAR (SETQ C (CADR C)) 'LAMBDA) )
    (!&COM2 (SETQ A (CADR A))
            (COND
             ((EQ B 'FEXPR) (CONS 'LAMBDAQ (CDR C)))
             (T C) ) )
    (COND ((MEMQ B '(MACRO MMACRO))
           (!&FSLOUTS
            (LIST 'SETQ A
             (LIST 'CONS (COND ((EQ B 'MACRO) '(QUOTE MACRO!:))
                               (T '(QUOTE MMACRO!:)) )
                         A ) )) )) )
   ((AND (EQ (CAR X) 'PUTC)
         (EQCAR (SETQ A (CADR X)) 'QUOTE)
         (EQCAR (SETQ B (CADDR X)) 'QUOTE)
         (FLAGP (CADR B) 'COMPILE)
         (EQCAR (SETQ C (CADDDR X)) 'QUOTE)
         (EQCAR (SETQ C (CADR C)) 'LAMBDA) )
    (CLEARBUFF) (PACK (CADR A)) (PACK PUTCHR!*) (PACK (CADR B))
    (!&COM2 (SETQ D (MKATOM)) C)
    (!&FSLOUTS (LIST 'PUT A B (MKQUOTE D))) )
   ((EQUAL X (SETQ A (MACEXPD1 X))) (!&FSLOUTS X))
   (T (MY!&FSLOUT1 A)) ))))

(FLAG '(FAPEND) 'IGNORE)

(FLAG '(DM DCM DMM) 'EVAL)

(FLAG '(EXPR FEXPR MACRO MMACRO) 'COMPILE)

FIN

%### SFAP.SL end
