%### SMODUL.SL

% This file is no longer in use. It was used to make so called
% side modules, that is a Cambridge Lisp module that is not seen
% until it is called upon, normally with the LOAD command. This
% version is more general and flexible but with greater risk for
% strange problems as compared to the used version sidmod.sl. JEA.

(SETGLOBALS
 (RESIDEFUNCTIONS!* (RESIDETENSORS))% Default functions for MKSIDEFAP.
 !*COMP
 PUTCHR!*
 SIDE!-NAME!*
 SIDE!-CHN!*
 OLDMODULNAM!*
 !*SIDEFN
 !*SIDEINIM
 SIDEFL!* )

(SETFLUIDS
 DFPRINT!*
 !*OLDCOMP
 !*DEFN
 !*MSGTOFILE )

% To make a fast loading file (to be available after a LOAD command
% only). Arguments are one or more source files, name will be
% determined from first specified file name. Added by JEA.
(DS MKSIDEFAP (FL1 !&REST FLL) (XMKSIDEFAP 'FL1 'FLL))

(DE XMKSIDEFAP (FL1 FLL)
 (SLET (FIL!*)
  (IMKSIDEFAP (CADR (FILNAM FL1)) (CONS FL1 FLL)) ) )

% Expr version of MKSIDEFAP with module name and file list as arguments.
(DE IMKSIDEFAP (MN FLL) (H!-SIDEFAP MN RESIDEFUNCTIONS!* FLL))

(DS SIDEFAP (MN RS !&REST FLL) (H!-SIDEFAP 'MN 'RS 'FLL))

(DE H!-SIDEFAP (MODULNAM!* RS FLL)
 (SLET ((OST (FOREACH FN IN RS COLLECT (FUNCALL FN NIL)))
        (EX (DELETE FASLOUTEXT!* (DELETE 'PSEUDO!-FILE MEXTLIS!*)))
        (OML (COPYT MLIST!*)) )
  (H!-SIDEMODULE MODULNAM!* !*SIDEFN NIL)
  (FOREACH FIL IN FLL DO (LOADX FIL MSEARCHLIS!* EX 'N NIL))
  (ENDSIDEMODULE)
  (FOREACH FN IN RS COLLECT
   (SETQ FN (FUNCALL FN OST)) (UNPUSH OST) FN)
  (SETQ MLIST!* OML) ) )

(DS SIDEMODULE (MN !&OPTIONAL SW FL) (H!-SIDEMODULE 'MN 'SW 'FL))

(DE H!-SIDEMODULE (MN SW FL)
 (PROGN
  (COND
   ((NOT (IDP MN))
    (ERRORFT 445 "Module name %p is not an identifier" MN) ) )
  (SETQ OLDMODULNAM!* MODULNAM!*)
  (SETQ MODULNAM!* MN)
  (SETQ !*SIDEFN SW)
  (SETQ !*SIDEINIM (NOT FL))
  (SETQ !*MSGTOFILE NIL)
  (SETQ SIDE!-NAME!* MN)
  (SETQ !*OLDCOMP !*COMP)
  (SETQ !*COMP T)
  (SETQ DFPRINT!* 'SIDE!-OUT)
  (SETQ !*DEFN T)
  (SETQ SIDEFL!* NIL)
  (MODULE MN)
  (COND ((NOT !*SIDEINIM)
         (SETQ SIDE!-CHN!* (OPEN (OUTFILENAME NIL FL 'ML) 'OUTPUT))
         (CHANOUT SIDE!-CHN!*
          (PRINTF "%%### %w.ML Side effects for module %w%n%n" MN MN) )
         (COND ((NOT !*SIDEFN)
                (SETQ FL (CONCATID 'START!% MN))
                (PUTD FL 'EXPR '(LAMBDA () NIL))
                (SIDE!-OUTS (LIST FL)) )) ))
  MN ))

(DE ENDSIDEMODULE () (SLET (FN)
  (COND
   (!*SIDEINIM
    (SETQ FN (CONCATID SIDE!-NAME!* PUTCHR!* 'PSEUDO!-FILEFN))
    (FLUID (LIST FN))
    (XPUSH SIDEFL!* (LIST 'SETQ FN (CONSA 'FASL SIDE!-NAME!* FN 0)))
    (PUTD FN 'EXPR (LIST 'LAMBDA () (CONS 'PROGN (REVERSIP SIDEFL!*))))
    (PUT SIDE!-NAME!* 'PSEUDO!-FILEFN FN)
    (SETQ SIDEFL!* NIL) )
   (T (CHANOUT SIDE!-CHN!* (PRINTF "%%### %w.ML End%n" SIDE!-NAME!*))
      (CLOSE SIDE!-CHN!*) ) )
  (SETQ !*COMP !*OLDCOMP)
  (SETQ DFPRINT!* NIL)
  (SETQ !*DEFN NIL)
  (SETQ MODULNAM!* OLDMODULNAM!*)
  (ENDMODULE) ))

(DE SIDE!-OUTS (X) (COND
  (!*SIDEINIM (XPUSH SIDEFL!* X))
  (T (CHANOUT SIDE!-CHN!* (PRINT X) (TERPRI))) ))

(DE SIDE!-OUT (X) (SLET (A B C D) (COND
  ((NOT (PAIRP X)) (SIDE!-OUTS X))
  ((EQ (CAR X) 'CPROGN) (FOREACH Y IN (CDR X) DO (SIDE!-OUT Y)))
  ((AND (EQ (CAR X) 'PUTD)
        (EQCAR (SETQ A (CADR X)) 'QUOTE)
        (EQCAR (CAR (SETQ B (CDDR X))) 'QUOTE)
        (EQCAR (CADR B) 'QUOTE) )
   (COND
    (!*SIDEFN (SETQ D (CADR A)))
    (T (SETQ D (CONCATID SIDE!-NAME!* '!% (CADR A)))
       (SIDE!-OUTS (LIST 'MOVD A (MKQUOTE D))) ) )
   (PUTD D (CADAR B) (CADADR B)) )
  ((AND (EQ (CAR X) 'PUTC)
        (EQCAR (SETQ A (CADR X)) 'QUOTE)
        (EQCAR (SETQ B (CADDR X)) 'QUOTE)
        (FLAGP (CADR B) 'COMPILE)       
        (EQCAR (SETQ C (CADDDR X)) 'QUOTE)
        (EQCAR (SETQ C (CADR C)) 'LAMBDA) )
   (SETQ D (COND
     (!*SIDEFN (CONCATID (CADR A) PUTCHR!* (CADR B)))
     (T (CONCATID SIDE!-NAME!* '!% (CADR A) PUTCHR!* (CADR B))) ))
   (PUTD D 'EXPR C)
   (SIDE!-OUTS (LIST 'PUT A B (MKQUOTE D))) )
  ((EQUAL X (SETQ A (MACEXPD1 X))) (SIDE!-OUTS X))
  (T (SIDE!-OUT A)) )))

(FLAG '(ENDSIDEMODULE) 'IGNORE)

%### SMODUL.SL end
