%### SYTYPA.SL ======================================================
%
%       SYTYPA.SL
%       --------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%
%       This file contains the SYSTYPE commands that tells which system,
%       site etc. that you have. Edit it appropriately for your site.
%       This is the Atari version of systyp.sl.
%
%====================================================================

% Note! Installation dependent directory specifications in file
% atari.sl!

(CPROGN
 (SETSYSTYPE 'SITE 'PRIVATE)
 (SETSYSTYPE 'MACHINE 'ATARI)
 (SETSYSTYPE 'MACHINEVERS 'ST4)
 (SETSYSTYPE 'OS 'TOS)
 (SETSYSTYPE 'MEMORY 4)         % Size of Ram memory is more interesting
                                % than MACHINEVERSion. Consulted for
                                % auto-excising. See also STENSOR-switch
                                % ECONOMY.
%(SETSYSTYPE 'NOHARDSK T)       % Uncomment this on Ataris with ONLY
                                % floppy. Hard disk icons use file stack
                                % space, so affecting at least Stensor
                                % installation procedure.
 (SETSYSTYPE 'LISPSYSTEM 'CULISP)       % Cambridge University Lisp.
 (SETSYSTYPE 'LISPVERS 0.90) )

%### SYTYPA.SL end
