;### INCLDE.L =======================================================
;
;       INCLDE.L
;       --------
;
;       Copyright (c) 1982 by Inge Frick, Institute of Theoretical
;       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
;
;       This file defines a temporary version of INCLUDE that is needed
;       for bootstrapping of file slmacs.o.
;
;====================================================================

(declare (special $EOF$ *IPRN *ECHO))

(setq *IPRN t)  ; INCLUDE normally prints out.

; This definition of INCLUDE is temporary, to be used in bootstrapping.
; See LOAD.SL for the final definition.
(defun INCLUDE fexpr (u)
 (setq u (car u))
 (let ((piport (infile u)))
  (princ "Including file: ") (princ u) (terpri)   ; JEA
  (do ((y (READ) (READ)) (x))
      ((eq y $EOF$) (close piport))
      (cond
       ((not (dtpr (setq x (errset (eval y) t))))
        (cond ((not *ECHO) (PRINT y)))
        (close piport)
        (setq piport nil)
        (ERROR 0 "Error return") )
       (*IPRN (PRINT (car x))) ) )
  (princ u) (princ " done include") (terpri)  ;JEA
  "Finished loading") )

;### INCLDE.L end
