%### NEWNAM.SL

% This file contain renamings of old functions

(BOTHTIMES (SETGLOBALS (DOCOMPLAIN!-MSG!* 10)))

(DMACRO NEWFNAME (CODE OLD ARGS NEW !&OPTIONAL STR)
 (OUTD!-HELP CODE OLD ARGS NEW STR NEW) )

(DMACRO OUTDNAME (CODE OLD ARGS !&OPTIONAL STR)
 (OUTD!-HELP CODE OLD ARGS (CONCATID 'OLD!- OLD) STR NIL) )

(BOTHTIMES
(DE OUTD!-HELP (CODE OLD ARGS NEW STR NEWS)
 (SLET ((QOLD (MKQUOTE OLD)) (QNEW (MKQUOTE NEW)))
  (SETQ STR (LIST 'NEWNAME!-MSG QOLD (MKQUOTE NEWS) (MKQUOTE STR)))
  (SETQ ARGS (COND ((LISTP ARGS)
                    (NCONS (LIST 'DE OLD ARGS STR (CONS NEW ARGS))))))
  (XPUSH ARGS
   (LIST (COND (ARGS 'CMMACRO) (T 'DMACRO)) OLD '(!&MACRO !&REST L!&AR)
    STR (LIST 'CONS QNEW '(CDR L!&AR)) ) )
  (COND ((NOT NEWS) (SETQ ARGS (CONSA
           (LIST 'COND (LIST (LIST 'AND (LIST 'NOT (LIST 'FNP QNEW))
                                   (LIST 'FNP QOLD) )
                             (LIST 'MOVD QNEW QOLD) ))
           (LIST 'REMD QOLD)
           ARGS))))
  (CONSA 'CPROGN
   (LIST 'DPUT OLD 'NEWNMSG CODE)
   ARGS) ) ) )

(BOTHTIMES
(DE NEWNAME!-MSG (OLD NEW STR)
 (SLET ((CODE (MIN (GET OLD 'NEWNMSG) DOCOMPLAIN!-MSG!*)))
  (COND ((OR (IGREATERP CODE 1) (AND (AONEP CODE) !*COMP))
         (COND ((OR (ILESSP CODE 3) (AND (NOT !*COMP) (IEQN CODE 3)))
                (PUT OLD 'NEWNMSG 0) ))
         (COND
          (STR (WARNINGFT 49 "%w" STR))
          (NEW (WARNINGFT 50 "%p is now replaced by %p" OLD NEW))
          (T (WARNINGFT 52 "%p has been outdated" OLD)) )
         (COND
          ((IGREATERP CODE 4) (ERRORFT 420 "Change your code"))
          ((IEQN CODE 4)
           (WARNINGFT 54
            "This will be an error quite soon%nChange your code" ) )
          (T (WARNINGFT 55 "Please change your code")) ) )) ) ))

(BOTHTIMES (FLAG '(NEWFNAME OUTDNAME) 'EVAL))

(NEWFNAME 4 CONCATL T CONCATIDL)

(NEWFNAME 4 XLET T SLET)

(NEWFNAME 2 XWARNING T WARNINGF)

% Revised version 56:
(NEWFNAME 2 XERROR T ERRORFT)

% Version 56:
(NEWFNAME 2 I!$PROGN T MKPROGN)

(NEWFNAME 2 ERRORF T ERRORFT)

(OUTDNAME 2 WARNINGF T)

(NEWFNAME 2 YESP T SYESP)

(NEWFNAME 2 NOP T SNOP)

(NEWFNAME 2 TR T TRA)

(NEWFNAME 2 UNTR T UNTRA)

%### NEWNAM.SL end
