



















          XXXXXX   XX   XX   XXXXXXX   XXXXXXX   XXXXXX
         XX        XX   XX   XX        XX        XX   XX
         XX        XX   XX   XX        XX        XX   XX
          XXXXX    XXXXXXX   XXXXX     XXXXX     XXXXXX
              XX   XX   XX   XX        XX        XX
              XX   XX   XX   XX        XX        XX
         XXXXXX    XX   XX   XXXXXXX   XXXXXXX   XX



                              GUIDE


                        Author: I. Frick

                Institute of Theoretical Physics
                     University of Stockholm
                           Vanadisv. 9
                       S-113 46  Stockholm
                             Sweden



                                   CONTENTS



CHAPTER 1       EXAMPLES ON HOW TO USE SHEEP

        1.1     HOW TO COMPUTE THE RICCI TENSOR FROM A GIVEN 
                METRIC.  . . . . . . . . . . . . . . . . . . . . . 1-1
        1.2     A SUBSTITUTION . . . . . . . . . . . . . . . . . . 1-4
        1.3     A TETRAD CALCULATION . . . . . . . . . . . . . . . 1-6
        1.3.1     Stating The Problem  . . . . . . . . . . . . . . 1-6
        1.3.2     An Input File  . . . . . . . . . . . . . . . . . 1-7
        1.3.3     Dialogue . . . . . . . . . . . . . . . . . . . . 1-8
        1.4     A PERTURBATION CALCULATION . . . . . . . . . . .  1-18
        1.4.1     Stating The Problem  . . . . . . . . . . . . .  1-18
        1.4.2     An Input File  . . . . . . . . . . . . . . . .  1-18
        1.4.3     Dialogue . . . . . . . . . . . . . . . . . . .  1-19












                            CHAPTER 1

                  EXAMPLES ON HOW TO USE SHEEP



In the following examples  "<cr>"  stands  for  carriage  return,
"<sp>" stands for space and "<alt>" stands for altmode (or escape
or control-[ on some terminals).  In the left  hand  column  user
input  is underlined, the rest in that column is computer output.
The right hand column only contains comments.



1.1  HOW TO COMPUTE THE RICCI TENSOR FROM A GIVEN METRIC.

We want to compute the Ricci tensor for the metric:

  2      2   -1  2   2       2     2           2
dS  _= AdT  -A  dR  -R (dTHETA  +SIN (THETA)dPHI )

where A is a function of T and R.

First log in to the computer.  Then do the following:

Input/Output                  Comment



 ____________.RUN CORD<cr>                 Start the  version  of  SHEEP  that
                              computes  tensor  components  in  a
                              coordinate frame.

SHEEP-77-01-26                Latest update of SHEEP

 ________________________*(ON NOZERO DIAGONAL)<cr>     Turn on  the  switches  NOZERO  and
                              DIAGONAL.
                              NOZERO  means  that  only  non-zero
                              components are printed by the write
                              command.
                              DIAGONAL tells the system that  off
                              diagonal  components  of the metric
                              are zero,  so  that  only  diagonal
                              components have to be inserted.

NIL                           A list of the arguments to ON  that
                              were  on  previously.  DIAGONAL and
                              NOZERO where both off so  the  list
EXAMPLES ON HOW TO USE SHEEP                             Page 1-2


                              is empty i.e. NIL.

 ______________*(MAKE RIC)<cr>               Make the components  of  the  Ricci
                              tensor.

G
 00                           The   system   can't    find    the
                              components  of  the  metric,  so it
                              asks for them.

 ______=A$<cr>                       "=" prompter means that input  goes
                              to the formula input function FOIN,
                              that reads formulas in mathematical
                              (infix)  notation.   "$"  indicates
                              end of the  input  to  FOIN.   This
                              input means that G00 is set to A.

G
 11                           Ask for G11.  As  DIAGONAL  is  on,
                              the system doesn't ask for G01, G02
                              or G03,  it  knows  that  they  are
                              zero.   The  system  never asks for
                              G10 as that component is  found  by
                              symmetry.

 _________=-1/A;<cr>                    ";" is another way to end input  to
                              FOIN, it tells the system to:

  -1
-A                            Write out the input and

 _____?$<cr>                        ask  for  confirmation.   The   "?"
                              prompter       indicates       that
                              confirmation or the correct formula
                              is expected.
                              By writing only the  end  character
                              "$",   the   previous   formula  is
                              confirmed.

G
 22                           Asks for G22

 _________=-R^2<alt>                    "<alt>"  has  the  same  effect  as
                              "$<cr>".

G
 33

 __________________=-R^2*SIN(S)^A;<cr>           S is  used  as  third  variable  as
                              there  is  no theta on the printer.
                              End with ";" to see if the input is
                              correct.

  2   A
-R SIN S                      It was not correct.   There  is  an
                              exponent A instead of 2.
EXAMPLES ON HOW TO USE SHEEP                             Page 1-3


 __________________?-R^2*SIN(S)^2;<cr>           Input the corrected formula with  a
                              ";"  at end to see if it is correct
                              this time.

  2   2
-R SIN S                      O.k.

 _____?<alt>                        Confirm.

GDF                           The system starts to make GDF  i.e.
                              the derivatives of the metric.

A DECLARE FUNCTION            The  system  didn't  know  how   to
                              differentiate A.

    __________________NOW*(FUNS (A T R))<cr>        Declare A as a function of T and R.

T DECLARE VARIABLE            T was not known as variable to  the
                              system

    ________________NOW*(VARS T R S)<cr>          Declare T R and S as variables 0, 1
                              and 2.

 ENDED                        The system has finished making GDF.

GAM  ENDED                    Makes Christoffel  symbol  of  1:st
                              type.

GDET  ENDED                   Makes determinant of the metric.

GINV  ENDED                   Makes 1/GDET.

GDET LOST                     Delete GDET as it isn't needed  any
                              more.  This saves space.  (There is
                              a KEEP command that can be used  to
                              inhibit  the  automatic deletion of
                              some tensors.)

GUU  ENDED                    The contravariant metric.

GINV LOST

GDF LOST

GAMU  ENDED                   Christoffel symbol of 2:nd type

RIE  ENDED                    Covariant Riemann tensor.

GAMU LOST

GAM LOST

RIC  ENDED                    Covariant Ricci tensor.

NIL                           Finished
EXAMPLES ON HOW TO USE SHEEP                             Page 1-4


 _______________*(WRITE RIC)<cr>              Write the Ricci tensor

               -1       -2   2      -1
R  =1/2AA    +R  AA   -A  A    +1/2A  A
 00      ,RR       ,R      ,T          ,TT

       -1 -1
R  = -R  A  A
 01          ,T

       -1 -1      -4   2      -3          -1
R  = -R  A  A   +A  A    -1/2A  A    -1/2A  A
 11          ,R      ,T          ,TT         ,RR

R  =1 -A -RA
 22         ,R

       2         2            2
R  =SIN (S) -RSIN (S)A   -ASIN (S)
 33                   ,R

NIL                           Finished WRITE command.

 ________________*(WMAKE RSCL)<cr>             Make  and   write   the   curvature
                              scalar.

RIE LOST

RICM  ENDED                   Mixed Ricci tensor

      -2          -2     -1       -3   2   -2
R= -2R   +A    +2R  A +4R  A   -2A  A    +A  A
           ,RR              ,R       ,T       ,TT

NIL                           Finished WMAKE command.

 _________________________*(SAVE SWRIC RIC RSCL)<cr>    Save  RIC  and  RSCL  in  the  file
                              SWRIC.LAM for later use.

(SWRIC NIL)                   Saved



1.2  A SUBSTITUTION

If A is set to 1-2M/R, then  the  previous  example  becomes  the
Schwarschild  metric.   Let  us do this substitution in the Ricci
tensor and see if it becomes zero.

Input/Output                  Comments



 __________________________*(SETSUB ESUL (DIFF 2))<cr>   Define  ESUBS  substitutions,  i.e.
                              substitutions   that   change   the
                              expressions in memory, as  distinct
                              from substitutions that only affect
EXAMPLES ON HOW TO USE SHEEP                             Page 1-5


                              the   output.    (DIFF 2)   defines
                              substitutions  of derivatives up to
                              order 2.

         ______1  FOR  =A<alt>               1 means that this will be the first
                              substitution   pair   on  the  ESUL
                              substitution list.  For A  and  its
                              derivatives

               ___________  SUBSTITUTE  =1-2M/R<alt>    substitute    1-2M/R    and     its
                              derivatives.

M DECLARE FUNCTION            We had forgotten to declare M as  a
                              function.

    ______________NOW*(FUNS (M))<cr>            Declare  M  as  a  function  of  no
                              variables i.e. a constant.

6                             The  ESUL  substitution  list   now
                              contains 6 substitution pairs.

 _______________*(PRSUB ALL)<cr>              Print all pairs on the substitution
                              list.

ESUL                          The ESUL substitution list.

1  FOR  A     SUBSTITUTE  0
         ,TT

2  FOR  A     SUBSTITUTE  0
         ,RT

                              -3
3  FOR  A     SUBSTITUTE   -4R  M
         ,RR

4  FOR  A    SUBSTITUTE  0
         ,T

                           -2
5  FOR  A    SUBSTITUTE  2R  M
         ,R

                            -1
6  FOR  A  SUBSTITUTE  1 -2R  M

NIL

 ______________*(ON ESUBS)<cr>               Turn on the ESUBS  switch  so  that
                              ESUBS  substitutions  will  be made
                              every time that the  simplification
                              function SIMP is called.

NIL                           ESUBS was off previously.
EXAMPLES ON HOW TO USE SHEEP                             Page 1-6


 _______________*(LSIMP RIC)<cr>              Call SIMP  (i.e.  in  our  case  do
                              substitutions)  for  each component
                              of RIC.

RIC  ENDED

NIL

 ___________*(WRITE)<cr>                  Write RIC.

RIC ALL FOUND ZERO            All specified  components  (in  our
                              case  all  RIC)  were zero.  As the
                              switch NOZERO is on,  no  component
                              is  written  but  a message that no
                              non-zero  component  was  found  is
                              given.



1.3  A TETRAD CALCULATION

1.3.1  Stating The Problem

The Bondi metric is:

  2      -1 2B   2 2 2G   2    2B         2 2G
dS  _= (VR  E   -U R E  )dT  +2E  dTdR +2UR E  dTdH -

  2  2G  2   -2G   2     2
-R (E  dH  +E   SIN (H)dF )

where U, V, B and G are arbitrary functions of T, R and H (we use
T,  R,  H,  F,  B  and  G, instead of u, r, theta, phi, betha and
gamma).
We use a tetrad with two null vectors and  two  orthogonal  space
like vectors so that

  2    AB                2    2
dS  _= H  W W  _= 2W W  -W   -W
          A B     0 1   2    3

A set of covariant vectors fulfilling this condition is:

      B
W  _= E dT
 0

      B      -1
W  _= E (1/2VR  dT +dR)
 1

       G
W  _= RE (-UdT +dH)
 2

EXAMPLES ON HOW TO USE SHEEP                             Page 1-7


       -G
W  _= RE  SIN(H)dF
 3

The problem is to calculate the tetrad components of the  Riemann
tensor for this metric.



1.3.2  An Input File

As the metric is a bit complicated, first prepare a file with the
commands  that  define  the  metric  and then load that file into
SHEEP.  Of course it is possible to input the  commands  directly
into SHEEP instead of using a file, but a file makes it easier to
start again if something goes wrong.
Use a text editor e.g. SOS, to make the file BONDI.HNL


File content                  Comment


(TITLE "BONDI METRIC IN HALF NULL TETRAD")        The       title
                              defined by this command, is printed
                              on the TTY when the file is  loaded
                              and on the line printer output from
                              the LPTWRITE command.

(VARS T R H F)                Define the variables.

(FUNS (B T R H) (G T R H) (U T R H) (V T R H))    Declare B, G, U
                              and V as functions of T, R and H.

(ON NOZERO)                   Turn on the NOZERO switch, so  that
                              only   non   zero   components  are
                              printed by the WRITE command.

(RPL ZDD)                     Define the covariant components  of
                              the tetrad vectors, defined by
E^B$
0$                                      i
0$                            W  = Z  dX
0$                             A    Ai
1/2V/R*E^B$
E^B$
0$
0$
-U*R*E^G$
0$
R*E^G$
0$
0$
0$
0$
R/E^G*SIN H$
EXAMPLES ON HOW TO USE SHEEP                             Page 1-8


(HNULL)                       Define HDD and HUU to be the metric
                              for  a tetrad with two null vectors
                              and   two   orthogonal   space-like
                              vectors as tetrad vectors.  This is
                              the last command on the file.



1.3.3  Dialogue



With the file completed, we now start the dialogue with SHEEP

Input/Output                  Comment


 _____________.RUN FRAME<cr>                Start the  version  of  SHEEP  that
                              computes  tensor  components  in  a
                              moving (tetrad) frame.

SHEEP-77-01-26                Latest update of SHEEP

 _______________________*(DSKIN (BONDI.HNL))<cr>      Call in the file BONDI.HNL from the
                              disk  memory.   This  will generate
                              the following output.

BONDI METRIC IN HALF NULL TETRAD        The title

NIL                           The value of the title  command  is
                              the  previous  title.  As there was
                              no previous  title,  the  value  is
                              NIL.























(T R H F)                     The value of the  VARS  command  is
EXAMPLES ON HOW TO USE SHEEP                             Page 1-9


                              the list of variables.























































(V U G B)                     The value of the  FUNS  command  is
EXAMPLES ON HOW TO USE SHEEP                            Page 1-10


                              the list of declared functions.























































NIL                           NOZERO was not on previously.
EXAMPLES ON HOW TO USE SHEEP                            Page 1-11


























































ZDD  ENDED                    ZDD is inserted.
EXAMPLES ON HOW TO USE SHEEP                            Page 1-12


























































NIL                           Value of the RPL command.
EXAMPLES ON HOW TO USE SHEEP                            Page 1-13


























































NIL                           Value of the HNULL command.
EXAMPLES ON HOW TO USE SHEEP                            Page 1-14


























































FINISHED-LOADING              Value of the DSKIN  command.   This
EXAMPLES ON HOW TO USE SHEEP                            Page 1-15


                              ends  the loading of the file.  Now
                              start the computations.






















































 _______________*(WMAKE GDD)<cr>              Make and print the metric tensor to
EXAMPLES ON HOW TO USE SHEEP                            Page 1-16


                              control  that  the  choice of frame
                              vectors is correct.
        -1 2B   2 2G 2
G   _= VR  E   -R E  U
 00
       2B
G   _= E
 01
       2 2G
G   _= R E  U
 02
         2 2G
G   _=  -R E
 22
         2 -2G   2
G   _=  -R E   SIN (H)
 33

 ______________*(MAKE RIC)<cr>               Make the Ricci tensor.

ASD  ENDED                    ASD (antisymmetric  differentiation
                              of ZDD) is made.

ZUD  ENDED                    The first index of ZDD  is  raised,
                              to form ZUD.

ZDET  ENDED                   The determinant of ZUD.

ZINV  ENDED                   1/ZDET.

ZDET LOST                     ZDET is deleted as it is not needed
                              any more.

ZDU  ENDED                    The contravariant components of the
                              tetrad  vectors.   The  inverse  of
                              ZUD.

ZINV LOST

ZUD LOST

APZ  ENDED                    Antisymmetric tensor product of two
                              ZDU.

LIE  ENDED                    The structure coefficients for  the
                              outer derivative.

ASD LOST

APZ LOST

GAM  ENDED                    The Ricci rotation coefficients.
EXAMPLES ON HOW TO USE SHEEP                            Page 1-17


RIE                           The  calculation  of  the   Riemann
                              tensor has started, but

NO FREE STG LEFT              there wasn't enough storage.

(RIE 1 2 1 2)                 The  components  before  this  were
                              made, but this component was

NOT MADE                      not made.

 ______________*(MCORE 10)<cr>               Get and allocate 10 K more memory.

 ______________*(CONTINUE)<cr>               Continue the calculation, starting

RIE  ENDED                    with the 1 2 1 2 component of  RIE,
                              and finish RIE.

NIL                           The calculation is  finished.   NIL
                              is the value of the MAKE command.

 _______________________*(WRITE RIE 0 1 0 1)<cr>      Write the first component of RIE.

            -3 -2B    -2 -2B       -1 -2B        -2B
R     _=  -VR  E    +VR  E   B   -VR  E   B    +2E   UB    +
 0101                        ,R           ,RR         ,HR

  -2B          -2B       -2 -2G   2   -2 -2B         -1 -2B
+E   U  B   +2E   B    -R  E   B    +R  E   V   -1/2R  E   V    -
      ,R ,H        ,RT          ,H           ,R             ,RR

  -1 -2B            2 2G-4B   2
-R  E   V  B   +3/4R E     U
         ,R ,R              ,R

NIL                           Value of WRITE command.

 __________________________*(LPTWRITE ZDD RIE GAM)<cr>   Write ZDD, RIE and GAM out  onto  a
                              file  that  is  sent  to  the  line
                              printer when logging out  from  the
                              computer.

ZDD  ENDED

RIE  ENDED

GAM  ENDED

((LAM03 .  LPT:) NIL)         Value    of    LPTWRITE    command.
                              LAM03.LPT   is   the  name  of  the
                              generated file.

__^C                            Leave SHEEP.
EXAMPLES ON HOW TO USE SHEEP                            Page 1-18


1.4  A PERTURBATION CALCULATION

1.4.1  Stating The Problem

The Levy metric is:

  2    2U  2   2K-2U   2    2    2 -2U  2         2       2
dS  _= E  dT  -E     (dR  +dZ ) -R E   dF  +X(H00dT  +H11dR  +

     2       2                                     2
H22dZ  +H33dF  +2H01dTdR +2H02dTdZ +2H12dRdZ) + O(X )

where X is a small parameter and U, K, H00, H01, H02,  H11,  H12,
H22  and H33 are functions of T, R and Z.  The dependence on T is
small, i.e. derivatives with respect to T are multiplied with X.
The problem is to compute the Ricci tensor to the first order  in
X for this metric.



1.4.2  An Input File

As the metric is complicated and as the contravariant metric  has
to  be  computed  by hand, first prepare a file with the commands
that define the co- and contravariant metrics and then load  that
file into SHEEP.
Make the file LEVY


File content                  Comment


(TITLE "LEVY METRIC")         Title

(VARS T R Z)                  Variables
                              (FUNS (U T R Z) (K T R Z) (H00 T R
                              Z) (H01 T R Z) (H02 T R Z)
(H11 T R Z) (H12 T R Z) (H22 T R Z) (H33 T R Z))  Functions

(TPSINIT TENSORS)             Initiate all tensors  as  truncated
                              power series with no terms of lower
                              order than zero.

(PUT '& 'DSHIF '(-1 NIL NIL NIL))       The  -1  in   the   first
                              position of the list
                                                      (-1 NIL NIL NIL)
                              means that the order of a  term  is
                              raised   one   step   when   it  is
                              differentiated with respect to  the
                              zeroth  variable  i.e. with respect
                              to  T.   The  NIL  in   the   other
                              positions  of  the list, means that
                              differentiating with respect to the
                              other  variables doesn't affect the
                              order of a term.
EXAMPLES ON HOW TO USE SHEEP                            Page 1-19


(RPL (0) GDD)                 Insert the zero order terms of  the
                              covariant metric.
EXP(2U)$
0$
0$
0$
-EXP(2K-2U)$
0$
0$
-EXP(2K-2U)$
0$
-R^2*EXP(-2U)$

(RPL (0) GUU)                 Insert  zero  order  terms  of  the
                              contravariant metric.
EXP(-2U)$
0$
0$
0$
-EXP(2U-2K)$
0$
0$
-EXP(2U-2K)$
0$
-R^(-2)EXP(2U)$

(RPL (1) GDD)                 Insert first order terms.
H00$
H01$
H02$
0$
H11$
H12$
0$
H22$
0$
H33$

(RPL (1) GUU)                 Insert first  order  terms  of  the
                              contravariant metric.
-H00*EXP(-4U)$
H01*EXP(-2K)$
H02*EXP(-2K)$
0$
-H11*EXP(4U-4K)$
-H12*EXP(4U-4K)$
0$
-H22*EXP(4U-4K)$
0$
-R^(-4)H33*EXP(4U)$           End of the file.



1.4.3  Dialogue

EXAMPLES ON HOW TO USE SHEEP                            Page 1-20


With the file completed, we now start the dialogue with SHEEP

Input/Output                  Comment



 _______________.RUN CORD 40<cr>              Start the  CORD  version  of  SHEEP
                              with  40  K  memory as this will be
                              needed in the calculation.

SHEEP-77-01-26                Latest update of SHEEP

 ________________*(DSKIN LEVY)<cr>             Call in the file LEVY from the disk
                              memory.   This  will  generate  the
                              following output.

LEVY METRIC                   The title

NIL

(T R Z 3)                     The variables.  We didn't give  the
                              third variable a name.

(H33 H22 H12 H11 H02 H01 H00 K U)       The declared functions.

GDD  ENDED                    The TPSINIT  command  has  started.
                              GDD first.
GDF  ENDED
GAM  ENDED
GDET  ENDED
GINV  ENDED
GUU  ENDED
GAMU  ENDED
RIE  ENDED
RIC  ENDED
RICM  ENDED
RSCL  ENDED
EIN  ENDED
EINM  ENDED
NIL                           End of TPSINIT.

&                             The DSHIF property  of  &  has  now
                              been defined.

GDD  ENDED                    Zeroth order of GDD

NIL

GUU  ENDED                    Zeroth order of GUU.

NIL

GDD  ENDED                    First order of GDD.
EXAMPLES ON HOW TO USE SHEEP                            Page 1-21


NIL

GUU  ENDED

NIL

FINISHED-LOADING              Finished.     Now     start     the
                              computations.

 ______________________*(WRITE GDD TO 1 1)<cr>       Write some components of GDD.
       2U           2
G   _= E   +H00X +O(X )
 00
               2
G   _= H01X +O(X )
 01
               2
G   _= H02X +O(X )
 02
         2
G   _= O(X )
 03
         -2U+2K           2
G   _=  -E       +H11X +O(X )
 11

NIL                           End of WRITE command.

 __________________*(MAKE (0) RIC)<cr>           Tell  system  to  make  the  zeroth
                              order  terms  in  the components of
                              the Ricci tensor.
GDF  ENDED
GAM  ENDED
GAMU  ENDED
RIE  ENDED
RIC  ENDED
NIL                           End of MAKE command.

 __________________*(MAKE (1) RIC)<cr>           Make first order terms.
GDF  ENDED
GAM  ENDED
GAMU  ENDED
RIE  ENDED
RIC  ENDED
NIL                           End of MAKE command.

 _______________________*(WRITE (1) RIC 0 1)<cr>      Write the first order terms in  the
                              0 1 component of the Ricci tensor.

EXAMPLES ON HOW TO USE SHEEP                            Page 1-22


                        2U-2K      2   2U-2K
R  (1) _= 2U    -K    -2E     H01U    +E     H01U    +
 01        ,RT   ,RT             ,Z             ,RR

   2U-2K             2U-2K             2U-2K
+2E     H01U  K   +2E     H02U  U   -2E     H02U  K   +
            ,Z ,Z             ,R ,Z             ,R ,Z

  2U-2K          2U-2K           2U-2K              2U-2K
+E     H02U    +E     U  H02   -E     U  H02   +1/2E     H01    -
           ,ZR         ,R   ,Z         ,Z   ,R              ,ZZ

  2U-2K           2U-2K              2U-2K
-E     H01  K   +E     H02  K   -1/2E     H02    +
          ,Z ,Z           ,R ,Z              ,ZR

  -1 2U-2K         -1
+R  E     H01U   +R  K   -2U  U
              ,R      ,T    ,T ,R


NIL                           End of WRITE command.

 ______________________________*(LPTWRITE (0) RIC (1) RIC)<cr>         Write first the zero  and
                              then  the  first order terms of RIC
                              out on a file that is sent  to  the
                              line printer at log out time.

RIC  ENDED                    Zeroth order of RIC.

RIC  ENDED                    First order.

((LAM03 .  LPT:) NIL)         Value    of    LPTWRITE    command.
                              LAM03.LPT   is   the  name  of  the
                              generated file.

__^C                            Leave SHEEP.