%### EXRCRF.SL

(GLOBAL '(!*IFPEXPAND))

(SETQ !*IFPEXPAND T)

(FLUID '(CURFUN!* DSARGS!*))

(FLAG '(COMMENT FUNCTIONS USEDPROPERTIES USEDFLAGS
        LOAD FLOAD PRELOAD POSTLOAD RELOAD SLOAD DSKIN INCLUDE)
      'NOANL)

(PUT 'XCOND 'ANLFN (GET 'COND 'ANLFN))

(DFEXPR DBGCRF (X) (STDINOUT (PRINT (EVAL X))))

(FLAG '(DBGCRF) 'IGNORE)

(DE ANFORL (U)
 (COND
  ((PAIRP (CADR U)) (ANFORML (CADR U)))
  (T (ANFORM (CADR U))) )
 (ADD2LOCS (LIST (CAR U)))
 (ANFORML (CDDR U))
 (REMLOCS (LIST (CAR U))) )

(DEFLIST '((FORL ANFORL) (IFORL ANFORL) (XIFORL ANFORL) % Bugfixes. JEA.
           (FORX ANFORL) (IFORX ANFORL) (XIFORX ANFORL) ) 'ANLFN)

(DC IFP ANLFN (U)
 (COND
  (!*IFPEXPAND
   (ANFORMPRG (COND ((EVAL (CAR U)) (CADR U)) (T (CADDR U)))) )
  (T (ANFORMCOND1 U)) ) )

(DC NEWFNAME ANLFN (U)
 (IOUTREF (CADR U) 'ANP!!EQ (CADDDR U) (GETYPE (CADDDR U)) NIL NIL) )

(FLAG '(OUTDNAME) 'NOANL)

(PUT 'XCASE 'ANLFN 'ANFORMCOND1)

(FLAG '(XCASE IFP) 'INPROG)

(DC XDEFLIST ANLFN (U)
 (COND
  (!*LOSE (ANFORM (MACEXPD (CONS 'XDEFLIST U))))
  (T (ANDEFLIST (LIST (MKQUOTE (CDR U)) (MKQUOTE (CAR U))))) ) )

(DC XFLAGS ANLFN (U)
 (COND
  (!*LOSE (ANFORM (MACEXPD (CONS 'XFLAGS U))))
  (T (ANFLAG (CDR U) (CAR U))) ) )

(PUT 'XPUT 'ANLFN 'ANLPUT)

(PUT 'IXPUT 'ANLFN 'ANLPUT)

(DC DPUT ANLFN (U) (ANFORMPUT (CAR U) (CADR U) (MKQUOTE (CADDR U))))

(DC SAMEDEF ANLFN (U)
 (IOUTREF (CAR U) 'ANP!!EQ (CADR U) (GETYPE (CADR U)) NIL NIL) )

(DC MOVD ANLFN (U)
 (COND
  (TOPLV!* (SLET ((TO (QCRFA U 1)) (FR (QCRFA U 2)))
                 (IOUTREF TO 'ANP!!EQ FR (GETYPE FR) NIL NIL) ))
  (T (ANFORML U)) ))

(DC DMACRO ANLFN (U) (XOUTREF (CAR U) (CADR U) (CDDR U) 'MACRO))

(DC CMMACRO ANLFN (U)
 (COND ((OR (FLAGP 'CMMACRO 'EVAL) (FLAGP 'CMMACRO 'IGNORE))
        (REMFLAG1 (CAR U) 'NOEXPAND) ))
 (XOUTREF (CAR U) (CADR U) (CDDR U) 'MACRO) )

(DC DS ANLFN (U)
 (XOUTREF (CAR U) (CONS '!&DS (CADR U)) (CDDR U) 'MACRO) )

(DC DFEXPR ANLFN (U) (XOUTREF (CAR U) (CADR U) (CDDR U) 'FEXPR))

(DC DEXPR ANLFN (U) (XOUTREF (CAR U) (CADR U) (CDDR U) 'EXPR))

(DC DFUN ANLFN (U) (XOUTREF (CAR U) (CADDR U) (CDDDR U) (CADR U)))

(DE XOUTREF (FN VARS BODY TYPE)
 (PROG (DSARGS!* DSB N UL SEEN PVARS XBODY X)
  (COND
   ((NOT (PAIRP (ERRSETT (!$MACFEX FN VARS BODY TYPE))))
    (RETURN NIL) ) )
  (SETQ N 0)
  (WHILE VARS
   (COND
    ((EQ (SETQ X (CAR VARS)) '!&DS) (SETQ DSB T))
    ((EQ X '!&MACRO) (SETQ N -1))
    ((MEMQ X '(!&EVAL !&QUOTE)) NIL)
    ((MEMQ X '(!&REST !&OPTIONAL !&AUX)) (SETQ SEEN X))
    ((EQ SEEN '!&REST) (SETQ UL T) (XPUSH PVARS X))
    ((NULL SEEN) (IINCR N) (XPUSH PVARS X))
    (T (XPUSH PVARS
        (COND
         ((PAIRP X) (COND ((CDR X) (XPUSH XBODY (CADR X)))) (CAR X))
         (T X) ) )
       (COND
        ((EQ SEEN '!&OPTIONAL)
         (SETQ UL (IADD1 (OR UL N))) ) ) ) )
   (UNPUSH VARS) )
  (COND
   (DSB
    (SETQ DSARGS!* PVARS)
    (COND
     (SEEN
      (WHILE BODY (XPUSH XBODY (DSSB (CAR BODY))) (UNPUSH BODY))
      (SETQ DSARGS!* NIL) )
     (T (SETQ TYPE 'SMACRO)) ) ) )
  (RETURN
   (IOUTREF FN PVARS (REVERSIPX XBODY BODY) TYPE
    (COND
     (UL (CONS N (COND ((NUMBERP UL) UL))))
     (T N) )
    NIL )) ) )

(COMMENT
(DE XOUTREF (FN VARS BODY TYPE)
 (PROG (N UL SEEN X)
  (SETQ N 0)
  (COND
   ((PAIRP (SETQ BODY (ERRSETT (!$MACFEX FN VARS BODY TYPE))))
    (SETQ BODY (CDDAR BODY)) )
   (T (RETURN NIL)) )
  (SETQ TYPE (CADAR BODY))
  (SETQ BODY (CDADR BODY))
  (WHILE (AND VARS (NOT (EQCAR VARS '!&AUX)))
   (COND
    ((MEMQ (SETQ X (CAR VARS)) '(!&REST !&OPTIONAL)) (SETQ SEEN X))
    ((MEMQ X '(!&MACRO !&DS !&EVAL !&QUOTE)) NIL)
    ((EQ SEEN '!&REST) (SETQ UL T))
    ((NULL SEEN) (SETQ N (ADD1 N)))
    (UL (SETQ UL (ADD1 UL)))
    (T (SETQ UL (ADD1 N))) )
   (SETQ VARS (CDR VARS)) )
  (RETURN (IOUTREF FN () BODY TYPE
    (COND
     (UL (CONS N (COND ((NUMBERP UL) UL))))
     (T N) )
    NIL )) ) ) )

(DEFLIST '((MAPRPL ANLMAP) (MAPRPLC ANLMAP) (DFEVAL ANLEVAL)) 'ANLFN)

(DC FUNCALL ANLFN (U)
 (ANFORML (CDR U)) (ANLAPLCH (CAR U) (CDR U) !*APPLYLOCAL) )

(PUT 'FEXPRCALL 'ANLFN (GET 'FUNCALL 'ANLFN))

(DC EXCHANGE ANLFN (U)
  (PROGN (ANLST (CAR U)) (ANLST (CADR U))))

(DE ANLINCR (U) (ANFORML U) (ANLST (CAR U)))

(FOREACH X IN
 '(XPUSH UNPUSH REMPOP PUSHQ POP INCR XINCR IINCR DECR XDECR IDECR)
 DO (PUT X 'ANLFN 'ANLINCR) )

(DC PLET ANLFN (U)
 (SLET ((A (FOREACH X IN (CAR U) COLLECT (COND
             ((PAIRP X) (COND ((CDR X) (ANFORM (CADR X)))) (CAR X))
             (T X) ))))
  (ADD2LOCS A)
  (ANFORML (CDR U))
  (REMLOCS A) ) )

(DC SLET ANLFN (U)
 (SLET ((A (FOREACH X IN (CAR U) COLLECT
            (SETQ X (COND
              ((PAIRP X) (COND ((CDR X) (ANFORM (CADR X)))) (CAR X))
              (T X) ))
            (ADD2LOCS (LIST X))
            X)))
  (ANFORML (CDR U))
  (REMLOCS A) ) )
 
(DC DC ANLFN (U) (IOUTREF (CAR U) (CADDR U) (CDDDR U) (CADR U) NIL NIL))

(DC THROWQ ANLFN (U) (ANFORM (CADR U)) (CHKTAG (CAR U) NIL))

(DC CATCHQ ANLFN (U) (ANFORM (CADR U)) (CHKTAG (CAR U) T))

(DC REEVALFORM ANLFN (U) (PROG (SLOCLS!*) (RETURN (ANFORM U))))

(DC DO ANLFN (U) (ANLDO U NIL))

(DC DO!* ANLFN (U) (ANLDO U T))

(DE ANLDO (U SW)
 (SLET ((A (FOREACH X IN (CAR U) COLLECT
            (SETQ X (COND
              ((NOT (PAIRP X)) X)
              ((NULL (CDR X)) (CAR X))
              (T (ANFORM (CADR X)) (CAR X)) ))
            (COND (SW (ADD2LOCS (LIST X))))
            X)))
  (COND ((NOT SW) (ADD2LOCS A)))
  (FOREACH X IN (CAR U) DO
   (COND ((AND (PAIRP X) (CDR X) (CDDR X)) (ANFORM (CADDR X)))) )
  (ANFORML (CADR U))
  (FOREACH X IN (CDDR U) DO (COND ((PAIRP X) (ANFORM1 X))))
  (REMLOCS A) ) )

(DC PSETQ ANLFN (U)
 (UNTIL (NULL (SETQ U (CDDR U)))
  (ANLST (CAR U))
  (COND
   ((CDR U) (ANFORM (CADR U)))
   (T
    (SETQ U (CONS NIL U))               % To end correctly
    (DOERRMSG T
     (LIST "PSETQ called odd instead of even number of arguments")
     ) ) ) ) )

(DC DECLAREFEXPR ANLFN (U) (SLET (Y)
  (FOREACH X IN U DO (COND ((NOT (FLAGP X 'ISAFEXPR))
     (CHKSETYPE X 'FEXPR)
     (COND ((AND (FLAGP X 'SEEN) (SETQ Y (GET X 'GALL))
                 (NOT (EQ 'FEXPR (CDR Y))) )
            (DOERRMSG NIL (LIST X " declared FEXPR but was "
                                (CDR Y) " before" )) ))
     (FLAG1 X 'ISAFEXPR) ))) ))

(DE ANEXPD (FN U)
 (PROG (X)
  (RETURN
   (COND
    ((OR (SETQ X (GET X 'cmacro))
      (AND (EQCAR (SETQ X (GETD FN)) 'MACRO) (SETQ X (CDR X))) )
     (APPLY X (LIST U)) )
    (T U) ) ) ) )

(DC ENTRYPOINTS ANLFN (U) (SETENTLOC U 'ENTRYPOINT))

(DC LOCALFUNCTIONS ANLFN (U) (SETENTLOC U 'LOCALFUNCTION))

(DE SETENTLOC (L TYP) (FOREACH X IN L DO (ISETENTLOC X TYP)))

(DE ISETENTLOC (X TYP)
 (SLET ((A (GET X 'ENTLOC)))
  (COND ((AND A (NOT (EQ TYP A)))
         (DOERRMSG NIL (LIST X " declared " A " previously "))  % JEA
         (COND ((EQ TYP 'LOCALFUNCTION) (SETQ TYP NIL))) ))
  (COND (TYP (PUT X 'ENTLOC TYP))) ) )

(DC SETCONSTANTS ANLFN (U) (ANLSETGLOB U 'CONSTANT "Constant"))

(COMMENT
 (FOREACH X IN U DO
  (COND
   ((NOT (LOSEPP X "Constant"))
    (COND
     ((PAIRP X)
      (SETQ X (COND ((PAIRP (CAR X)) (CAAR X)) (T (CAR X)))) ) )
    (PUT X 'SETLIN CURLIN!*)
    (IDOGLOB X 'CONSTANT) ))) )

(DE ANLSETGLOB (U TYP SW)
 (FOREACH X IN U DO
  (COND
   ((LOSEPP X (OR SW "Variable")) NIL)
   ((NOT (PAIRP X)) (IDOGLOB X TYP))
   (T (COND
       ((PAIRP (SETQ X (CAR X))) (ANFORM (CADR X)) (SETQ X (CAR X))) )
      (IDOGLOB X TYP)
      (COND ((OR SW (NOT (GET X 'SETLIN))) (ANLST X))) ) )))

(DC SETGLOBALS ANLFN (U) (ANLSETGLOB U 'GLOBAL "Variable"))

(DC SETLOCALGLOBALS ANLFN (U) (ANLSETGLOB U 'GLOBAL "Variable"))

(DC SETFLUIDS ANLFN (U) (ANLSETGLOB U 'FLUID "Variable"))

(DC QSETGLOBALS ANLFN (U) (ANLSETGLOB U 'GLOBAL NIL))

(DC QSETLOCALGLOBALS ANLFN (U) (ANLSETGLOB U 'GLOBAL NIL))

(DC QSETFLUIDS ANLFN (U) (ANLSETGLOB U 'FLUID NIL))

(REMFLAG '(DECLAREFEXPR ENTRYPOINTS FUNCTIONS LOCALFUNCTIONS) 'IGNORE)

(REMFLAG '(FLUID GLOBAL UNFLUID) 'EVAL)

(REMFLAG '(SAMEDEF DC XPUT DPUT XDEFLIST IFP
           SETGLOBALS SETLOCALGLOBALS SETFLUIDS SETCONSTANTS
           QSETGLOBALS QSETLOCALGLOBALS QSETFLUIDS)
         'DFEXPAND)

(REMFLAG '(DECLAREFEXPR LOCALFUNCTIONS ENTRYPOINTS) 'IGNORE)

%### EXRCRF.SL end
