%### FUNS.SL

(SETLOCALGLOBALS RPF!*W)

(NEWSWITCHES
 (NOPRDIFIFVAL
  "PRFUNS doesn't print derivatives of function with value" ) )

(DE XVTGT (X) (SLET (A) (COND
   ((NOT (IDP X)) NIL)
   ((MEMQ X VARSETLIS!*) X)
   ((SETQ A (ATSOC X VARSETALIS!*)) (CDR A))
   ((EQ X '!#) 
%    (COND (RPF!*W (SETQ RPF!*W NIL)
%      (WARNINGFT 130
%       "In the future, please declare # by (VARSETNAME (!# 2))" ) ))
    (XVTGTN 2) )               % This is temporary.
   ((SETQ A (GET X 'MOREVT)) (XVTGTN A)) )))

(DE ALLDIGITP (B)
 (WHILE (AND B (DIGIT (CAR B))) (UNPUSH B))
 (NULL B) )

(DE XVTGTN (A)
 (OR
  (KAR1 VARSETLIS!* (ISUB1 A))
  (SLET (VT)
   (FORL N ((IADD1 (LENGTH VARSETLIS!*)) A)
    (SETQ VT (MAKEID (CONSA 'D 'F (EXPLODE N)) T))
    (FOREACH X IN DEFDIFLIS!*!* DO (PUT VT (CAR X) (CDR X)))
    (SETQ VARSETLIS!* (NCONC1 VARSETLIS!* VT))
    (STVRMX VT (MIN DEFAULTDIMENSION!* (GTVRMX CRDIF!*)))
    (STVRLS VT (VARMLIS VT)) )
   VT ) ) )

(DEFLIST '((DF1 1) (DF2 2) (DF3 3) (DF4 4) (DF5 5) (DF6 6)) 'MOREVT)

(DE EXVTGT (X)
 (OR
  (XVTGT X)
  (ERRORFT 520 "%r is not a valid variable set name" X) ) )

(DE XVARSETNAMEL (L)
 (FOREACH X IN L DO (COND
  ((PAIRP X) (XVARSETNAME (CAR X) (CADR X)))
  (T (XVARSETNAME X NIL)) )) )

(DE XVARSETNAME (VT N)
 (XPUSH VARSETALIS!*
  (CONS VT (COND
    ((NULL N) (XVTGTN (IADD1 (LENGTH VARSETLIS!*))))
    ((IDP N) (EXVTGT N))
    (T (XVTGTN N)) )) ) )

(DE XVARSET (X) (PROG1 CRDIF!* (SETQ CRDIF!* (EXVTGT X))))

(DE XGTVTNM (VT)
 (SLET ((A (RATSOC VT VARSETALIS!*)))
  (COND (A (CAR A)) (T VT)) ) )

(DE VARSL (L)
 (SLET ((VT (COND (L (XVTGT (CAR L))))))
  (COND
   (VT (UNPUSH L))
   (T (SETQ VT CRDIF!*)) )
  (PROG1 (GTVRLS VT) (COND (L (XVARS L VT)))) ) )

(DE XVARS (L VT)
 (SLET ((B (GTVRLS VT)) A)
  (FOREACH X IN B DO (COND ((IDP X) (XREMFUNS X VT))))
  (XVARMAX (LENGTH L) VT)
  (SETQ A (SETQ B (VARMLIS VT)))
  (FOREACH X IN L DO
   (COND
    ((IDP X)
     (RPLACA A X)
     (XREMFUNS X VT)
     (PUT X VT (FOREACH Y IN B COLLECT (COND ((EQ X Y) 1) (T 0)))) ) )
   (UNPUSH A) )
  (STVRLS VT B) ) )

(DE FUNSL (L!&)
 (SLET ((VT!& CRDIF!*) A!&)
  (FOREACH X!& IN L!& DO (COND
    ((SETQ A!& (XVTGT X!&)) (SETQ VT!& A!&))
    (T (XFUNS X!& VT!&)) ))
  (GTFNLS VT!&) ) )

% Future idea: Do SPEC via SETEN or via RPL, (RPL (DF1 fn 0))
(DE XFUNS (X!& VT!&) 
 (SLET (A!& B!& C!& D!& G!& FN!&)
  (SETQ B!&
   (COND 
    ((IDP X!&)
     (SETQ FN!& X!&)
     (COND ((SETQ X!& (IDVALUE X!&)) NIL) (T (SETQ X!& (FOINPC FN!&))))
     (SETQ D!& 0) )
    ((AND (SETQ FN!& (CAR X!&)) (NULL (UNPUSH X!&))) 2)
    ((EQ (SETQ D!& (CAR X!&)) 'ALL) (SETQ D!& 1) 0)
    ((EQ D!& 'SUBS) (SETQ X!& (FOINPC FN!&)) (SETQ D!& 0))
    ((EQ D!& 'SPEC) (UNPUSH X!&) 1)
    ((EQ D!& 'TRANSF) (SETQ X!& (FINVTGT X!&)) (SETQ D!& 2) 0)
    (T (SETQ D!& NIL) 1) ))
  (COND
   ((SETQ A!& (MEMQ FN!& (GTVRLS VT!&)))
    (RPLACA A!& (GETVAR FN!& VT!&)) 
    (WARNINGFT 132 "Function %r was a variable previously" FN!&) ) )
  (SETQ C!& (GTFNLS VT!&))
  (COND ((MEMQ FN!& C!&) (SETQ C!& (DELQIP FN!& C!&))))
  (SETQ A!& (COND
    ((AND (EQ D!& 'SPEC) (SETQ G!& (GET FN!& VT!&))) G!&)
    ((IZEROP B!&) (VARMLIS VT!&))
    (T (COLIST (GTVRMX VT!&) 0)) ))
  (XCASE B!& NIL
   (FOREACH Y IN A!& REPLACE (XCASE D!& NIL
     (SIMPE (SIDIFC X!& Y VT!&))
     (MKDIFF FN!& Y VT!&)
     (SIMPE (SICHDF FN!& Y VT!& X!&)) ))
   (FOREACH Y IN X!& DO
    (SETQ Y (GETVAR Y VT!&))
    (RPLACA (CNDR A!& Y) (COND
      (D!& (FOINP (MKDIFF FN!& Y VT!&)))
      (T (MKDIFF FN!& Y VT!&)) )) )
   NIL)
  (ISETFUNS FN!& VT!& A!& (EQ D!& 'SPEC))
  (STFNLS VT!& (NCONC1 C!& FN!&)) ) )

(DE ISETFUNS (FN VT VL SW) (SLET (OVL)
  (COND ((AND (NOT SW) (SETQ OVL (GET FN VT)) (NOT (EQUAL OVL VL)))
         (WARNINGFT 134 "Variable dependence of %r is redefined" FN) ))
  (PUT FN VT VL) ))

(DE FINVTGT (X)
 (COND
  ((CDR X) (XVTGT (CADR X)))
  (T (EXVTGT (FOINPC 'TRANSVARSET))) ) )

(DE PUTFUNDIF (FN VAR VT VDF)
 (SLET ((A (GET FN (SETQ VT (EXVTGT VT)))))
  (COND ((NULL A)
         (PUT FN VT (SETQ A (COLIST (GTVRMX VT) 0)))
         (STFNLS VT (CONS FN (GTFNLS VT))) ))
  (COND ((NULL (SETQ A (CNDR A VAR)))
         (ERRORFT 521 "Try to set variable %p when %p has dimension %p"
                 VAR VT (GTVRMX VT)) ))
  (RPLACA A VDF)
  VDF) )

(DE SIDIFC (SXP VAR VT) (SIMP1 (DIFFC SXP VAR VT)))

(DE SICHDF (FN VAR VT VTC) (SIMP1 (CHNDIF FN VAR VT VTC)))

(DE REMFUNSL (L)
 (SLET ((VT CRDIF!*) A)
  (FOREACH X IN L DO (COND
    ((SETQ A (XVTGT X)) (SETQ VT A))
    (T (XREMFUNS X VT)) ))
  (GTFNLS VT) ) )

(DE XREMFUNS (X VT)
 (COND
  ((EQ X 'ALL) (REMFALL VT))
  (T (SLET ((A (GTFNLS VT)))
      (COND
       ((MEMQ X A) (STFNLS VT (DELQIP X A)))
       ((SETQ A (MEMQ X (GTVRLS VT))) (RPLACA A (GETVAR X VT))) )
     (REMPROP X VT) )) ) )

(DE REMFALL (VT) (PROGN
  (FOREACH X IN (GTVRLS VT) DO (COND ((IDP X) (REMPROP X VT))))
  (STVRLS VT (VARMLIS VT))
  (FOREACH X IN (GTFNLS VT) DO (REMPROP X VT))
  (STFNLS VT NIL)))

(DE VARMAXL (L)
 (SLET ((VT (COND (L (XVTGT (CAR L))))))
  (COND
   (VT (UNPUSH L))
   (T (SETQ VT CRDIF!*)) )
  (COND
   (L (XVARMAX (CAR L) VT))
   (T (GTVRMX VT)) ) ) )


(DE XVARMAX (N VT)
 (SLET ((A (GTVRMX VT)) SW B)
  (COND 
   ((AEQN A N) NIL)
   ((LESSP N VARMAXMIN)
    (ERRORFT 522 "%w is less than minimum %w" N VARMAXMIN) )
   (T (STVRMX VT N)
      (SETQ B (GTVRLS VT))
      (COND
       ((LESSP N A)
        (FOREACH X IN (CDR (SETQ B (CNDR B (SETQ SW (IDECR N))))) DO
         (COND ((IDP X) (REMPROP X VT))) )
        (RPLACD B NIL) )
       (T (NCONC B (CNDR (SEQ0L N) A)) (SETQ N (IDIFFERENCE N A))) )
      (FOREACH X IN (APPEND (GTVRLS VT) (GTFNLS VT)) DO (COND
        ((NOT (IDP X)) NIL)
        (SW (RPLACD (CNDR (GET X VT) N) NIL))
        (T (NCONC (GET X VT) (COLIST N 0))) )) ) )
  A) )

(DE VARMLIS (X) (SEQ0L (GTVRMX X)))

% Print variables, using their print name (c f "(VARS)"-command).
(DE PVARS () (FOREACH X IN VARSETLIS!* DO (PVARX X)))

(DE PVARX (VT)
 (SLET ((A (GTVRMX VT)) B)
  (SETQ !*FPRT NIL)
  (PRTLF "%variables from 0 to %v :%v"
   (COND
    ((NULL (CDR VARSETLIS!*)) "V")
    (T (XCONS " v" (COND
         ((SETQ B (RATSOC VT VARSETALIS!*))
          (LIST (VALU (CAR B)) " (" (VALU VT) '!)) )
         (T (VALU VT)) ))) )
   (ISUB1 A)
   (FOREACH X IN (SEQ0L A) COLLECT (CONS " " (PRTVARNR X VT))) )
 NIL) )

(DE ALLFUNSL ()
 (SLET ((FNL (GTFNLS (CAR VARSETLIS!*))))
  (FOREACH X IN (CDR VARSETLIS!*) DO (SETQ FNL (UNIONQ (GTFNLS X) FNL)))
  FNL) )

(DE PRFUNSL (FNL!&)
 (COND ((NULL FNL!&) (SETQ FNL!& (ALLFUNSL))))
 (FOREACH X!& IN FNL!& DO (PRFUNS1 X!&))
 FNL!&)

(DE PRFUNS1 (FN!&)
 (PLET ((A!& (IDVALUE FN!&)))
  (COND (A!& (XWRITE FN!& NIL)))
  (COND
   ((AND A!& NOPRDIFIFVAL) NIL)
   ((NULL (CDR VARSETLIS!*)) (PRFUNS2 FN!& (CAR VARSETLIS!*)))
   (T (FOREACH VT IN VARSETLIS!* DO
       (PRTLF "Dependence on %w variables:" (XGTVTNM VT))
       (PRFUNS2 FN!& VT) )) ) ) )
          
(DE PRFUNS2 (FN VT)
 (SLET (A B SW VL)
  (COND
   ((NULL (GET FN VT))
    (PRTLF "%w's dependence on variables not declared" FN) )
   (T (FOREACH VR IN (VARMLIS VT) DO (COND
        ((AND (AZEROP (SETQ A (DIFFC FN VR VT))) NOZERO) NIL)
        ((EQUAL (SETQ B (MKDIFF FN VR VT)) A)
         (COND (VL (XPUSH VL ", ")))
         (XPUSH VL (GTVRNAM VR VT NIL)) )
        (T (PRING A B) (SETQ SW T)) ))
      (COND
       (VL (COND ((CDR VL) (RPLACA (CDR VL) " and ")))
           (PRTLF "%w%v depends on %v" FN (COND (SW " also"))
            (REVERSIP VL) ) )
       ((NULL SW) (PRTLF "%w is a constant" FN)) ) ) ) ) )

% code for new REDOUT.  JEFS
 
(DE WRITEALLFUNDEPS ()
 (FOREACH VT IN VARSETLIS!* DO (WRITEFUNDEPS VT)) )

(DE WRITEFUNDEPS (VT)
 (FOREACH FN IN (GTFNLS VT) DO (WRITEFUNDEP FN VT)) )
         
(NEWSWITCHES
 (FUNSLET "REDOUT generates LET statements for special derivatives"))

(DE WRITEFUNDEP (FN VT)
 (SLET ((!*FPRT T) (VN 0) L DL B)
  (COND
   ((NOT (GET FN 'DFUN))
    (FOREACH X IN (GET FN VT) DO
     (COND
      ((AZEROP X) NIL)
      ((PROGN (XPUSH DL VN)
        (AND FUNSLET (NOT (EQUAL X (SETQ B (MKDIFF FN VN VT))))) )
       (XPUSH L (LIST 'EQUAL B X)) ) )
     (IINCR VN) )
    (COND (DL (PRTL (VALU (CONSA 'DEPEND VT FN (REVERSIP DL))))
              (FOREACH X IN (REVERSIP L) DO
               (PRTL (VALU (LIST 'LET X))) ) )) )) ))

%### FUNS.SL end

