%### HELPFN.SL

(COMMENT
(DE SNUMP (SXP)
 (COND ((OR (NUMBERP SXP) (AND (PAIRP SXP) (NUMBERP (CAR SXP)))) SXP)) )

(DE SATOM (SXP) (OR (ATOM SXP) (NUMBERP (CAR SXP))))
)

(DE COPYL (SXP)
 (COND ((SATOM SXP) SXP) (T (CONS (CAR SXP) (COPYA (CDR SXP))))) )

(DE COPYA (AXP)
 (COND
  ((ATOM AXP) AXP)
  (T (CONS (COPYL (CAR AXP)) (COPYA (CDR AXP)))) ) )

(DE XCOPY (SXP)
 (COND
  ((SATOM SXP) SXP)
  (T (CONS 'XCOPY SXP)) ) )

(DE COLIST (N X) (SLET (A) (REPEATS N (XPUSH A X)) A))

(DE APPLYSXP (FN SXP) (COND (FN (FUNCALL FN SXP)) (T SXP)))

(COMMENT
 (DE CNDR (X N)
  (COND
   ((OR (AZEROP N) (NULL X)) X)
   ((NOT (XMINUSP N)) (CNDR (CDR X) (XSUB1 N)))))
 )

(DE KAR1 (X N) (COND ((SETQ X (CNDR X N)) (CAR X))))

% Put carefully
(DE PUTQ (X Y Z) (COND ((NOT (GET X Y)) (PUT X Y Z))))

% Put/extend List
(DE PUTXL (X Y Z) (SLET ((A (GET X Y))) (COND
  (A (ATTACHQ1 Z A) A)
  (T (PUT X Y (NCONS Z))) )))

% Extend conditionally with 1 extra element
(DE ATTACHQ1 (X L) (COND
  ((EQ X (CAR L)) NIL)
  ((CDR L) (ATTACHQ1 X (CDR L)))
  (T (RPLACD L (NCONS X))) ))

(DE REMPROPXL (X Y Z)
 (SLET ((A (GET X Y)))
  (COND
   ((NULL A) NIL)
   ((NOT (EQ Z (CAR A))) (DELQIP Z A))
   ((CDR A) (PUT X Y (CDR A)))
   (T (REMPROP X Y)) ) ) )

(DE PUTAL (X P Y Z) (SLET ((A (GET X P))) (COND
   (A (ATTAL A Y Z))
   (T (PUT X P (NCONS (CONS Y Z)))) )))

(DE ATTAL (AL Y Z) (COND
  ((EQCAR (CAR AL) Y) (RPLACD (CAR AL) Z))
  ((CDR AL) (ATTAL (CDR AL) Y Z))
  (T (RPLACD AL (NCONS (CONS Y Z)))) ))

(DE FINDCNT (X SX) (COND
  ((EQ X SX) 1)
  ((PAIRP SX) (XIPLUS (FINDCNT X (CAR SX)) (FINDCNT X (CDR SX))))
  (T 0) ))

(DE VERRS (X!&)
 (COND ((PAIRP (SETQ X!& (ERRSET (EVAL X!&) !*VERRS))) (CAR X!&))) )

(SAMEDEF IDVALUE VERRS)

(DE SEQ0L (X)
 (SLET (A)
  (WHILE (NOT (XMINUSP (XDECR X))) (XPUSH A X))
  A) )

(DE APPLYQ1 (FN X) (COND (FN (FUNCALL FN X))))

(DE PRINRED () (PROMPTER "?" (PROMPT) (READ)))

(DE CHKQUIT (X) (COND
  ((EQ X 'RESET) (RESET))
  ((EQ X 'QUIT) (QUIT))
  ((EQ X 'BYE) (BYE))
  (T X) ) )

(DE ASKIN (ERO ERSTR READFN OKFN DEFAULT HELPFN!*)
 (CHKQUIT (COND
   ((AND !*INT
     (SLET (A (C ASKREPEAT!*))
      (UNTIL (OR A (IMINUSP (IDECR C)))
       (COND
        (ERSTR (MSGOUT NIL ERSTR ERO))
        (T (EPRTO ERO NIL)) )
       (SETQ A (FOLDCASE T (STDIN (ERRSETT (FUNCALL READFN)))))
       (COND
        ((NOT (PAIRP A)) (SETQ A NIL))
        ((NOT
          (OR (FUNCALL OKFN (CAR A)) (MEMQ (CAR A) '(RESET QUIT BYE))) )
         (COND ((MEMQ (CAR A) '(HELP !?))
                (QHELP HELPFN!*) (SETQ C ASKREPEAT!*) NIL))
         (SETQ A NIL) ) ) )
      (SETQ ERO A) ) )
    (CAR ERO) )
   (T (ERRORPRINTF "Using default %p" DEFAULT) DEFAULT) )) )

% ERO           -list of %-operator values to be substituted into:
% ERSTR         -a string that may have %-operators,
% EASKFORM!*    -expression that failed to evaluate, thereby causing
%                dialogue
% The last two arguments may be nil:
% FOARG!*       -Only after keyword "FOINP" that starts FOIN-asking:
%                indicate which tsr component etc being assigned.
% HELPFN!*      -Function or string, used in case user responds
%                keyword "HELP".
(DE EASK (ERO ERSTR EASKFORM!* FOARG!* HELPFN!*)
 (SLET (B!& (C!& ASKREPEAT!*))
  (UNTIL (OR B!& (IMINUSP (IDECR C!&)))
   (COND
    (ERSTR (MSGOUT3 NIL ERSTR ERO))
    (T (EPRTO ERO NIL)) )
   (SETQ B!& (STDIN
     (PROMPTER "now" (PROMPT) (ERRSETT (EVAL (READ)))) )) % JEA
   (SETQ B!& (COND
     ((NOT (PAIRP B!&)) NIL)
     ((EQ (CAR B!&) 'FOINP) (STDIN (FOINP FOARG!*)))
     ((EQ (CAR B!&) 'HELP) (QHELP HELPFN!*) (SETQ C!& ASKREPEAT!*) NIL)
     (T (CHKQUIT (CAR B!&)) (EVAL EASKFORM!*)) ) ) )
  (COND
   (B!& B!&)
   (T (ERRORFT 480 "Asking too many times")) ) ) )

(DE LLHELP (HD L) (TERPRI) (PRIN2T HD) (LHELP L NIL)) %LH

(DE LHELP (L SW)
 (FOREACH X IN L DO (COND
   ((NULL SW) (PRIN1 X) (QHELP (GET X 'HELP)))
   ((GET X 'HELP) (PRIN1 X) (PRIN2 '! )) )) )

(DE QHELP (FN) (COND
 ((STRINGP FN) (TTAB 15) (PRIN2T FN))
 ((OR (FNP FN) (CODEP FN) (EQCAR FN 'LAMBDA)) (FUNCALL FN))
 ((PAIRP FN) (FOREACH X IN FN DO (QHELP X)))
 (T (TTAB 15) (PRIN2T "No help available")) ))

(DMACRO HELP (!&REST L) (IHELP L))  % Changed from DS. JEA.
(DE IHELP (L)
  (COND
    (L (LHELP L NIL))
    (T (QHELP (GET 'HELP 'HELP))) )
  'SUPPRESSANS!* )

% HELP facility is now extendible. JEA.
(DC HELP HELP ()
  (QTRPRI)
  (PRIN2 "Help is available for ") (LHELP HELPBAS!* T)
  (TERPRI) )

(DE EPRTO (SXP SHD) (STDOUT (PRING SXP (COND (SHD (COPYL SHD))))))

%(DE EPRINX (X)
% (STDOUT
%  (QTRPRI)
%  (COND
%   ((NOT (EQCAR X 'TXT)) (PRIN2D X))
%   (T (PRIN2L (CDR X)) (PRIN2D '! )) ) ) )

%(DE QTRPRI () (COND ((NOT (IZEROP (POSN))) (TERPRI))))

(DS SHPFIL (X) (OUTFILENAME NIL X SHPEXT!*))

(PUT SAVEXT!* 'INFN 'READIN)

(PUT FOEXT!* 'INFN 'FOINR)

(PUT ROEXT!* 'INFN 'FOINRR)

(DS OUTF (X !&REST L) (FILEOUT (SHPFIL 'X) . L))

(DS INF (X !&REST L) (FILEIN (SHPFIL 'X) . L))

(DE TSTBIT (X BT) (NOT (XEVENP (XQUOTIENT X BT))))    % JEA.

%### HELPFN.SL end

