%### MKISHP.SL

% This file is used to generate interpreted Sheep on Portable Standard
% Lisp (PSL) or Rsheep on PSL based Reduce.

(SETQ !*COMP NIL)
(SETQ !*MODULCOMP NIL)
(DPUT FLOADEXT SUBDRS NONE)     % Do not load fast loading modules.
(LOAD "../SEARSH")              % Set search list for making Sheep.
(IFP !*RSHEEP (LOAD SHBOOT))    % For Rsheep only.
(LOAD SHPMC)                    % Sheep macros.
(LOAD SHEEP)                    % The Sheep source code.
(IFP !*RSHEEP (LOAD SHPFIN))    % For Rsheep only.
(IFP (CODEP (GETFN 'ADDHLP))    % Check if Sheep Lisp is compiled.
 (IFP !*RSHEEP                  % Save the image.
  (SAVERUN IRSHEEP)             % Interpreted Rsheep.
  (SAVERUN ISHEEP) )            % Interpreted Sheep.
 (IFP !*RSHEEP
  (SAVERUN IIRSHEEP)            % Interpreted Rsheep on irslisp.
  (SAVERUN IISHEEP) ) )         % Interpreted Sheep on islisp.

%### MKISHP.SL end
