%### SUBL1.SL

(NEWSWITCHES
 (SEQSUBS "(EXPERIMENTAL) Do substitutions in sequence") )

(PON SEQSUBS) % Remove this when switching to new facility

(SETLOCALGLOBALS
 ((TESULS!*     ESUL))
 (!$SUPSUB      NIL)
 DIFTY!$
 INSNU!$
 LSBPIK!$
 SUDIFOR!$
 SUTRAN!$)

(SETFLUIDS SUB!$SUBL SEENSUBL!$ NEWSUBL!$ !$FACOUT)

(DE SUBL1 (SUBLARG!* SBL)
 (SETQ !*!*SUBSTW NIL)
 (COND
  ((SNUMP SUBLARG!*) SUBLARG!*)
  (T (SUBL2 SBL)) ) )

(DE SUBL2 (SBL) (COND
  ((NULL SBL) SUBLARG!*)
  ((IDP SBL) (SUBL2 (EVAL SBL)))
  ((EQCAR SBL 'SUBS) (COND
    (SEQSUBS (SUBSX SUBLARG!* (CDR SBL)))
    (T (SUBSS2 SUBLARG!* (CDR SBL))) ))
  ((EQCAR SBL 'SUBL) (SUBL2L (CDR SBL)) SUBLARG!*)
  (T (ERRORFT 500 "Subs list expected but %r is not a substitution list"
             SBL )) ))

(DE SUBL2L (L) (SLET (A) (COND
   ((NULL L) NIL)
   ((SETQ A (IGET (CAR L) 'SUBLOP)) (SUBL2L (FUNCALL A L))) %Bugfix. JEA
   (T (SETQ SUBLARG!* (SUBL2 (CAR L))) (SUBL2L (CDR L))) )))

(DC MSUBS SUBLOP (L) (SLET ((MCU SUBMTIMES!*) (OSW !*!*SUBSTW))
  (COND ((NUMBERP (CAR (UNPUSH L))) (SETQ MCU (CAR L)) (UNPUSH L)))
  (UNTIL (OR (NULL !*!*SUBSTW) (IZEROP (IDECR MCU)))
         (SETQ !*!*SUBSTW NIL) (SUBL2L L) )     % Bugfix. JEA.
  (SETQ !*!*SUBSTW (OR !*!*SUBSTW OSW))
  NIL))

(DC FACOUT SUBLOP (L) (SLET ((!$FACOUT !$FACOUT))
  (COND ((NULL !$FACOUT)
         (SETQ !$FACOUT T) (SETQ SUBLARG!* (OUTFAC SUBLARG!*)) ))
  (SUBL2L (CDR L))
  (FACINSUBL '(FACIN)) ))

(DE FACINSUBL (L)
 (COND ((AND !$FACOUT (EQCAR SUBLARG!* 'FACTOR))
        (SETQ SUBLARG!* (SMTIMES2 (CADR SUBLARG!*) (CADDR SUBLARG!*)))))
 (CDR L) )

(XDEFLIST SUBLOP (FACIN FACINSUBL))

(SETFLUIDS
 SUBEXP!$
 SUBMASK!$
 SUBSUBS!$)

(DE SUBSX (SXP SBL) (SLET ((OSW !*!*SUBSTW))
  (SETQ !*!*SUBSTW NIL)
  (FOREACH SPR IN SBL DO (SETQ SXP (SUBSS1 SXP (CAR SPR) (CDR SPR))))
  (COND
   (!*!*SUBSTW (SIMP2 SXP))
   (T (SETQ !*!*SUBSTW OSW) SXP) ) ))

% SUBSS1 formerly called SUBS1, correspondingly for SUBSS11, SUBSS2,
% SUBSS3 and SUBSS4.
(DE SUBSS1 (SXP SUBMASK!$ SUBSUBS!$)
 (SLET (SUBEXP!$ A)
  (COND ((AND SUBPOT (EQCAR SUBMASK!$ 'EXPT)
              (FIXP (SETQ A (CADDR SUBMASK!$))) )
         (SETQ SUBEXP!$ A) (SETQ SUBMASK!$ (CADR SUBMASK!$)) ))
  (SUBSS11 SXP) ) )

(DE SUBSS11 (SXP) 
 (COND 
  ((AND (NOT SUBEXP!$) (EQUAL SXP SUBMASK!$))
   (SETQ !*!*SUBSTW (COPYL SUBSUBS!$)) )
  ((SATOM SXP) SXP)
  ((AND SUBEXP!$ (EQ (CAR SXP) 'EXPT) (EQUAL (CADR SXP) SUBMASK!$))
   (SUBSEX SXP (CADDR SXP)) )
  (T (FOREACH X IN (CDR SXP) REPLACE (SUBSS11 X)) SXP) ) )

(DE SUBSEX (SXP EX)
 (COND
  ((EQUAL EX SUBEXP!$) (SETQ !*!*SUBSTW (COPYL SUBSUBS!$)))
  ((NOT (FIXP EX)) SXP)
  (T (SLET ((DIV (DIVIDE EX SUBEXP!$)) REM)
      (SETQ REM (CDR DIV))
      (SETQ DIV (CAR DIV))
      (COND
       ((OR (AZEROP DIV) (MINUSP DIV)) SXP)
       (T (SETQ REM (COND 
            ((AZEROP REM) NIL)
            ((AONEP REM) (CADR SXP))
            ((AONEP DIV) (RPLACA (CDDR SXP) REM) SXP)
            (T (LIST 'EXPT (CADR SXP) REM)) ))
          (SETQ DIV (COND 
            ((AONEP DIV) (COPYL SUBSUBS!$))
            (T (RPLACA (CDR SXP) (COPYL SUBSUBS!$))
               (RPLACA (CDDR SXP) DIV) SXP) ))
          (SETQ !*!*SUBSTW T)
          (COND (REM (LIST 'TIMES DIV REM)) (T DIV)) ) ) )) ) )

(DE SUBSS2 (SXP SUB!$SUBL) (COND
  (SUB!$SUBL (SUBSS3 SXP))
  (T SXP) ))

(DE SUBSS3 (SXP)
 (OR
  (SUBSS4 SXP)
  (COND
   ((SATOM SXP) SXP)
   (T
    (SLET
      ((OSW !*!*SUBSTW) FN)
      (SETQ !*!*SUBSTW NIL)
      (SETQ SXP (COND
        ((NOT NOALLSUBS) (COND
          ((SETQ FN (IGET (CAR SXP) 'SUBSFN)) (FUNCALL FN SXP))
          ((PROGN (SUBSL3 SXP) (NULL !*!*SUBSTW)) SXP)
          ((SETQ FN (IGET (CAR SXP) 'SIMPXFN))
           (FUNCALL FN (CADR SXP) SXP) )
          ((SETQ FN (IGET (CAR SXP) 'SHSMPFN)) (FUNCALL FN SXP))
          (T SXP) ))
        ((EQ (CAR SXP) 'PLUS) (PLUSSUB SXP))
        ((EQ (CAR SXP) 'TIMES) (TIMESSUB SXP))
        ((EQ (CAR SXP) 'EXPT) (EXPTSUB SXP))
        ((EQ (CAR SXP) 'EXP) (EXPSUB SXP))
        (T SXP) ))
      (COND ((NULL !*!*SUBSTW) (SETQ !*!*SUBSTW OSW)))
      SXP) ) ) ) )

(DE SUBSS4 (SXP)
 (COND
  ((SETQ SXP (ASSOC SXP SUB!$SUBL))
   (SETQ !*!*SUBSTW T)
   (COPYL (CDR SXP)) ) ) )

(DE SUBSL3 (SXP) (FOREACH X IN (CDR SXP) REPLACE (SUBSS3 X)))
 
(DE PLUSSUB (SXP)
 (SUBSL3 SXP)
 (COND
  (!*!*SUBSTW (SMPLUSL SXP))
  (T SXP) ) )

(DE TIMESSUB (SXP) (SLET ((A SXP) B)
  (WHILE (AND (UNPUSH A) (NOT (AZEROP (SETQ B (SUBSS3 (CAR A))))))
   (RPLACA A B) )
  (COND
   (A 0)
   (!*!*SUBSTW (SMTIMESL SXP))
   (T SXP) ) ))

(DE EXPTSUB (SXP)
 (SLET (A)
  (COND
   ((SETQ A
     (AND SUBPOT (EXPTSUB1 SXP (CADR SXP) (CADDR SXP) SUB!$SUBL)) )
    A )
   ((AZEROP (SETQ A (SUBSS3 (CADDR SXP)))) 1)
   ((AONEP A) (SUBSS3 (CADR SXP)))
   ((PROGN (RPLACA (CDR SXP) (SUBSS3 (CADR SXP))) !*!*SUBSTW)
    (COLLEX (CADR SXP) A SXP) )
   (T SXP) )))

(DE EXPTSUB1 (SXP BAS EX L)
 (AND L
  (OR
   (AND (EQCAR (CAAR L) 'EXPT) (EQUAL BAS (CADAAR L))
        (EXPTSUB2 SXP BAS EX (CADDR (CAAR L)) (CDAR L)) )
   (EXPTSUB1 SXP BAS EX (CDR L)) ) ) )

(DE EXPTSUB2 (SXP BAS EX TEX SB)
 (COND
  ((OR
    (MINUSP (SETQ EX (SQUOTIENT EX TEX)))
    (AZEROP (SETQ TEX (SFIX EX))) )
   NIL)
  ((AZEROP SB) (SETQ !*!*SUBSTW T) 0)
  (T (SETQ !*!*SUBSTW T)
     (SETQ EX (COND ((NOT (AZEROP (SETQ EX (SFRACTION EX))))
                      (COLLEX BAS EX SXP) )))
     (SETQ BAS (COND
       ((AONEP TEX) (COPYL SB))
       (T (COLLEX (COPYL SB) TEX (COND ((NOT EX) SXP)))) ))
     (COND
      (EX (SMTIMES2 BAS EX))
      (T BAS) ) ) ))

(DE EXPSUB (SXP)
 (SUBSL3 SXP)
 (COND
  (!*!*SUBSTW (XSMEXP (CADR SXP) SXP))
  (T SXP) ) )

(DEFLIST '((PLUS PLUSSUB) (TIMES TIMESSUB) (EXPT EXPTSUB) (EXP EXPSUB))
         'SUBSFN)

(DE DIFSUB (SXP) (SLET ((A (SUBSS3 (CADR SXP)))) (COND
   (!*!*SUBSTW (SMDIFFL A (CDDR SXP) (CAR SXP)))
   (T SXP) )))

(XPUSH DEFDIFLIS!*!* '(SUBSFN . DIFSUB))



(DE REMSUB1 (A)
 (SLET (B C L)
  (SETQ A (GETSL3 A))
  (SETQ L (LENGTH TESULS!*))  
  (WHILE A 
   (COND 
    ((EQ (SETQ B (CAR A)) 'ALL) (REMSULI 1 T))
    ((EQ B 'LAST) (REMSULI (ISUB1 L) NIL))              % Bugfix. JEA.
    ((AND (EQ B 'RECENT) (EQCAR LSBPIK!$ LASUB!*))      % Added case for
     (REMSULI (CADR LSBPIK!$) (CDDR LSBPIK!$)) )        % RECENT. JEA.
    ((NUMBERP B) (REMSULI B NIL))
    ((AND (PAIRP B) (NUMBERP (SETQ C (CAR B))))
     (REMSULI C (COND ((CDR B) (CADR B)) (T T))) ) )
   (UNPUSH A) )
  (DIFFERENCE L (LENGTH (DELQIP NIL TESULS!*))) ))

(DE REMSULI (B C)
 (SLET (K)
  (COND ((ILESSP B 1) (SETQ B 1)))
  (COND 
   ((NULL C) (SETQ C B))
   ((EQ C 'T) (SETQ C (LENGTH TESULS!*))) )
  (COND ((AND (NOT (XILESSP C B)) (SETQ K (CNDR TESULS!* B)))
         (SETQ LSBPIK!$ NIL)      % Fix. JEA.
         (UNTIL (OR (XILESSP C (XIINCR B)) (NULL (UNPUSH K)))
          (RPLACA K NIL) ) )) ))

(DE RMSNUD (A B C M) 
 (COND ((NOT (IGREATERP (CAR A) B))
        (RPLACA A (MAX M (IDIFFERENCE (CAR A) C))) )) )

(DE GETSL3 (L) 
 (SLET (A)
  (COND 
   ((AND L (IDP (SETQ A (CAR L)))
     (NOT (OR (MEMQ A '(LISTS RECENT LAST DIFF TRANSF ALL))
              (GET A 'SUBLOP) (XVTGT A))) )
    (UNPUSH L) )
   (T (SETQ A LASUB!*)) )
  (SETQ TESULS!* (GETSL1 A))
  (SETQ LASUB!* A)
  L) )

(DE GETSL1 (X) (SLET ((A (GETSL2 X)))
  (COND ((NULL A)
         (ERRORFT 501 "%r is not the name of a substitution list" X) ))
  A))

(DE GETSL2 (X)
 (COND
  ((AND (PAIRP (SETQ X (IDVALUE X)))
    (OR (SETQ !$SUPSUB (EQ (CAR X) 'SUBL)) (EQ (CAR X) 'SUBS)) )
   X ) ) )

(DE GETSUL (X) (COPYT (GETSL1 X)))

(DE ISETSUP (SU I NOK DSW L)
 (COND
  ((NULL L) NIL)
  ((NUMBERP (CAR L)) (SETQ I (CAR L)) (UNPUSH L))
  ((OR (NULL (CAR L)) (EQ (CAR L) 'LAST)) (SETQ I NIL) (UNPUSH L)) )
 (SETQ TESULS!*
  (IPUTSUL SU (COND (NOK 'SUBL)) I DSW (COND (L (CONS 'SUBL L)))) )
 (SETQ LASUB!* SU) )

% Some bugfixes in IPUTSUL and PUTSUL to make (MOVSUL subl NIL) work
% also for old substitution lists. Other cases will probably not work.
% JEA.
(DE IPUTSUL (SU NOK I DSW L)
 (SLET ((SL (COND (NOK (GETSL2 SU)) (T (GETSL1 SU)))) SLE)
  (COND ((AND L (EQ (CAR L) 'SUBL)) (CHKSUBL SU (CDR L))))
  (COND
   ((NULL SL) (PUSHQ SUBLISTS!* SU) (SET SU (OR L (NCONS NOK))))
   (T (COND
       (L (COND
           ((NOT (EQ (CAR L) (CAR SL)))
            (COND
             ((AND NOK (OR (NULL (CDR SL)) (AND DSW (AONEP I))))
              (RPLACA SL (CAR L)) )
             (T (SUBTYPER SU (CAR SL))) ) ) )
          (UNPUSH L) ) )
      (COND
       ((AND I (LESSP I (LENGTH SL)) (OR L DSW))
        (SETQ SLE (NTH SL I))           % Bugfix. JEA
        (RPLACD SLE (COND (DSW L) (T (NCONC L (CDR SLE))))) )
       ((AND L I) (NCONC SL L))         % Bugfix(?). JEA
       (T (RPLACD SL L)) ) ) )          % Bugfix(?). JEA
  SL) )

(DE SUBTYPER (SU TSW)
 (ERRORFT 503 "%r is a %w substitution list which is wrong type"
         SU (COND (TSW "super") (T "simple")) ) )

(DE PUTSUL (X Y) (IPUTSUL X 'SUBS NIL T Y))     % Bugfix(?). JEA

(DE XMOVSUL (X L)
 (PUTSUL X (COND
   ((NULL L) (GETSUL LASUB!*))
   ((NULL (CAR L)) NIL)
   (T (GETSUL (CAR L))) ))
 X)

(DE CHKSUBL (NEWSUBL!$ L) (SLET (SEENSUBL!$) (CHKSUBL1 L)))

(DE CHKSUBL1 (L) (COND
  ((PAIRP L) (FOREACH X IN L DO (CHKSUBL1 X)))
  ((MEMQ L SEENSUBL!$) NIL)
  ((PROGN (XPUSH SEENSUBL!$ L) (EQ L NEWSUBL!$))
   (ERRORFT 504
    "Trying to create recursive super substitution list %p" NEWSUBL!$) )
  ((GET L 'SUBLOP) NIL)
  ((PROGN (SETQ L (GETSL1 L)) !$SUPSUB) (CHKSUBL1 (CDR L))) ))

% NEWSUL defines a new substitution list.
% First argument may be a number (of times SETSUB will be used)
% or the name of the new substitution list. If the first
% argument is a number, the second must be the name of the list.
% Further arguments, e.g. (DIFF 2), are accepted and passed
% to SETSUB. SUBLISTS!* is a list of substitution lists defined
% with NEWSUL.
% This function originally written by Jan E. Aman, Univ. of Stockholm
(DE XNEWSUL (L)
 (COND ((OR (NULL L) (NOT (NUMBERP (CAR L)))) (XPUSH L 1)))
 (PUTSUL (CADR L) NIL)
 (XSETNSUB L) )

% SETNSUB reads in multiple substitutions.
% First argument is number of substitutions, rest of
% arguments are passed on to SETSUB.
% This function originally written by Malcolm MacCallum, QMC, London.
(DE XSETNSUB (L) (SLET ((N 1))
  (COND ((NUMBERP (CAR L)) (SETQ N (CAR L)) (UNPUSH L)))
  (SETSUBA1 L)
  (REPEATS N (XSETSUB))
  (SETLSBPIK) ))

(DE XPRSUB (L)
  (SETQ L (GETSL3 L))
  (COND ((NOT (EQCAR L 'LISTS)) (TERPRI) (PRINT LASUB!*)))
  (SETQ !*FPRT NIL)
  (COND 
   ((NULL L) (PRSUEI 1 T))
   (T (FOREACH X IN L DO
       (COND 
        ((EQ X 'ALL) (PRSUEI 1 T))
        ((EQ X 'LAST)
         (PRSUEI (LENGTH (CDR TESULS!*)) NIL))  % Bugfix. JEA.
        ((EQ X 'RECENT)         % Case for RECENT fixed. JEA.
         (COND
          ((EQCAR LSBPIK!$ LASUB!*)
           (PRSUEI (CADR LSBPIK!$) (CDDR LSBPIK!$)) )
          (T (PRSUEI (LENGTH TESULS!*) T)) ))   % Nothing printed. JEA.
        ((EQ X 'LISTS)
         (FOREACH Y IN (REVERSE SUBLISTS!*) DO (PRSUBLIS Y)) )
        ((NUMBERP X) (PRSUEI X NIL))
        ((AND (PAIRP X) (NUMBERP (CAR X)))
         (PRSUEI (CAR X) (COND ((CDR X) (CADR X)) (T T))) ) ) )) ) )

% Print all substitution lists (defined by NEWSUL/USESUL).
% This function originally written by Jan E. Aman, Univ. of Stockholm
(DE PRSUBLISTS NIL (PRSUB LISTS))

(DE PRSUBLIS (LASUB!*)
 (COND ((CDR (SETQ TESULS!* (GETSL1 LASUB!*)))
        (TERPRI) (PRINT LASUB!*) (SETQ !*FPRT NIL) (PRSUEI 1 T)
        (COND
         ((SETQ LASUB!* (GET LASUB!* 'USE))
          (PRINTF "%nUsed when making: %l%n" LASUB!*) NIL ) ) )) )

(DE PRSUEI (X Y) 
  (SETQ X (MAX 1 X))                    % X always number, ensure > 0
  (PRSUE1
    X
    (COND
      ((NUMBERP Y) Y)                   % Arg 2 := Y     -if number,
      (Y (LENGTH (CDR TESULS!*)))       %      length-1  -if Y was T
      (T X) )                           %          X     -if Y = NIL
    (CNDR TESULS!* X) ) )

(DE PRSUE1 (X Y A)
  (WHILE (AND A (NOT (IGREATERP X Y)))
   (COND
    (!$SUPSUB (PRIN1 (CAR A)) (PRIN2 " "))
    (T (PRTLF "%v For %w%b substitute %w" X (CAAR A) (CDAR A))) )
   (IINCR X)
   (UNPUSH A) ) )

(DC SUBS PRT (SUL)
 (SLET ((N 0))
  (CONS "Substitution list"
   (FOREACH X IN (CDR SUL) CONC
    (LIST PNEWLN (XINCR N) " For " (VALUC (CAR X))
          BREAK " substitute " (VALUC (CDR X)) )) ) ) )

(DE SETSUBA1 (A) (SLET (B C)
  (SETQ A (GETSL3 A))
  (COND
   (!$SUPSUB
    (ERRORFT 505 "%r is not a simple substitution list" LASUB!*) ) )
  (SETQ DIFTY!$ (SETQ SUTRAN!$ NIL))
  (SETQ SUDIFOR!$ DIFFORDER!*)
  (SETQ INSNU!$ (LENGTH TESULS!*))
  (WHILE A 
   (COND 
    ((EQ (SETQ B (CAR A)) 'DIFF) (SETQ DIFTY!$ CRDIF!*))
    ((EQ B 'TRANSF) 
     (SETQ SUTRAN!$ (COND
       ((AND (CDR A) (SETQ B (XVTGT (CADR A)))) (SETQ A (CDR A)) B)
       (T (FINVTGT NIL)) ))
     (COND ((NULL DIFTY!$) (SETQ DIFTY!$ CRDIF!*))) )
%    ((EQ B 'LAST) )
%    ((NUMBERP B) )
    ((SETQ C (XVTGT B)) (SETQ DIFTY!$ C))
    ((NOT (PAIRP B)) NIL)
    ((EQ (SETQ C (CAR B)) 'INS)
     (SETQ INSNU!$ (COND ((CDR B) (MAX 1 (CADR B))) (T 1))) )
%    ((NUMBERP C) )
    ((OR (AND (EQ C 'DIFF) (SETQ C CRDIF!*)) (SETQ C (XVTGT C)))
     (SETQ DIFTY!$ C) 
     (COND ((UNPUSH B)
            (COND
             ((FIXP (CAR B))
              (SETQ SUDIFOR!$ (MAX 1 (CAR B)))
              (UNPUSH B) ) )
            (COND
             ((NULL B) NIL)
             ((NOT (EQ (CAR B) 'TRANSF))
              (ERRORFT 502 "Strange SETSUB option %r" (CAR B)) )
             (T (SETQ SUTRAN!$ (FINVTGT B))) ) )) ) )
   (UNPUSH A) )
  (SETQ LSBPIK!$ INSNU!$) ))

(DE XSETSUBL (L)
 (SETSUBA1 L) (XSETSUB) (SETLSBPIK) (LENGTH (CDR TESULS!*)) )

(DE XSETSUB () (PLET ((PSUBS NIL))
  (SLET ((X (FOINPC (LIST 'TXT INSNU!$ "For"))))
   (SETSUBXX X (FOINPC "Substitute ")) ) ))

(DE SETSUBX (AL A B)
 (SETSUBA1 (COND ((OR (NULL AL) (PAIRP AL)) AL) (T (LIST AL))))
 (SETSUBXX A B) )

(DE SETSUBXX (A B)
 (SETQ A (LIST (CONS A B)))
 (COND (DIFTY!$ (SETQ A (DODIFO A))))
 (SETQ B (PNTH TESULS!* INSNU!$))
 (SETQ INSNU!$ (PLUS INSNU!$ (LENGTH A)))
 (RPLACD B (NCONC A (CDR B)))
 A)

(DE SETLSBPIK ()
 (SETQ LSBPIK!$
  (CONS LASUB!* (CONS LSBPIK!$ (ISUB1 INSNU!$))) ) )    % Bugfix. JEA.

% Returns true if commutative type of differentiation
(DE ISCOMUTDIF (DUMMY) NIL)

(DE DODIFO (X) 
 (SLET ((B (VARMLIS DIFTY!$)) (A X) L C D (SDF SUDIFOR!$) (ST SUTRAN!$))
  (WHILE (AND A (NOT (IMINUSP (IDECR SDF))))
   (SETQ L NIL)
   (FOREACH Y IN A DO (FOREACH Z IN B DO
     (COND ((AND
%            (EQCAR (SETQ C (SIDIFC (CAR Y) Z DIFTY!$)) DIFTY!$)
             (OR (EQCAR (SETQ C (SIDIFC (CAR Y) Z DIFTY!$)) DIFTY!$)
                 (EQCAR C 'CONJ) )      % Should be this way. JEA
             (NOT (ASSOC C L))
             (NOT (EQUAL C (SETQ D (COND 
                 (ST (SICHDF (CDR Y) Z DIFTY!$ ST))
                 (T (SIDIFC (CDR Y) Z DIFTY!$)) )))) )
            (XPUSH L (CONS C D)) )) ))
   (COND (ST
          (SETQ ST NIL) 
          (COND ((EQUAL (CAAR X) (CDAR X)) (SETQ X NIL))) ))
   (SETQ X (REVERSEX L X))
   (SETQ A (REVERSIP L)) )
  X) )

%### SUBL1.SL end
