%### DIRFIX.SL

% Due to a bug in VMS PSL version 3.2 current directory must be
% specified for bootstrap or PSL will fail to find files specified
% relative to current directory as e.g. (INCLUDE "../exfn1i.sl").
% This required directory may of course be installation dependent!
% No device is specified here in order to increase the likelyhood that
% things may work unchanged at other installations. Bug gone in
% version 3.2A and this definition will then be suppressed. JEA.

(GLOBAL '(TOPDIR!*))

(FLUID '(CURRENTDIR!*))

% CURRENTDIR!* must be the specification of the current directory
% (where this file is found).
(SETQ CURRENTDIR!* "[sheep.new.slsrc.psl]")

% TOPDIR!* is the directory where the executable images are kept.
% As sslisp.ini is loaded this is used to set up MSEARCHLIS!* to
% look for files in the subdirectorys of this directory.
% TOPDIR!* is also normally used to determine CURRENTDIR!* in Sheep
% and Classi for the implementations that require this.
(SETQ TOPDIR!* "[sheep.new]")

%### DIRFIX.SL end
