%### LDINT.SL =======================================================
%
%       LDINT.SL
%       --------
%
%       Copyright (c) 1993 - 2011 by Jan E. Aman,
%       Department of Physics, Stockholm University,
%       SE-106 91  Stockholm, Sweden.
%
%       This file loads the files into Codemist Standard Lisp (CSL)
%       to build an interpreted Sheep Lisp.
%
%====================================================================

(VERBOS 3)

(RDF "inclde.sl")

(INCLUDE "exfn1.sl")

% Used for testing which system is running.
(SETQ !*RSHEEP NIL)

(INCLUDE "systyp.sl")
(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "printf.sl")
(INCLUDE "load.sl")

% List of extensions searched for:
(SETQ MEXTLIS!* '(PSEUDO!-FILE SL))
(DPUT SLLSPEXT SUBDRS SL)       % Extension for Sheep Lisp sources.
(DPUT SHPSRCEXT SUBDRS SHP)     % Source extension for Sheep.

(PROGN (REMD 'IINCLUDE) NIL)

(SETPROMPTER "SL> ")

% Set TOPDIR!* to be two levels up from current directory. JEA.
(SETQ TOPDIR!* (PREFIXOF (PREFIXOF (GETENV "PWD"))))

% Set up search list. MSEARCHLIS!* is reset in SSLISP.INI. JEA.
(SETQ MSEARCHLIS!* '(NIL HERELIST))
(ADDSUBDIRS (LIST TOPDIR!*)
 '(NIL (("slsrc" LISPSYS)) "slsrc" (("shpsrc" LISPSYS)) "shpsrc") )

%### LDINT.SL end
