%### LDINT.SL =======================================================
%
%       LDINT.SL
%       --------
%
%       Copyright (c) 1989 by Jan E. Aman and Inge Frick, Institute of
%       Theoretical Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46 Stockholm, Sweden.      
%
%       This file contains the essential part of the commands executed
%       in Franz Lisp to build Sheep Lisp.
%
%====================================================================

(setq user!-top!-level 'SLISPTOP)
(makunbound '!*)
(makunbound '!*!*)
(makunbound '!*!*!*)
(makunbound '!+)
(makunbound '!+!+)
(makunbound '!+!+!+)
(allocate 'symbol 30)
(setq !$purcopylits nil)

(INCLUDE "exfn1.sl")

% Used for testing which system is running.
(SETQ !*RSHEEP NIL)

(INCLUDE "systyp.sl")
(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "../prntfi.sl")
(INCLUDE "load.sl")
(INCLUDE "../newnam.sl")

% List of extensions searched for:
(SETQ MEXTLIS!* '(O SL))
(DPUT SLLSPEXT SUBDRS (SL L))   % Extensions for Sheep Lisp sources.
(DPUT SHPSRCEXT SUBDRS (SL SHP))        % Extensions for Sheep sources.

(SETQ MSEARCHLIS!*
 (CONSA NIL 'HERELIST LISPLIBDIR!*) ) % MSEARCHLIS!* set in SSLISP.INI.

(SETQ DATE!* (DATETIME))

(SAVERUN ISLISP)

%### LDINT.SL end
