;### MKSL.L =========================================================
;
;       MKSL.L
;       ------
;
;       Copyright Inge Frick, Institute of Theoretical
;       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
;
;
;       This file contains the commands executed in Franz Lisp to build
;       Sheep Lisp.
;
;====================================================================

(load 'slisp)
(load "reatab.l")
(putd 'load (getd 'Fload))

(setq user!-top!-level 'SLISPTOP)
(makunbound '!*)
(makunbound '!*!*)
(makunbound '!*!*!*)
(makunbound '!+)
(makunbound '!+!+)
(makunbound '!+!+!+)
(allocate 'symbol 30)
(setq piport nil)
(setq poport nil)
(setq !$purcopylits nil)

(fasl "exfn1.o")

% Used for testing which system is running.
(SETQ !*RSHEEP NIL)

(fasl "exint.o")
(fasl "exfn2.o")
(fasl "printf.o")
(fasl "load.o")
(fasl "newnam.o")

% List of extensions searched for:
(SETQ MEXTLIS!* '(O SL))
(DPUT SLLSPEXT SUBDRS (SL L))   % Extensions for Sheep Lisp sources.
(DPUT SHPSRCEXT SUBDRS (SL SHP))        % Extensions for Sheep sources.

(SETQ MSEARCHLIS!*
 (CONSA NIL 'HERELIST LISPLIBDIR!*) ) % MSEARCHLIS!* set in SSLISP.INI.

(SETQ DATE!* (DATETIME))

(SAVERUN SLISP)

%### MKSL.L end
