;### SLMACS.L =======================================================
;
;       SLMACS.L
;       --------
;
;       Copyright (c) 1982 by Inge Frick, Institute of Theoretical
;       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
;
;       This file compiles slmacs.o. It requires slmac1.o.
;       To compile, a number of functions have to be present. For that
;       that reason some files are preloaded.
;
;====================================================================

(include "slmac.l")

(declare (load "slmac1.o"))

(declare
 (terpri)
 (princ "******************************************************")
 (terpri) (princ "Starting to load interpreted versions") (terpri)
 (INCLUDE "exfn1.sl")
 (INCLUDE "exint.sl")
 (INCLUDE "excom.sl")
 (INCLUDE "exfn2.sl")
 (REMFLAG '(CMMACRO DMACRO DS) 'EVAL)
 (INCLUDE "../prntfi.sl")
 (terpri)
 (princ "******************************************************")
 (terpri) (princ "Starting to compile again") (terpri) )

(include "exfn1.sl")

(include "exint.sl")

(include "excom.sl")

(include "exfn2.sl")

(REMFLAG '(CMMACRO DMACRO DS) 'EVAL)

(include "../prntfi.sl")

(include "../newnam.sl")

(include "load.sl")

(REMFLAG '(INCLUDE DSKIN) 'IGNORE)

(sstatus translink nil)

(DOINITFILE "SSLC.INI" "SLC.INI")

(sstatus translink t)

(SETLOADED 'SLMACS)

%### SLMACS.L end
