%### DOS386.SL ======================================================
%
%       DOS386.SL
%       ---------
%
%       This file contains, for IBM PC compatible computers with DOS386
%       (also 486 and Pentium CPUs) some initial adoptions and symbols
%       that are used throughout in the code for SLISP, SHEEP, CLASSI
%       and STENSOR.
%
%       The intial implementation for DOS386 was made by Jim Skea, this
%       file was written by Jan E. Aman.
%
%====================================================================

(GLOBAL '(TOPDIR!*))

(FLUID '(CURRENTDIR!*))

% Installation dependent directory specifications. Change the
% following two specifications, in particular the disk (partition)
% e: to agree with your Atari disk.

% CURRENTDIR!* must be the full specification of the current
% directory (where this file is found).
% Can be installation dependent!

% (SETQ CURRENTDIR!* "c:\sheep\060\slsrc\psl\")

% TOPDIR!* is the directory where sslisp.ini is to be found.
% As sslisp.ini is loaded this is used to set up MSEARCHLIS!* to
% look for files in the subdirectorys of this directory.
% TOPDIR!* is also normally used to determine CURRENTDIR!* in Sheep
% and Classi for the implementations that require this.
% Can be installation dependent!

(SETQ TOPDIR!* "c:\sheep\060\")

% LOADDIRECTORIES!* is where PSL finds its loadable binary module
% like compiler.b, debug.b etc.
% Can be installation dependent!

(SETQ LOADDIRECTORIES!* '("" "c:\reduce\psl\"))

%### DOS386.SL end
