%### EXINT.SL =======================================================
%
%       EXINT.SL
%       --------
%
%       Copyright (c) 1988 by Jan E. Aman and Inge Frick, Institute of
%       Theoretical Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file contains some changes to EXINTI.SL that adapts it to
%       PSL.
%
%====================================================================

(DMACRO XCASE (XC!&CS XC!&D !&REST XC!&L) (SLET ((CNT 0))
  (COND (XC!&D (SETQ XC!&D (NCONS (LIST NIL XC!&D)))))
  (FOREACH X IN XC!&L DO
   (XPUSH XC!&D (LIST (NCONS CNT) X))
   (IINCR CNT) )
  (CONSA 'CASE XC!&CS (REVERSIP XC!&D)) ))

(FLAG '(XCASE) 'LOSE)                   % Defined in the present file.
(FLAG '(ERRSET WHILE) 'LOSE)            % Defined in Bare PSL.
(IFP (MEMQ 'USEFUL OPTIONS!*)           % Defined in PSL Module USEFUL.
 (FLAG '(PROG1) 'LOSE) )

(INCLUDE "../exinti.sl")

(REMFLAG '(XCASE) 'LOSE)                % Defined in the present file.
(REMFLAG '(ERRSET WHILE) 'LOSE)         % Defined in Bare PSL.
(IFP (MEMQ 'USEFUL OPTIONS!*)           % Defined in PSL Module USEFUL.
 (REMFLAG '(PROG1) 'LOSE) )

%### EXINT.SL end
